import { a as ve, b as xe } from "./FocusScope-B-R06ewx.js";
import { a as Ee } from "./useFocusRing-DTBeynF4.js";
import { s as ge, i as he, t as O } from "./useHover-r8IM8mvD.js";
import { j as T, n as I, k as D, l as we, m as De, b as ye, d as Ce, e as Pe, o as L } from "./utils-DPfg4HqB.js";
import m, { useRef as R, useEffect as y, useContext as C, createContext as P, useState as Oe, useMemo as Te, forwardRef as Le } from "react";
import { $ as B } from "./getScrollParent-mRV3mdwj.js";
import { $ as Se } from "./useLabels-vObMberA.js";
import { $ as Ie } from "./useLocalizedStringFormatter-BXegnzqm.js";
import { $ as Re } from "./VisuallyHidden-5Sj7PJLN.js";
import { a as Be } from "./Button-CXfbBbgl.js";
import { a as Me } from "./RSPContexts-EOiWkKOf.js";
import { $ as M } from "./filterDOMProps-D6KHYVBX.js";
import { a as Ae } from "./PressResponder-D58S-mw4.js";
import He from "react-dom";
function ke(e) {
  let { ref: t, onInteractOutside: r, isDisabled: o, onInteractOutsideStart: n } = e, l = R({
    isPointerDown: !1,
    ignoreEmulatedMouseEvents: !1
  }), s = T((a) => {
    r && E(a, t) && (n && n(a), l.current.isPointerDown = !0);
  }), c = T((a) => {
    r && r(a);
  });
  y(() => {
    let a = l.current;
    if (o) return;
    const u = t.current, d = ge(u);
    if (typeof PointerEvent < "u") {
      let f = (b) => {
        a.isPointerDown && E(b, t) && c(b), a.isPointerDown = !1;
      };
      return d.addEventListener("pointerdown", s, !0), d.addEventListener("pointerup", f, !0), () => {
        d.removeEventListener("pointerdown", s, !0), d.removeEventListener("pointerup", f, !0);
      };
    } else {
      let f = (p) => {
        a.ignoreEmulatedMouseEvents ? a.ignoreEmulatedMouseEvents = !1 : a.isPointerDown && E(p, t) && c(p), a.isPointerDown = !1;
      }, b = (p) => {
        a.ignoreEmulatedMouseEvents = !0, a.isPointerDown && E(p, t) && c(p), a.isPointerDown = !1;
      };
      return d.addEventListener("mousedown", s, !0), d.addEventListener("mouseup", f, !0), d.addEventListener("touchstart", s, !0), d.addEventListener("touchend", b, !0), () => {
        d.removeEventListener("mousedown", s, !0), d.removeEventListener("mouseup", f, !0), d.removeEventListener("touchstart", s, !0), d.removeEventListener("touchend", b, !0);
      };
    }
  }, [
    t,
    o,
    s,
    c
  ]);
}
function E(e, t) {
  if (e.button > 0) return !1;
  if (e.target) {
    const r = e.target.ownerDocument;
    if (!r || !r.documentElement.contains(e.target) || e.target.closest("[data-react-aria-top-layer]")) return !1;
  }
  return t.current ? !e.composedPath().includes(t.current) : !1;
}
const $ = [];
function lt(e, t) {
  let { onClose: r, shouldCloseOnBlur: o, isOpen: n, isDismissable: l = !1, isKeyboardDismissDisabled: s = !1, shouldCloseOnInteractOutside: c } = e;
  y(() => {
    if (n && !$.includes(t))
      return $.push(t), () => {
        let i = $.indexOf(t);
        i >= 0 && $.splice(i, 1);
      };
  }, [
    n,
    t
  ]);
  let a = () => {
    $[$.length - 1] === t && r && r();
  }, u = (i) => {
    (!c || c(i.target)) && $[$.length - 1] === t && (i.stopPropagation(), i.preventDefault());
  }, d = (i) => {
    (!c || c(i.target)) && ($[$.length - 1] === t && (i.stopPropagation(), i.preventDefault()), a());
  }, f = (i) => {
    i.key === "Escape" && !s && !i.nativeEvent.isComposing && (i.stopPropagation(), i.preventDefault(), a());
  };
  ke({
    ref: t,
    onInteractOutside: l && n ? d : void 0,
    onInteractOutsideStart: u
  });
  let { focusWithinProps: b } = Ee({
    isDisabled: !o,
    onBlurWithin: (i) => {
      !i.relatedTarget || ve(i.relatedTarget) || (!c || c(i.relatedTarget)) && (r == null || r());
    }
  }), p = (i) => {
    i.target === i.currentTarget && i.preventDefault();
  };
  return {
    overlayProps: {
      onKeyDown: f,
      ...b
    },
    underlayProps: {
      onPointerDown: p
    }
  };
}
const h = typeof document < "u" && window.visualViewport, Fe = /* @__PURE__ */ new Set([
  "checkbox",
  "radio",
  "range",
  "color",
  "file",
  "image",
  "button",
  "submit",
  "reset"
]);
let g = 0, w;
function ct(e = {}) {
  let { isDisabled: t } = e;
  I(() => {
    if (!t)
      return g++, g === 1 && (he() ? w = Ke() : w = We()), () => {
        g--, g === 0 && w();
      };
  }, [
    t
  ]);
}
function We() {
  return D(v(document.documentElement, "paddingRight", `${window.innerWidth - document.documentElement.clientWidth}px`), v(document.documentElement, "overflow", "hidden"));
}
function Ke() {
  let e, t, r = (u) => {
    e = B(u.target, !0), !(e === document.documentElement && e === document.body) && e instanceof HTMLElement && window.getComputedStyle(e).overscrollBehavior === "auto" && (t = v(e, "overscrollBehavior", "contain"));
  }, o = (u) => {
    if (!e || e === document.documentElement || e === document.body) {
      u.preventDefault();
      return;
    }
    e.scrollHeight === e.clientHeight && e.scrollWidth === e.clientWidth && u.preventDefault();
  }, n = () => {
    t && t();
  }, l = (u) => {
    let d = u.target;
    Ne(d) && (c(), d.style.transform = "translateY(-2000px)", requestAnimationFrame(() => {
      d.style.transform = "", h && (h.height < window.innerHeight ? requestAnimationFrame(() => {
        S(d);
      }) : h.addEventListener("resize", () => S(d), {
        once: !0
      }));
    }));
  }, s = null, c = () => {
    if (s) return;
    let u = () => {
      window.scrollTo(0, 0);
    }, d = window.pageXOffset, f = window.pageYOffset;
    s = D(x(window, "scroll", u), v(document.documentElement, "paddingRight", `${window.innerWidth - document.documentElement.clientWidth}px`), v(document.documentElement, "overflow", "hidden"), v(document.body, "marginTop", `-${f}px`), () => {
      window.scrollTo(d, f);
    }), window.scrollTo(0, 0);
  }, a = D(x(document, "touchstart", r, {
    passive: !1,
    capture: !0
  }), x(document, "touchmove", o, {
    passive: !1,
    capture: !0
  }), x(document, "touchend", n, {
    passive: !1,
    capture: !0
  }), x(document, "focus", l, !0));
  return () => {
    t == null || t(), s == null || s(), a();
  };
}
function v(e, t, r) {
  let o = e.style[t];
  return e.style[t] = r, () => {
    e.style[t] = o;
  };
}
function x(e, t, r, o) {
  return e.addEventListener(t, r, o), () => {
    e.removeEventListener(t, r, o);
  };
}
function S(e) {
  let t = document.scrollingElement || document.documentElement, r = e;
  for (; r && r !== t; ) {
    let o = B(r);
    if (o !== document.documentElement && o !== document.body && o !== r) {
      let n = o.getBoundingClientRect().top, l = r.getBoundingClientRect().top;
      l > n + r.clientHeight && (o.scrollTop += l - n);
    }
    r = o.parentElement;
  }
}
function Ne(e) {
  return e instanceof HTMLInputElement && !Fe.has(e.type) || e instanceof HTMLTextAreaElement || e instanceof HTMLElement && e.isContentEditable;
}
var A = {};
A = {
  dismiss: "تجاهل"
};
var H = {};
H = {
  dismiss: "Отхвърляне"
};
var k = {};
k = {
  dismiss: "Odstranit"
};
var F = {};
F = {
  dismiss: "Luk"
};
var W = {};
W = {
  dismiss: "Schließen"
};
var K = {};
K = {
  dismiss: "Απόρριψη"
};
var N = {};
N = {
  dismiss: "Dismiss"
};
var U = {};
U = {
  dismiss: "Descartar"
};
var V = {};
V = {
  dismiss: "Lõpeta"
};
var j = {};
j = {
  dismiss: "Hylkää"
};
var _ = {};
_ = {
  dismiss: "Rejeter"
};
var z = {};
z = {
  dismiss: "התעלם"
};
var Y = {};
Y = {
  dismiss: "Odbaci"
};
var Z = {};
Z = {
  dismiss: "Elutasítás"
};
var q = {};
q = {
  dismiss: "Ignora"
};
var G = {};
G = {
  dismiss: "閉じる"
};
var X = {};
X = {
  dismiss: "무시"
};
var J = {};
J = {
  dismiss: "Atmesti"
};
var Q = {};
Q = {
  dismiss: "Nerādīt"
};
var ee = {};
ee = {
  dismiss: "Lukk"
};
var te = {};
te = {
  dismiss: "Negeren"
};
var re = {};
re = {
  dismiss: "Zignoruj"
};
var oe = {};
oe = {
  dismiss: "Descartar"
};
var ne = {};
ne = {
  dismiss: "Dispensar"
};
var ae = {};
ae = {
  dismiss: "Revocare"
};
var se = {};
se = {
  dismiss: "Пропустить"
};
var ie = {};
ie = {
  dismiss: "Zrušiť"
};
var de = {};
de = {
  dismiss: "Opusti"
};
var le = {};
le = {
  dismiss: "Odbaci"
};
var ce = {};
ce = {
  dismiss: "Avvisa"
};
var ue = {};
ue = {
  dismiss: "Kapat"
};
var fe = {};
fe = {
  dismiss: "Скасувати"
};
var $e = {};
$e = {
  dismiss: "取消"
};
var me = {};
me = {
  dismiss: "關閉"
};
var be = {};
be = {
  "ar-AE": A,
  "bg-BG": H,
  "cs-CZ": k,
  "da-DK": F,
  "de-DE": W,
  "el-GR": K,
  "en-US": N,
  "es-ES": U,
  "et-EE": V,
  "fi-FI": j,
  "fr-FR": _,
  "he-IL": z,
  "hr-HR": Y,
  "hu-HU": Z,
  "it-IT": q,
  "ja-JP": G,
  "ko-KR": X,
  "lt-LT": J,
  "lv-LV": Q,
  "nb-NO": ee,
  "nl-NL": te,
  "pl-PL": re,
  "pt-BR": oe,
  "pt-PT": ne,
  "ro-RO": ae,
  "ru-RU": se,
  "sk-SK": ie,
  "sl-SI": de,
  "sr-SP": le,
  "sv-SE": ce,
  "tr-TR": ue,
  "uk-UA": fe,
  "zh-CN": $e,
  "zh-TW": me
};
function Ue(e) {
  return e && e.__esModule ? e.default : e;
}
function ut(e) {
  let { onDismiss: t, ...r } = e, o = Ie(Ue(be), "@react-aria/overlays"), n = Se(r, o.format("dismiss")), l = () => {
    t && t();
  };
  return /* @__PURE__ */ m.createElement(Re, null, /* @__PURE__ */ m.createElement("button", {
    ...n,
    tabIndex: -1,
    onClick: l,
    style: {
      width: 1,
      height: 1
    }
  }));
}
const Ve = /* @__PURE__ */ P({});
function je() {
  var e;
  return (e = C(Ve)) !== null && e !== void 0 ? e : {};
}
const pe = /* @__PURE__ */ m.createContext(null);
function ft(e) {
  let t = we(), { portalContainer: r = t ? null : document.body, isExiting: o } = e, [n, l] = Oe(!1), s = Te(() => ({
    contain: n,
    setContain: l
  }), [
    n,
    l
  ]), { getContainer: c } = je();
  if (!e.portalContainer && c && (r = c()), !r) return null;
  let a = e.children;
  return e.disableFocusManagement || (a = /* @__PURE__ */ m.createElement(xe, {
    restoreFocus: !0,
    contain: (e.shouldContainFocus || n) && !o
  }, a)), a = /* @__PURE__ */ m.createElement(pe.Provider, {
    value: s
  }, /* @__PURE__ */ m.createElement(Ae, null, a)), /* @__PURE__ */ He.createPortal(a, r);
}
function _e() {
  let e = C(pe), t = e == null ? void 0 : e.setContain;
  I(() => {
    t == null || t(!0);
  }, [
    t
  ]);
}
function ze(e, t) {
  let { role: r = "dialog" } = e, o = De();
  o = e["aria-label"] ? void 0 : o;
  let n = R(!1);
  return y(() => {
    if (t.current && !t.current.contains(document.activeElement)) {
      O(t.current);
      let l = setTimeout(() => {
        document.activeElement === t.current && (n.current = !0, t.current && (t.current.blur(), O(t.current)), n.current = !1);
      }, 500);
      return () => {
        clearTimeout(l);
      };
    }
  }, [
    t
  ]), _e(), {
    dialogProps: {
      ...M(e, {
        labelable: !0
      }),
      role: r,
      tabIndex: -1,
      "aria-labelledby": e["aria-labelledby"] || o,
      // Prevent blur events from reaching useOverlay, which may cause
      // popovers to close. Since focus is contained within the dialog,
      // we don't want this to occur due to the above useEffect.
      onBlur: (l) => {
        n.current && l.stopPropagation();
      }
    },
    titleProps: {
      id: o
    }
  };
}
const Ye = /* @__PURE__ */ P(null), Ze = /* @__PURE__ */ P(null), $t = /* @__PURE__ */ Le(function(t, r) {
  let o = t["aria-labelledby"];
  [t, r] = ye(t, r, Ye);
  let { dialogProps: n, titleProps: l } = ze({
    ...t,
    // Only pass aria-labelledby from props, not context.
    // Context is used as a fallback below.
    "aria-labelledby": o
  }, r), s = C(Ze);
  !n["aria-label"] && !n["aria-labelledby"] && (t["aria-labelledby"] ? n["aria-labelledby"] = t["aria-labelledby"] : console.warn('If a Dialog does not contain a <Heading slot="title">, it must have an aria-label or aria-labelledby attribute for accessibility.'));
  let c = Ce({
    defaultClassName: "react-aria-Dialog",
    className: t.className,
    style: t.style,
    children: t.children,
    values: {
      close: (s == null ? void 0 : s.close) || (() => {
      })
    }
  });
  return /* @__PURE__ */ m.createElement("section", {
    ...M(t),
    ...n,
    ...c,
    ref: r,
    slot: t.slot || void 0
  }, /* @__PURE__ */ m.createElement(Pe, {
    values: [
      [
        Me,
        {
          slots: {
            [L]: {},
            title: {
              ...l,
              level: 2
            }
          }
        }
      ],
      [
        Be,
        {
          slots: {
            [L]: {},
            close: {
              onPress: () => s == null ? void 0 : s.close()
            }
          }
        }
      ]
    ]
  }, c.children));
});
export {
  lt as $,
  ct as a,
  _e as b,
  Ze as c,
  ut as d,
  ft as e,
  $t as f,
  Ye as g
};
