import { G as q, A as P, j as B, w as T, s as $, H as J, k as Y, t as Q, z as _, h as X, I as Z, l as O } from "./useHover-r8IM8mvD.js";
import { n as m } from "./utils-DPfg4HqB.js";
import F, { useRef as g, useContext as ee, useMemo as L, useEffect as H } from "react";
class te {
  get currentNode() {
    return this._currentNode;
  }
  set currentNode(e) {
    if (!P(this.root, e)) throw new Error("Cannot set currentNode to a node that is not contained by the root node.");
    const t = [];
    let n = e, o = e;
    for (this._currentNode = e; n && n !== this.root; ) if (n.nodeType === Node.DOCUMENT_FRAGMENT_NODE) {
      const l = n, i = this._doc.createTreeWalker(l, this.whatToShow, {
        acceptNode: this._acceptNode
      });
      t.push(i), i.currentNode = o, this._currentSetFor.add(i), n = o = l.host;
    } else n = n.parentNode;
    const a = this._doc.createTreeWalker(this.root, this.whatToShow, {
      acceptNode: this._acceptNode
    });
    t.push(a), a.currentNode = o, this._currentSetFor.add(a), this._walkerStack = t;
  }
  get doc() {
    return this._doc;
  }
  firstChild() {
    let e = this.currentNode, t = this.nextNode();
    return P(e, t) ? (t && (this.currentNode = t), t) : (this.currentNode = e, null);
  }
  lastChild() {
    let t = this._walkerStack[0].lastChild();
    return t && (this.currentNode = t), t;
  }
  nextNode() {
    const e = this._walkerStack[0].nextNode();
    if (e) {
      if (e.shadowRoot) {
        var t;
        let o;
        if (typeof this.filter == "function" ? o = this.filter(e) : !((t = this.filter) === null || t === void 0) && t.acceptNode && (o = this.filter.acceptNode(e)), o === NodeFilter.FILTER_ACCEPT)
          return this.currentNode = e, e;
        let a = this.nextNode();
        return a && (this.currentNode = a), a;
      }
      return e && (this.currentNode = e), e;
    } else if (this._walkerStack.length > 1) {
      this._walkerStack.shift();
      let n = this.nextNode();
      return n && (this.currentNode = n), n;
    } else return null;
  }
  previousNode() {
    const e = this._walkerStack[0];
    if (e.currentNode === e.root) {
      if (this._currentSetFor.has(e))
        if (this._currentSetFor.delete(e), this._walkerStack.length > 1) {
          this._walkerStack.shift();
          let o = this.previousNode();
          return o && (this.currentNode = o), o;
        } else return null;
      return null;
    }
    const t = e.previousNode();
    if (t) {
      if (t.shadowRoot) {
        var n;
        let a;
        if (typeof this.filter == "function" ? a = this.filter(t) : !((n = this.filter) === null || n === void 0) && n.acceptNode && (a = this.filter.acceptNode(t)), a === NodeFilter.FILTER_ACCEPT)
          return t && (this.currentNode = t), t;
        let l = this.lastChild();
        return l && (this.currentNode = l), l;
      }
      return t && (this.currentNode = t), t;
    } else if (this._walkerStack.length > 1) {
      this._walkerStack.shift();
      let o = this.previousNode();
      return o && (this.currentNode = o), o;
    } else return null;
  }
  /**
   * @deprecated
   */
  nextSibling() {
    return null;
  }
  /**
   * @deprecated
   */
  previousSibling() {
    return null;
  }
  /**
   * @deprecated
   */
  parentNode() {
    return null;
  }
  constructor(e, t, n, o) {
    this._walkerStack = [], this._currentSetFor = /* @__PURE__ */ new Set(), this._acceptNode = (l) => {
      if (l.nodeType === Node.ELEMENT_NODE) {
        const f = l.shadowRoot;
        if (f) {
          const u = this._doc.createTreeWalker(f, this.whatToShow, {
            acceptNode: this._acceptNode
          });
          return this._walkerStack.unshift(u), NodeFilter.FILTER_ACCEPT;
        } else {
          var i;
          if (typeof this.filter == "function") return this.filter(l);
          if (!((i = this.filter) === null || i === void 0) && i.acceptNode) return this.filter.acceptNode(l);
          if (this.filter === null) return NodeFilter.FILTER_ACCEPT;
        }
      }
      return NodeFilter.FILTER_SKIP;
    }, this._doc = e, this.root = t, this.filter = o ?? null, this.whatToShow = n ?? NodeFilter.SHOW_ALL, this._currentNode = t, this._walkerStack.unshift(e.createTreeWalker(t, n, this._acceptNode));
    const a = t.shadowRoot;
    if (a) {
      const l = this._doc.createTreeWalker(a, this.whatToShow, {
        acceptNode: this._acceptNode
      });
      this._walkerStack.unshift(l);
    }
  }
}
function re(r, e, t, n) {
  return q() ? new te(r, e, t, n) : r.createTreeWalker(e, t, n);
}
function ne(r) {
  const e = B(r);
  if (!(r instanceof e.HTMLElement) && !(r instanceof e.SVGElement)) return !1;
  let { display: t, visibility: n } = r.style, o = t !== "none" && n !== "hidden" && n !== "collapse";
  if (o) {
    const { getComputedStyle: a } = r.ownerDocument.defaultView;
    let { display: l, visibility: i } = a(r);
    o = l !== "none" && i !== "hidden" && i !== "collapse";
  }
  return o;
}
function oe(r, e) {
  return !r.hasAttribute("hidden") && // Ignore HiddenSelect when tree walking.
  !r.hasAttribute("data-react-aria-prevent-focus") && (r.nodeName === "DETAILS" && e && e.nodeName !== "SUMMARY" ? r.hasAttribute("open") : !0);
}
function G(r, e) {
  return r.nodeName !== "#comment" && ne(r) && oe(r, e) && (!r.parentElement || G(r.parentElement, r));
}
const W = /* @__PURE__ */ F.createContext(null), M = "react-aria-focus-scope-restore";
let h = null;
function be(r) {
  let { children: e, contain: t, restoreFocus: n, autoFocus: o } = r, a = g(null), l = g(null), i = g([]), { parentNode: f } = ee(W) || {}, u = L(() => new I({
    scopeRef: i
  }), [
    i
  ]);
  m(() => {
    let s = f || N.root;
    if (N.getTreeNode(s.scopeRef) && h && !R(h, s.scopeRef)) {
      let b = N.getTreeNode(h);
      b && (s = b);
    }
    s.addChild(u), N.addNode(u);
  }, [
    u,
    f
  ]), m(() => {
    let s = N.getTreeNode(i);
    s && (s.contain = !!t);
  }, [
    t
  ]), m(() => {
    var s;
    let b = (s = a.current) === null || s === void 0 ? void 0 : s.nextSibling, v = [], S = (C) => C.stopPropagation();
    for (; b && b !== l.current; )
      v.push(b), b.addEventListener(M, S), b = b.nextSibling;
    return i.current = v, () => {
      for (let C of v) C.removeEventListener(M, S);
    };
  }, [
    e
  ]), ue(i, n, t), ae(i, t), ce(i, n, t), le(i, o), H(() => {
    const s = T($(i.current ? i.current[0] : void 0));
    let b = null;
    if (E(s, i.current)) {
      for (let v of N.traverse()) v.scopeRef && E(s, v.scopeRef.current) && (b = v);
      b === N.getTreeNode(i) && (h = b.scopeRef);
    }
  }, [
    i
  ]), m(() => () => {
    var s, b, v;
    let S = (v = (b = N.getTreeNode(i)) === null || b === void 0 || (s = b.parent) === null || s === void 0 ? void 0 : s.scopeRef) !== null && v !== void 0 ? v : null;
    (i === h || R(i, h)) && (!S || N.getTreeNode(S)) && (h = S), N.removeTreeNode(i);
  }, [
    i
  ]);
  let d = L(() => ie(i), []), c = L(() => ({
    focusManager: d,
    parentNode: u
  }), [
    u,
    d
  ]);
  return /* @__PURE__ */ F.createElement(W.Provider, {
    value: c
  }, /* @__PURE__ */ F.createElement("span", {
    "data-focus-scope-start": !0,
    hidden: !0,
    ref: a
  }), e, /* @__PURE__ */ F.createElement("span", {
    "data-focus-scope-end": !0,
    hidden: !0,
    ref: l
  }));
}
function ie(r) {
  return {
    focusNext(e = {}) {
      let t = r.current, { from: n, tabbable: o, wrap: a, accept: l } = e;
      var i;
      let f = n || T($((i = t[0]) !== null && i !== void 0 ? i : void 0)), u = t[0].previousElementSibling, d = x(t), c = w(d, {
        tabbable: o,
        accept: l
      }, t);
      c.currentNode = E(f, t) ? f : u;
      let s = c.nextNode();
      return !s && a && (c.currentNode = u, s = c.nextNode()), s && p(s, !0), s;
    },
    focusPrevious(e = {}) {
      let t = r.current, { from: n, tabbable: o, wrap: a, accept: l } = e;
      var i;
      let f = n || T($((i = t[0]) !== null && i !== void 0 ? i : void 0)), u = t[t.length - 1].nextElementSibling, d = x(t), c = w(d, {
        tabbable: o,
        accept: l
      }, t);
      c.currentNode = E(f, t) ? f : u;
      let s = c.previousNode();
      return !s && a && (c.currentNode = u, s = c.previousNode()), s && p(s, !0), s;
    },
    focusFirst(e = {}) {
      let t = r.current, { tabbable: n, accept: o } = e, a = x(t), l = w(a, {
        tabbable: n,
        accept: o
      }, t);
      l.currentNode = t[0].previousElementSibling;
      let i = l.nextNode();
      return i && p(i, !0), i;
    },
    focusLast(e = {}) {
      let t = r.current, { tabbable: n, accept: o } = e, a = x(t), l = w(a, {
        tabbable: n,
        accept: o
      }, t);
      l.currentNode = t[t.length - 1].nextElementSibling;
      let i = l.previousNode();
      return i && p(i, !0), i;
    }
  };
}
function x(r) {
  return r[0].parentElement;
}
function y(r) {
  let e = N.getTreeNode(h);
  for (; e && e.scopeRef !== r; ) {
    if (e.contain) return !1;
    e = e.parent;
  }
  return !0;
}
function ae(r, e) {
  let t = g(void 0), n = g(void 0);
  m(() => {
    let o = r.current;
    if (!e) {
      n.current && (cancelAnimationFrame(n.current), n.current = void 0);
      return;
    }
    const a = $(o ? o[0] : void 0);
    let l = (u) => {
      if (u.key !== "Tab" || u.altKey || u.ctrlKey || u.metaKey || !y(r) || u.isComposing) return;
      let d = T(a), c = r.current;
      if (!c || !E(d, c)) return;
      let s = x(c), b = w(s, {
        tabbable: !0
      }, c);
      if (!d) return;
      b.currentNode = d;
      let v = u.shiftKey ? b.previousNode() : b.nextNode();
      v || (b.currentNode = u.shiftKey ? c[c.length - 1].nextElementSibling : c[0].previousElementSibling, v = u.shiftKey ? b.previousNode() : b.nextNode()), u.preventDefault(), v && p(v, !0);
    }, i = (u) => {
      (!h || R(h, r)) && E(_(u), r.current) ? (h = r, t.current = _(u)) : y(r) && !k(_(u), r) ? t.current ? t.current.focus() : h && h.current && D(h.current) : y(r) && (t.current = _(u));
    }, f = (u) => {
      n.current && cancelAnimationFrame(n.current), n.current = requestAnimationFrame(() => {
        let d = O(), c = (d === "virtual" || d === null) && X() && Z(), s = T(a);
        if (!c && s && y(r) && !k(s, r)) {
          h = r;
          let v = _(u);
          if (v && v.isConnected) {
            var b;
            t.current = v, (b = t.current) === null || b === void 0 || b.focus();
          } else h.current && D(h.current);
        }
      });
    };
    return a.addEventListener("keydown", l, !1), a.addEventListener("focusin", i, !1), o == null || o.forEach((u) => u.addEventListener("focusin", i, !1)), o == null || o.forEach((u) => u.addEventListener("focusout", f, !1)), () => {
      a.removeEventListener("keydown", l, !1), a.removeEventListener("focusin", i, !1), o == null || o.forEach((u) => u.removeEventListener("focusin", i, !1)), o == null || o.forEach((u) => u.removeEventListener("focusout", f, !1));
    };
  }, [
    r,
    e
  ]), m(() => () => {
    n.current && cancelAnimationFrame(n.current);
  }, [
    n
  ]);
}
function U(r) {
  return k(r);
}
function E(r, e) {
  return !r || !e ? !1 : e.some((t) => t.contains(r));
}
function k(r, e = null) {
  if (r instanceof Element && r.closest("[data-react-aria-top-layer]")) return !0;
  for (let { scopeRef: t } of N.traverse(N.getTreeNode(e)))
    if (t && E(r, t.current)) return !0;
  return !1;
}
function he(r) {
  return k(r, h);
}
function R(r, e) {
  var t;
  let n = (t = N.getTreeNode(e)) === null || t === void 0 ? void 0 : t.parent;
  for (; n; ) {
    if (n.scopeRef === r) return !0;
    n = n.parent;
  }
  return !1;
}
function p(r, e = !1) {
  if (r != null && !e) try {
    Q(r);
  } catch {
  }
  else if (r != null) try {
    r.focus();
  } catch {
  }
}
function j(r, e = !0) {
  let t = r[0].previousElementSibling, n = x(r), o = w(n, {
    tabbable: e
  }, r);
  o.currentNode = t;
  let a = o.nextNode();
  return e && !a && (n = x(r), o = w(n, {
    tabbable: !1
  }, r), o.currentNode = t, a = o.nextNode()), a;
}
function D(r, e = !0) {
  p(j(r, e));
}
function le(r, e) {
  const t = F.useRef(e);
  H(() => {
    if (t.current) {
      h = r;
      const n = $(r.current ? r.current[0] : void 0);
      !E(T(n), h.current) && r.current && D(r.current);
    }
    t.current = !1;
  }, [
    r
  ]);
}
function ue(r, e, t) {
  m(() => {
    if (e || t) return;
    let n = r.current;
    const o = $(n ? n[0] : void 0);
    let a = (l) => {
      let i = _(l);
      E(i, r.current) ? h = r : U(i) || (h = null);
    };
    return o.addEventListener("focusin", a, !1), n == null || n.forEach((l) => l.addEventListener("focusin", a, !1)), () => {
      o.removeEventListener("focusin", a, !1), n == null || n.forEach((l) => l.removeEventListener("focusin", a, !1));
    };
  }, [
    r,
    e,
    t
  ]);
}
function V(r) {
  let e = N.getTreeNode(h);
  for (; e && e.scopeRef !== r; ) {
    if (e.nodeToRestore) return !1;
    e = e.parent;
  }
  return (e == null ? void 0 : e.scopeRef) === r;
}
function ce(r, e, t) {
  const n = g(typeof document < "u" ? T($(r.current ? r.current[0] : void 0)) : null);
  m(() => {
    let o = r.current;
    const a = $(o ? o[0] : void 0);
    if (!e || t) return;
    let l = () => {
      (!h || R(h, r)) && E(T(a), r.current) && (h = r);
    };
    return a.addEventListener("focusin", l, !1), o == null || o.forEach((i) => i.addEventListener("focusin", l, !1)), () => {
      a.removeEventListener("focusin", l, !1), o == null || o.forEach((i) => i.removeEventListener("focusin", l, !1));
    };
  }, [
    r,
    t
  ]), m(() => {
    const o = $(r.current ? r.current[0] : void 0);
    if (!e) return;
    let a = (l) => {
      if (l.key !== "Tab" || l.altKey || l.ctrlKey || l.metaKey || !y(r) || l.isComposing) return;
      let i = o.activeElement;
      if (!k(i, r) || !V(r)) return;
      let f = N.getTreeNode(r);
      if (!f) return;
      let u = f.nodeToRestore, d = w(o.body, {
        tabbable: !0
      });
      d.currentNode = i;
      let c = l.shiftKey ? d.previousNode() : d.nextNode();
      if ((!u || !u.isConnected || u === o.body) && (u = void 0, f.nodeToRestore = void 0), (!c || !k(c, r)) && u) {
        d.currentNode = u;
        do
          c = l.shiftKey ? d.previousNode() : d.nextNode();
        while (k(c, r));
        l.preventDefault(), l.stopPropagation(), c ? p(c, !0) : U(u) ? p(u, !0) : i.blur();
      }
    };
    return t || o.addEventListener("keydown", a, !0), () => {
      t || o.removeEventListener("keydown", a, !0);
    };
  }, [
    r,
    e,
    t
  ]), m(() => {
    const o = $(r.current ? r.current[0] : void 0);
    if (!e) return;
    let a = N.getTreeNode(r);
    if (a) {
      var l;
      return a.nodeToRestore = (l = n.current) !== null && l !== void 0 ? l : void 0, () => {
        let i = N.getTreeNode(r);
        if (!i) return;
        let f = i.nodeToRestore, u = T(o);
        if (e && f && (u && k(u, r) || u === o.body && V(r))) {
          let d = N.clone();
          requestAnimationFrame(() => {
            if (o.activeElement === o.body) {
              let c = d.getTreeNode(r);
              for (; c; ) {
                if (c.nodeToRestore && c.nodeToRestore.isConnected) {
                  z(c.nodeToRestore);
                  return;
                }
                c = c.parent;
              }
              for (c = d.getTreeNode(r); c; ) {
                if (c.scopeRef && c.scopeRef.current && N.getTreeNode(c.scopeRef)) {
                  let s = j(c.scopeRef.current, !0);
                  z(s);
                  return;
                }
                c = c.parent;
              }
            }
          });
        }
      };
    }
  }, [
    r,
    e
  ]);
}
function z(r) {
  r.dispatchEvent(new CustomEvent(M, {
    bubbles: !0,
    cancelable: !0
  })) && p(r);
}
function w(r, e, t) {
  let n = e != null && e.tabbable ? J : Y, o = (r == null ? void 0 : r.nodeType) === Node.ELEMENT_NODE ? r : null, a = $(o), l = re(a, r || a, NodeFilter.SHOW_ELEMENT, {
    acceptNode(i) {
      var f;
      return !(e == null || (f = e.from) === null || f === void 0) && f.contains(i) ? NodeFilter.FILTER_REJECT : n(i) && G(i) && (!t || E(i, t)) && (!(e != null && e.accept) || e.accept(i)) ? NodeFilter.FILTER_ACCEPT : NodeFilter.FILTER_SKIP;
    }
  });
  return e != null && e.from && (l.currentNode = e.from), l;
}
function ve(r, e = {}) {
  return {
    focusNext(t = {}) {
      let n = r.current;
      if (!n) return null;
      let { from: o, tabbable: a = e.tabbable, wrap: l = e.wrap, accept: i = e.accept } = t, f = o || T($(n)), u = w(n, {
        tabbable: a,
        accept: i
      });
      n.contains(f) && (u.currentNode = f);
      let d = u.nextNode();
      return !d && l && (u.currentNode = n, d = u.nextNode()), d && p(d, !0), d;
    },
    focusPrevious(t = e) {
      let n = r.current;
      if (!n) return null;
      let { from: o, tabbable: a = e.tabbable, wrap: l = e.wrap, accept: i = e.accept } = t, f = o || T($(n)), u = w(n, {
        tabbable: a,
        accept: i
      });
      if (n.contains(f)) u.currentNode = f;
      else {
        let c = A(u);
        return c && p(c, !0), c ?? null;
      }
      let d = u.previousNode();
      if (!d && l) {
        u.currentNode = n;
        let c = A(u);
        if (!c)
          return null;
        d = c;
      }
      return d && p(d, !0), d ?? null;
    },
    focusFirst(t = e) {
      let n = r.current;
      if (!n) return null;
      let { tabbable: o = e.tabbable, accept: a = e.accept } = t, i = w(n, {
        tabbable: o,
        accept: a
      }).nextNode();
      return i && p(i, !0), i;
    },
    focusLast(t = e) {
      let n = r.current;
      if (!n) return null;
      let { tabbable: o = e.tabbable, accept: a = e.accept } = t, l = w(n, {
        tabbable: o,
        accept: a
      }), i = A(l);
      return i && p(i, !0), i ?? null;
    }
  };
}
function A(r) {
  let e, t;
  do
    t = r.lastChild(), t && (e = t);
  while (t);
  return e;
}
class K {
  get size() {
    return this.fastMap.size;
  }
  getTreeNode(e) {
    return this.fastMap.get(e);
  }
  addTreeNode(e, t, n) {
    let o = this.fastMap.get(t ?? null);
    if (!o) return;
    let a = new I({
      scopeRef: e
    });
    o.addChild(a), a.parent = o, this.fastMap.set(e, a), n && (a.nodeToRestore = n);
  }
  addNode(e) {
    this.fastMap.set(e.scopeRef, e);
  }
  removeTreeNode(e) {
    if (e === null) return;
    let t = this.fastMap.get(e);
    if (!t) return;
    let n = t.parent;
    for (let a of this.traverse()) a !== t && t.nodeToRestore && a.nodeToRestore && t.scopeRef && t.scopeRef.current && E(a.nodeToRestore, t.scopeRef.current) && (a.nodeToRestore = t.nodeToRestore);
    let o = t.children;
    n && (n.removeChild(t), o.size > 0 && o.forEach((a) => n && n.addChild(a))), this.fastMap.delete(t.scopeRef);
  }
  // Pre Order Depth First
  *traverse(e = this.root) {
    if (e.scopeRef != null && (yield e), e.children.size > 0) for (let t of e.children) yield* this.traverse(t);
  }
  clone() {
    var e;
    let t = new K();
    var n;
    for (let o of this.traverse()) t.addTreeNode(o.scopeRef, (n = (e = o.parent) === null || e === void 0 ? void 0 : e.scopeRef) !== null && n !== void 0 ? n : null, o.nodeToRestore);
    return t;
  }
  constructor() {
    this.fastMap = /* @__PURE__ */ new Map(), this.root = new I({
      scopeRef: null
    }), this.fastMap.set(null, this.root);
  }
}
class I {
  addChild(e) {
    this.children.add(e), e.parent = this;
  }
  removeChild(e) {
    this.children.delete(e), e.parent = void 0;
  }
  constructor(e) {
    this.children = /* @__PURE__ */ new Set(), this.contain = !1, this.scopeRef = e.scopeRef;
  }
}
let N = new K();
export {
  w as $,
  he as a,
  be as b,
  ve as c
};
