import { j as ce, $ as ue, b as fe, c as $e, d as be, e as R, k as pe } from "./Collection-CYEl0MHQ.js";
import { a as oe, $ as B, m as Y, k as ve, b as ge, c as j, d as L, e as te, o as me, i as he, g as Pe } from "./utils-DPfg4HqB.js";
import d, { createContext as k, useCallback as De, forwardRef as q, useMemo as H, useContext as m, useEffect as ae, useRef as W } from "react";
import { a as xe } from "./Text-NEUq4Wl7.js";
import { $ as U } from "./filterDOMProps-D6KHYVBX.js";
import { $ as ye } from "./usePress-BKP_smFB.js";
import { u as Se, r as Fe, a as le, m as Z } from "./useHover-r8IM8mvD.js";
import { a as ke, $ as we } from "./useFocusRing-DTBeynF4.js";
import { $ as Ve } from "./useLabel-Q5o-912H.js";
import { a as Ie, $ as Ee } from "./useSelectableList-CKfXeGoq.js";
import { $ as Be, a as Me } from "./useListState-D42GzxiD.js";
import { $ as Te } from "./context-DRz_xlLl.js";
import { $ as Ce } from "./useCollator-UGgeWRRW.js";
import { b as _e } from "./FocusScope-B-R06ewx.js";
const G = /* @__PURE__ */ new WeakMap();
function He(o) {
  return typeof o == "string" ? o.replace(/\s*/g, "") : "" + o;
}
function Le(o, e) {
  let a = G.get(o);
  if (!a) throw new Error("Unknown list");
  return `${a.id}-option-${He(e)}`;
}
function Ue(o, e, a) {
  let l = U(o, {
    labelable: !0
  }), r = o.selectionBehavior || "toggle", i = o.linkBehavior || (r === "replace" ? "action" : "override");
  r === "toggle" && i === "action" && (i = "override");
  let { listProps: t } = Ie({
    ...o,
    ref: a,
    selectionManager: e.selectionManager,
    collection: e.collection,
    disabledKeys: e.disabledKeys,
    linkBehavior: i
  }), { focusWithinProps: n } = ke({
    onFocusWithin: o.onFocus,
    onBlurWithin: o.onBlur,
    onFocusWithinChange: o.onFocusChange
  }), c = oe(o.id);
  G.set(e, {
    id: c,
    shouldUseVirtualFocus: o.shouldUseVirtualFocus,
    shouldSelectOnPressUp: o.shouldSelectOnPressUp,
    shouldFocusOnHover: o.shouldFocusOnHover,
    isVirtualized: o.isVirtualized,
    onAction: o.onAction,
    linkBehavior: i
  });
  let { labelProps: $, fieldProps: u } = Ve({
    ...o,
    id: c,
    // listbox is not an HTML input element so it
    // shouldn't be labeled by a <label> element.
    labelElementType: "span"
  });
  return {
    labelProps: $,
    listBoxProps: B(l, n, e.selectionManager.selectionMode === "multiple" ? {
      "aria-multiselectable": "true"
    } : {}, {
      role: "listbox",
      ...B(u, t)
    })
  };
}
const ee = /* @__PURE__ */ new WeakMap();
function Oe(o) {
  let e = ee.get(o);
  if (e != null) return e;
  let a = 0, l = (r) => {
    for (let i of r) i.type === "section" ? l(ce(i, o)) : a++;
  };
  return l(o), ee.set(o, a), a;
}
function ze(o, e, a) {
  var l, r;
  let { key: i } = o, t = G.get(e);
  var n;
  let c = (n = o.isDisabled) !== null && n !== void 0 ? n : e.selectionManager.isDisabled(i);
  var $;
  let u = ($ = o.isSelected) !== null && $ !== void 0 ? $ : e.selectionManager.isSelected(i);
  var p;
  let s = (p = o.shouldSelectOnPressUp) !== null && p !== void 0 ? p : t == null ? void 0 : t.shouldSelectOnPressUp;
  var v;
  let h = (v = o.shouldFocusOnHover) !== null && v !== void 0 ? v : t == null ? void 0 : t.shouldFocusOnHover;
  var g;
  let b = (g = o.shouldUseVirtualFocus) !== null && g !== void 0 ? g : t == null ? void 0 : t.shouldUseVirtualFocus;
  var P;
  let S = (P = o.isVirtualized) !== null && P !== void 0 ? P : t == null ? void 0 : t.isVirtualized, F = Y(), M = Y(), y = {
    role: "option",
    "aria-disabled": c || void 0,
    "aria-selected": e.selectionManager.selectionMode !== "none" ? u : void 0
  };
  Se() && Fe() || (y["aria-label"] = o["aria-label"], y["aria-labelledby"] = F, y["aria-describedby"] = M);
  let f = e.collection.getItem(i);
  if (S) {
    let x = Number(f == null ? void 0 : f.index);
    y["aria-posinset"] = Number.isNaN(x) ? void 0 : x + 1, y["aria-setsize"] = Oe(e.collection);
  }
  let T = t != null && t.onAction ? () => {
    var x;
    return t == null || (x = t.onAction) === null || x === void 0 ? void 0 : x.call(t, i);
  } : void 0, C = Le(e, i), { itemProps: A, isPressed: V, isFocused: D, hasAction: w, allowsSelection: I } = ue({
    selectionManager: e.selectionManager,
    key: i,
    ref: a,
    shouldSelectOnPressUp: s,
    allowsDifferentPressOrigin: s && h,
    isVirtualized: S,
    shouldUseVirtualFocus: b,
    isDisabled: c,
    onAction: T || !(f == null || (l = f.props) === null || l === void 0) && l.onAction ? ve(f == null || (r = f.props) === null || r === void 0 ? void 0 : r.onAction, T) : void 0,
    linkBehavior: t == null ? void 0 : t.linkBehavior,
    id: C
  }), { hoverProps: _ } = le({
    isDisabled: c || !h,
    onHoverStart() {
      Z() || (e.selectionManager.setFocused(!0), e.selectionManager.setFocusedKey(i));
    }
  }), E = U(f == null ? void 0 : f.props);
  delete E.id;
  let N = ye(f == null ? void 0 : f.props);
  return {
    optionProps: {
      ...y,
      ...B(E, A, _, N),
      id: C
    },
    labelProps: {
      id: F
    },
    descriptionProps: {
      id: M
    },
    isFocused: D,
    isFocusVisible: D && e.selectionManager.isFocused && Z(),
    isSelected: u,
    isDisabled: c,
    isPressed: V,
    allowsSelection: I,
    hasAction: w
  };
}
function Ae(o) {
  let { heading: e, "aria-label": a } = o, l = oe();
  return {
    itemProps: {
      role: "presentation"
    },
    headingProps: e ? {
      // Techincally, listbox cannot contain headings according to ARIA.
      // We hide the heading from assistive technology, using role="presentation",
      // and only use it as a visual label for the nested group.
      id: l,
      role: "presentation"
    } : {},
    groupProps: {
      role: "group",
      "aria-label": a,
      "aria-labelledby": e ? l : void 0
    }
  };
}
const Ne = /* @__PURE__ */ k(null), O = /* @__PURE__ */ k({}), ie = /* @__PURE__ */ k(null), Ke = /* @__PURE__ */ q(function(e, a) {
  let { render: l } = m(ie);
  return /* @__PURE__ */ d.createElement(d.Fragment, null, l(e, a));
});
function re(o, e) {
  var a;
  let l = o == null ? void 0 : o.renderDropIndicator, r = o == null || (a = o.isVirtualDragging) === null || a === void 0 ? void 0 : a.call(o), i = De((t) => {
    if (r || e != null && e.isDropTarget(t)) return l ? l(t) : /* @__PURE__ */ d.createElement(Ke, {
      target: t
    });
  }, [
    e == null ? void 0 : e.target,
    r,
    l
  ]);
  return o != null && o.useDropIndicator ? i : void 0;
}
function We(o, e, a) {
  var l, r;
  let i = o.focusedKey, t = null;
  if (!(e == null || (l = e.isVirtualDragging) === null || l === void 0) && l.call(e) && (a == null || (r = a.target) === null || r === void 0 ? void 0 : r.type) === "item") {
    t = a.target.key;
    var n;
    a.target.dropPosition === "after" && (t = (n = a.collection.getKeyAfter(t)) !== null && n !== void 0 ? n : t);
  }
  return H(() => new Set([
    i,
    t
  ].filter((c) => c != null)), [
    i,
    t
  ]);
}
const Re = /* @__PURE__ */ k({}), je = /* @__PURE__ */ k({}), ne = /* @__PURE__ */ k(null), z = /* @__PURE__ */ k(null), $o = /* @__PURE__ */ q(function(e, a) {
  [e, a] = ge(e, a, ne);
  let l = m(z);
  return l ? /* @__PURE__ */ d.createElement(de, {
    state: l,
    props: e,
    listBoxRef: a
  }) : /* @__PURE__ */ d.createElement($e, {
    content: /* @__PURE__ */ d.createElement(be, e)
  }, (r) => /* @__PURE__ */ d.createElement(qe, {
    props: e,
    listBoxRef: a,
    collection: r
  }));
});
function qe({ props: o, listBoxRef: e, collection: a }) {
  o = {
    ...o,
    collection: a,
    children: null,
    items: null
  };
  let { layoutDelegate: l } = m(R), r = Me({
    ...o,
    layoutDelegate: l
  });
  return /* @__PURE__ */ d.createElement(de, {
    state: r,
    props: o,
    listBoxRef: e
  });
}
function de({ state: o, props: e, listBoxRef: a }) {
  let { filter: l, collectionProps: r, collectionRef: i } = m(Ne) || {};
  e = H(() => r ? {
    ...e,
    ...r
  } : e, [
    e,
    r
  ]);
  let { dragAndDropHooks: t, layout: n = "stack", orientation: c = "vertical" } = e;
  a = j(H(() => he(a, i !== void 0 ? i : null), [
    i,
    a
  ]));
  let $ = Be(o, l), { collection: u, selectionManager: p } = $, s = !!(t != null && t.useDraggableCollectionState), v = !!(t != null && t.useDroppableCollectionState), { direction: h } = Te(), { disabledBehavior: g, disabledKeys: b } = p, P = Ce({
    usage: "search",
    sensitivity: "base"
  }), { isVirtualized: S, layoutDelegate: F, dropTargetDelegate: M, CollectionRoot: y } = m(R), f = H(() => e.keyboardDelegate || new Ee({
    collection: u,
    collator: P,
    ref: a,
    disabledKeys: b,
    disabledBehavior: g,
    layout: n,
    orientation: c,
    direction: h,
    layoutDelegate: F
  }), [
    u,
    P,
    a,
    g,
    b,
    c,
    h,
    e.keyboardDelegate,
    n,
    F
  ]), { listBoxProps: T } = Ue({
    ...e,
    shouldSelectOnPressUp: s || e.shouldSelectOnPressUp,
    keyboardDelegate: f,
    isVirtualized: S
  }, $, a), C = W(s), A = W(v);
  ae(() => {
    C.current !== s && console.warn("Drag hooks were provided during one render, but not another. This should be avoided as it may produce unexpected behavior."), A.current !== v && console.warn("Drop hooks were provided during one render, but not another. This should be avoided as it may produce unexpected behavior.");
  }, [
    s,
    v
  ]);
  let V, D, w, I = !1, _ = null, E = W(null);
  if (s && t) {
    V = t.useDraggableCollectionState({
      collection: u,
      selectionManager: p,
      preview: t.renderDragPreview ? E : void 0
    }), t.useDraggableCollection({}, V, a);
    let K = t.DragPreview;
    _ = t.renderDragPreview ? /* @__PURE__ */ d.createElement(K, {
      ref: E
    }, t.renderDragPreview) : null;
  }
  if (v && t) {
    D = t.useDroppableCollectionState({
      collection: u,
      selectionManager: p
    });
    let K = t.dropTargetDelegate || M || new t.ListDropTargetDelegate(u, a, {
      orientation: c,
      layout: n,
      direction: h
    });
    w = t.useDroppableCollection({
      keyboardDelegate: f,
      dropTargetDelegate: K
    }, D, a), I = D.isDropTarget({
      type: "root"
    });
  }
  let { focusProps: N, isFocused: x, isFocusVisible: J } = we(), Q = {
    isDropTarget: I,
    isEmpty: $.collection.size === 0,
    isFocused: x,
    isFocusVisible: J,
    layout: e.layout || "stack",
    state: $
  }, se = L({
    className: e.className,
    style: e.style,
    defaultClassName: "react-aria-ListBox",
    values: Q
  }), X = null;
  return $.collection.size === 0 && e.renderEmptyState && (X = /* @__PURE__ */ d.createElement("div", {
    // eslint-disable-next-line
    role: "option",
    style: {
      display: "contents"
    }
  }, e.renderEmptyState(Q))), /* @__PURE__ */ d.createElement(_e, null, /* @__PURE__ */ d.createElement("div", {
    ...U(e),
    ...B(T, N, w == null ? void 0 : w.collectionProps),
    ...se,
    ref: a,
    slot: e.slot || void 0,
    onScroll: e.onScroll,
    "data-drop-target": I || void 0,
    "data-empty": $.collection.size === 0 || void 0,
    "data-focused": x || void 0,
    "data-focus-visible": J || void 0,
    "data-layout": e.layout || "stack",
    "data-orientation": e.orientation || "vertical"
  }, /* @__PURE__ */ d.createElement(te, {
    values: [
      [
        ne,
        e
      ],
      [
        z,
        $
      ],
      [
        O,
        {
          dragAndDropHooks: t,
          dragState: V,
          dropState: D
        }
      ],
      [
        je,
        {
          elementType: "div"
        }
      ],
      [
        ie,
        {
          render: Je
        }
      ],
      [
        pe,
        {
          name: "ListBoxSection",
          render: Ge
        }
      ]
    ]
  }, /* @__PURE__ */ d.createElement(y, {
    collection: u,
    scrollRef: a,
    persistedKeys: We(p, t, D),
    renderDropIndicator: re(t, D)
  })), X, _));
}
function Ge(o, e, a, l = "react-aria-ListBoxSection") {
  let r = m(z), { dragAndDropHooks: i, dropState: t } = m(O), { CollectionBranch: n } = m(R), [c, $] = Pe();
  var u;
  let { headingProps: p, groupProps: s } = Ae({
    heading: $,
    "aria-label": (u = o["aria-label"]) !== null && u !== void 0 ? u : void 0
  }), v = L({
    defaultClassName: l,
    className: o.className,
    style: o.style,
    values: {}
  });
  return /* @__PURE__ */ d.createElement("section", {
    ...U(o),
    ...s,
    ...v,
    ref: e
  }, /* @__PURE__ */ d.createElement(Re.Provider, {
    value: {
      ...p,
      ref: c
    }
  }, /* @__PURE__ */ d.createElement(n, {
    collection: r.collection,
    parent: a,
    renderDropIndicator: re(i, t)
  })));
}
const bo = /* @__PURE__ */ fe("item", function(e, a, l) {
  let r = j(a), i = m(z), { dragAndDropHooks: t, dragState: n, dropState: c } = m(O), { optionProps: $, labelProps: u, descriptionProps: p, ...s } = ze({
    key: l.key,
    "aria-label": e == null ? void 0 : e["aria-label"]
  }, i, r), { hoverProps: v, isHovered: h } = le({
    isDisabled: !s.allowsSelection && !s.hasAction,
    onHoverStart: l.props.onHoverStart,
    onHoverChange: l.props.onHoverChange,
    onHoverEnd: l.props.onHoverEnd
  }), g = null;
  n && t && (g = t.useDraggableItem({
    key: l.key
  }, n));
  let b = null;
  c && t && (b = t.useDroppableItem({
    target: {
      type: "item",
      key: l.key,
      dropPosition: "on"
    }
  }, c, r));
  let P = n && n.isDragging(l.key), S = L({
    ...e,
    id: void 0,
    children: e.children,
    defaultClassName: "react-aria-ListBoxItem",
    values: {
      ...s,
      isHovered: h,
      selectionMode: i.selectionManager.selectionMode,
      selectionBehavior: i.selectionManager.selectionBehavior,
      allowsDragging: !!n,
      isDragging: P,
      isDropTarget: b == null ? void 0 : b.isDropTarget
    }
  });
  ae(() => {
    l.textValue || console.warn("A `textValue` prop is required for <ListBoxItem> elements with non-plain text children in order to support accessibility features such as type to select.");
  }, [
    l.textValue
  ]);
  let F = e.href ? "a" : "div";
  return /* @__PURE__ */ d.createElement(F, {
    ...B($, v, g == null ? void 0 : g.dragProps, b == null ? void 0 : b.dropProps),
    ...S,
    ref: r,
    "data-allows-dragging": !!n || void 0,
    "data-selected": s.isSelected || void 0,
    "data-disabled": s.isDisabled || void 0,
    "data-hovered": h || void 0,
    "data-focused": s.isFocused || void 0,
    "data-focus-visible": s.isFocusVisible || void 0,
    "data-pressed": s.isPressed || void 0,
    "data-dragging": P || void 0,
    "data-drop-target": (b == null ? void 0 : b.isDropTarget) || void 0,
    "data-selection-mode": i.selectionManager.selectionMode === "none" ? void 0 : i.selectionManager.selectionMode
  }, /* @__PURE__ */ d.createElement(te, {
    values: [
      [
        xe,
        {
          slots: {
            [me]: u,
            label: u,
            description: p
          }
        }
      ]
    ]
  }, S.children));
});
function Je(o, e) {
  e = j(e);
  let { dragAndDropHooks: a, dropState: l } = m(O), { dropIndicatorProps: r, isHidden: i, isDropTarget: t } = a.useDropIndicator(o, l, e);
  return i ? null : /* @__PURE__ */ d.createElement(Xe, {
    ...o,
    dropIndicatorProps: r,
    isDropTarget: t,
    ref: e
  });
}
function Qe(o, e) {
  let { dropIndicatorProps: a, isDropTarget: l, ...r } = o, i = L({
    ...r,
    defaultClassName: "react-aria-DropIndicator",
    values: {
      isDropTarget: l
    }
  });
  return /* @__PURE__ */ d.createElement("div", {
    ...a,
    ...i,
    // eslint-disable-next-line
    role: "option",
    ref: e,
    "data-drop-target": l || void 0
  });
}
const Xe = /* @__PURE__ */ q(Qe);
export {
  $o as $,
  bo as a,
  ne as b,
  z as c
};
