import { r as ce } from "./useHover-r8IM8mvD.js";
import { a as U } from "./number-CUyhRgxf.js";
import de, { useEffect as J, useState as fe, useRef as K, useCallback as Q, forwardRef as pe, createContext as ue } from "react";
import { n as G, b as me, d as ve } from "./utils-DPfg4HqB.js";
import { $ as ge } from "./context-DRz_xlLl.js";
function $e() {
  return typeof window.ResizeObserver < "u";
}
function W(t) {
  const { ref: e, box: r, onResize: l } = t;
  J(() => {
    let o = e == null ? void 0 : e.current;
    if (o)
      if ($e()) {
        const n = new window.ResizeObserver((s) => {
          s.length && l();
        });
        return n.observe(o, {
          box: r
        }), () => {
          o && n.unobserve(o);
        };
      } else
        return window.addEventListener("resize", l, !1), () => {
          window.removeEventListener("resize", l, !1);
        };
  }, [
    l,
    e,
    r
  ]);
}
const M = {
  top: "top",
  bottom: "top",
  left: "left",
  right: "left"
}, Y = {
  top: "bottom",
  bottom: "top",
  left: "right",
  right: "left"
}, he = {
  top: "left",
  left: "top"
}, q = {
  top: "height",
  left: "width"
}, re = {
  width: "totalWidth",
  height: "totalHeight"
}, B = {};
let P = typeof document < "u" ? window.visualViewport : null;
function V(t) {
  let e = 0, r = 0, l = 0, o = 0, n = 0, s = 0, i = {};
  var $;
  let d = (($ = P == null ? void 0 : P.scale) !== null && $ !== void 0 ? $ : 1) > 1;
  if (t.tagName === "BODY") {
    let f = document.documentElement;
    l = f.clientWidth, o = f.clientHeight;
    var p;
    e = (p = P == null ? void 0 : P.width) !== null && p !== void 0 ? p : l;
    var g;
    r = (g = P == null ? void 0 : P.height) !== null && g !== void 0 ? g : o, i.top = f.scrollTop || t.scrollTop, i.left = f.scrollLeft || t.scrollLeft, P && (n = P.offsetTop, s = P.offsetLeft);
  } else
    ({ width: e, height: r, top: n, left: s } = F(t)), i.top = t.scrollTop, i.left = t.scrollLeft, l = e, o = r;
  if (ce() && (t.tagName === "BODY" || t.tagName === "HTML") && d) {
    i.top = 0, i.left = 0;
    var u;
    n = (u = P == null ? void 0 : P.pageTop) !== null && u !== void 0 ? u : 0;
    var a;
    s = (a = P == null ? void 0 : P.pageLeft) !== null && a !== void 0 ? a : 0;
  }
  return {
    width: e,
    height: r,
    totalWidth: l,
    totalHeight: o,
    scroll: i,
    top: n,
    left: s
  };
}
function be(t) {
  return {
    top: t.scrollTop,
    left: t.scrollLeft,
    width: t.scrollWidth,
    height: t.scrollHeight
  };
}
function D(t, e, r, l, o, n, s) {
  var i;
  let $ = (i = o.scroll[t]) !== null && i !== void 0 ? i : 0, d = l[q[t]], p = l.scroll[M[t]] + n, g = d + l.scroll[M[t]] - n, u = e - $ + s[t] - l[M[t]], a = e - $ + r + s[t] - l[M[t]];
  return u < p ? p - u : a > g ? Math.max(g - a, p - u) : 0;
}
function xe(t) {
  let e = window.getComputedStyle(t);
  return {
    top: parseInt(e.marginTop, 10) || 0,
    bottom: parseInt(e.marginBottom, 10) || 0,
    left: parseInt(e.marginLeft, 10) || 0,
    right: parseInt(e.marginRight, 10) || 0
  };
}
function ee(t) {
  if (B[t]) return B[t];
  let [e, r] = t.split(" "), l = M[e] || "right", o = he[l];
  M[r] || (r = "center");
  let n = q[l], s = q[o];
  return B[t] = {
    placement: e,
    crossPlacement: r,
    axis: l,
    crossAxis: o,
    size: n,
    crossSize: s
  }, B[t];
}
function j(t, e, r, l, o, n, s, i, $, d) {
  let { placement: p, crossPlacement: g, axis: u, crossAxis: a, size: f, crossSize: h } = l, c = {};
  var m;
  c[a] = (m = t[a]) !== null && m !== void 0 ? m : 0;
  var v, E, T, L;
  g === "center" ? c[a] += (((v = t[h]) !== null && v !== void 0 ? v : 0) - ((E = r[h]) !== null && E !== void 0 ? E : 0)) / 2 : g !== a && (c[a] += ((T = t[h]) !== null && T !== void 0 ? T : 0) - ((L = r[h]) !== null && L !== void 0 ? L : 0)), c[a] += n;
  const b = t[a] - r[h] + $ + d, _ = t[a] + t[h] - $ - d;
  if (c[a] = U(c[a], b, _), p === u) {
    const y = i ? s[f] : e[re[f]];
    c[Y[u]] = Math.floor(y - t[u] + o);
  } else c[u] = Math.floor(t[u] + t[f] + o);
  return c;
}
function we(t, e, r, l, o, n, s, i) {
  const $ = l ? r.height : e[re.height];
  var d;
  let p = t.top != null ? r.top + t.top : r.top + ($ - ((d = t.bottom) !== null && d !== void 0 ? d : 0) - s);
  var g, u, a, f, h, c;
  let m = i !== "top" ? (
    // We want the distance between the top of the overlay to the bottom of the boundary
    Math.max(0, e.height + e.top + ((g = e.scroll.top) !== null && g !== void 0 ? g : 0) - p - (((u = o.top) !== null && u !== void 0 ? u : 0) + ((a = o.bottom) !== null && a !== void 0 ? a : 0) + n))
  ) : Math.max(0, p + s - (e.top + ((f = e.scroll.top) !== null && f !== void 0 ? f : 0)) - (((h = o.top) !== null && h !== void 0 ? h : 0) + ((c = o.bottom) !== null && c !== void 0 ? c : 0) + n));
  return Math.min(e.height - n * 2, m);
}
function te(t, e, r, l, o, n) {
  let { placement: s, axis: i, size: $ } = n;
  var d, p;
  if (s === i) return Math.max(0, r[i] - t[i] - ((d = t.scroll[i]) !== null && d !== void 0 ? d : 0) + e[i] - ((p = l[i]) !== null && p !== void 0 ? p : 0) - l[Y[i]] - o);
  var g;
  return Math.max(0, t[$] + t[i] + t.scroll[i] - e[i] - r[i] - r[$] - ((g = l[i]) !== null && g !== void 0 ? g : 0) - l[Y[i]] - o);
}
function Ee(t, e, r, l, o, n, s, i, $, d, p, g, u, a, f, h) {
  let c = ee(t), { size: m, crossAxis: v, crossSize: E, placement: T, crossPlacement: L } = c, b = j(e, i, r, c, p, g, d, u, f, h), _ = p, y = te(i, d, e, o, n + p, c);
  if (s && l[m] > y) {
    let Z = ee(`${Y[T]} ${L}`), se = j(e, i, r, Z, p, g, d, u, f, h);
    te(i, d, e, o, n + p, Z) > y && (c = Z, b = se, _ = p);
  }
  let H = "bottom";
  c.axis === "top" ? c.placement === "top" ? H = "top" : c.placement === "bottom" && (H = "bottom") : c.crossAxis === "top" && (c.crossPlacement === "top" ? H = "bottom" : c.crossPlacement === "bottom" && (H = "top"));
  let w = D(v, b[v], r[E], i, $, n, d);
  b[v] += w;
  let R = we(b, i, d, u, o, n, r.height, H);
  a && a < R && (R = a), r.height = Math.min(r.height, R), b = j(e, i, r, c, _, g, d, u, f, h), w = D(v, b[v], r[E], i, $, n, d), b[v] += w;
  let z = {}, A = e[v] + 0.5 * e[E] - b[v] - o[M[v]];
  const S = f / 2 + h;
  var N, O, I, C;
  const k = M[v] === "left" ? ((N = o.left) !== null && N !== void 0 ? N : 0) + ((O = o.right) !== null && O !== void 0 ? O : 0) : ((I = o.top) !== null && I !== void 0 ? I : 0) + ((C = o.bottom) !== null && C !== void 0 ? C : 0), X = r[E] - k - f / 2 - h, ne = e[v] + f / 2 - (b[v] + o[M[v]]), ie = e[v] + e[E] - f / 2 - (b[v] + o[M[v]]), ae = U(A, ne, ie);
  return z[v] = U(ae, S, X), {
    position: b,
    maxHeight: R,
    arrowOffsetLeft: z.left,
    arrowOffsetTop: z.top,
    placement: c.placement
  };
}
function Pe(t) {
  let { placement: e, targetNode: r, overlayNode: l, scrollNode: o, padding: n, shouldFlip: s, boundaryElement: i, offset: $, crossOffset: d, maxHeight: p, arrowSize: g = 0, arrowBoundaryOffset: u = 0 } = t, a = l instanceof HTMLElement ? Le(l) : document.documentElement, f = a === document.documentElement;
  const h = window.getComputedStyle(a).position;
  let c = !!h && h !== "static", m = f ? F(r) : le(r, a);
  if (!f) {
    let { marginTop: z, marginLeft: A } = window.getComputedStyle(r);
    m.top += parseInt(z, 10) || 0, m.left += parseInt(A, 10) || 0;
  }
  let v = F(l), E = xe(l);
  var T, L;
  v.width += ((T = E.left) !== null && T !== void 0 ? T : 0) + ((L = E.right) !== null && L !== void 0 ? L : 0);
  var b, _;
  v.height += ((b = E.top) !== null && b !== void 0 ? b : 0) + ((_ = E.bottom) !== null && _ !== void 0 ? _ : 0);
  let y = be(o), H = V(i), w = V(a), R = i.tagName === "BODY" ? F(a) : le(a, i);
  return a.tagName === "HTML" && i.tagName === "BODY" && (w.scroll.top = 0, w.scroll.left = 0), Ee(e, m, v, y, E, n, s, H, w, R, $, d, c, p, g, u);
}
function F(t) {
  let { top: e, left: r, width: l, height: o } = t.getBoundingClientRect(), { scrollTop: n, scrollLeft: s, clientTop: i, clientLeft: $ } = document.documentElement;
  return {
    top: e + n - i,
    left: r + s - $,
    width: l,
    height: o
  };
}
function le(t, e) {
  let r = window.getComputedStyle(t), l;
  if (r.position === "fixed") {
    let { top: o, left: n, width: s, height: i } = t.getBoundingClientRect();
    l = {
      top: o,
      left: n,
      width: s,
      height: i
    };
  } else {
    l = F(t);
    let o = F(e), n = window.getComputedStyle(e);
    o.top += (parseInt(n.borderTopWidth, 10) || 0) - e.scrollTop, o.left += (parseInt(n.borderLeftWidth, 10) || 0) - e.scrollLeft, l.top -= o.top, l.left -= o.left;
  }
  return l.top -= parseInt(r.marginTop, 10) || 0, l.left -= parseInt(r.marginLeft, 10) || 0, l;
}
function Le(t) {
  let e = t.offsetParent;
  if (e && e === document.body && window.getComputedStyle(e).position === "static" && !oe(e) && (e = document.documentElement), e == null)
    for (e = t.parentElement; e && !oe(e); ) e = e.parentElement;
  return e || document.documentElement;
}
function oe(t) {
  let e = window.getComputedStyle(t);
  return e.transform !== "none" || /transform|perspective/.test(e.willChange) || e.filter !== "none" || e.contain === "paint" || "backdropFilter" in e && e.backdropFilter !== "none" || "WebkitBackdropFilter" in e && e.WebkitBackdropFilter !== "none";
}
const Ce = /* @__PURE__ */ new WeakMap();
function Re(t) {
  let { triggerRef: e, isOpen: r, onClose: l } = t;
  J(() => {
    if (!r || l === null) return;
    let o = (n) => {
      let s = n.target;
      if (!e.current || s instanceof Node && !s.contains(e.current) || n.target instanceof HTMLInputElement || n.target instanceof HTMLTextAreaElement) return;
      let i = l || Ce.get(e.current);
      i && i();
    };
    return window.addEventListener("scroll", o, !0), () => {
      window.removeEventListener("scroll", o, !0);
    };
  }, [
    r,
    l,
    e
  ]);
}
let x = typeof document < "u" ? window.visualViewport : null;
function Ne(t) {
  let { direction: e } = ge(), { arrowSize: r = 0, targetRef: l, overlayRef: o, scrollRef: n = o, placement: s = "bottom", containerPadding: i = 12, shouldFlip: $ = !0, boundaryElement: d = typeof document < "u" ? document.body : null, offset: p = 0, crossOffset: g = 0, shouldUpdatePosition: u = !0, isOpen: a = !0, onClose: f, maxHeight: h, arrowBoundaryOffset: c = 0 } = t, [m, v] = fe(null), E = [
    u,
    s,
    o.current,
    l.current,
    n.current,
    i,
    $,
    d,
    p,
    g,
    a,
    e,
    h,
    c,
    r
  ], T = K(x == null ? void 0 : x.scale);
  J(() => {
    a && (T.current = x == null ? void 0 : x.scale);
  }, [
    a
  ]);
  let L = Q(() => {
    if (u === !1 || !a || !o.current || !l.current || !d || (x == null ? void 0 : x.scale) !== T.current) return;
    let w = null;
    if (n.current && n.current.contains(document.activeElement)) {
      var R;
      let C = (R = document.activeElement) === null || R === void 0 ? void 0 : R.getBoundingClientRect(), k = n.current.getBoundingClientRect();
      var z;
      if (w = {
        type: "top",
        offset: ((z = C == null ? void 0 : C.top) !== null && z !== void 0 ? z : 0) - k.top
      }, w.offset > k.height / 2) {
        w.type = "bottom";
        var A;
        w.offset = ((A = C == null ? void 0 : C.bottom) !== null && A !== void 0 ? A : 0) - k.bottom;
      }
    }
    let S = o.current;
    if (!h && o.current) {
      var N;
      S.style.top = "0px", S.style.bottom = "";
      var O;
      S.style.maxHeight = ((O = (N = window.visualViewport) === null || N === void 0 ? void 0 : N.height) !== null && O !== void 0 ? O : window.innerHeight) + "px";
    }
    let I = Pe({
      placement: ze(s, e),
      overlayNode: o.current,
      targetNode: l.current,
      scrollNode: n.current || o.current,
      padding: i,
      shouldFlip: $,
      boundaryElement: d,
      offset: p,
      crossOffset: g,
      maxHeight: h,
      arrowSize: r,
      arrowBoundaryOffset: c
    });
    if (I.position) {
      if (S.style.top = "", S.style.bottom = "", S.style.left = "", S.style.right = "", Object.keys(I.position).forEach((C) => S.style[C] = I.position[C] + "px"), S.style.maxHeight = I.maxHeight != null ? I.maxHeight + "px" : "", w && document.activeElement && n.current) {
        let C = document.activeElement.getBoundingClientRect(), k = n.current.getBoundingClientRect(), X = C[w.type] - k[w.type];
        n.current.scrollTop += X - w.offset;
      }
      v(I);
    }
  }, E);
  G(L, E), Te(L), W({
    ref: o,
    onResize: L
  }), W({
    ref: l,
    onResize: L
  });
  let b = K(!1);
  G(() => {
    let w, R = () => {
      b.current = !0, clearTimeout(w), w = setTimeout(() => {
        b.current = !1;
      }, 500), L();
    }, z = () => {
      b.current && R();
    };
    return x == null || x.addEventListener("resize", R), x == null || x.addEventListener("scroll", z), () => {
      x == null || x.removeEventListener("resize", R), x == null || x.removeEventListener("scroll", z);
    };
  }, [
    L
  ]);
  let _ = Q(() => {
    b.current || f == null || f();
  }, [
    f,
    b
  ]);
  Re({
    triggerRef: l,
    isOpen: a,
    onClose: f && _
  });
  var y, H;
  return {
    overlayProps: {
      style: {
        position: "absolute",
        zIndex: 1e5,
        ...m == null ? void 0 : m.position,
        maxHeight: (y = m == null ? void 0 : m.maxHeight) !== null && y !== void 0 ? y : "100vh"
      }
    },
    placement: (H = m == null ? void 0 : m.placement) !== null && H !== void 0 ? H : null,
    arrowProps: {
      "aria-hidden": "true",
      role: "presentation",
      style: {
        left: m == null ? void 0 : m.arrowOffsetLeft,
        top: m == null ? void 0 : m.arrowOffsetTop
      }
    },
    updatePosition: L
  };
}
function Te(t) {
  G(() => (window.addEventListener("resize", t, !1), () => {
    window.removeEventListener("resize", t, !1);
  }), [
    t
  ]);
}
function ze(t, e) {
  return e === "rtl" ? t.replace("start", "right").replace("end", "left") : t.replace("start", "left").replace("end", "right");
}
const He = /* @__PURE__ */ ue({
  placement: "bottom"
}), Oe = /* @__PURE__ */ pe(function(e, r) {
  [e, r] = me(e, r, He);
  let l = e.placement, o = {
    position: "absolute",
    transform: l === "top" || l === "bottom" ? "translateX(-50%)" : "translateY(-50%)"
  };
  l != null && (o[l] = "100%");
  let n = ve({
    ...e,
    defaultClassName: "react-aria-OverlayArrow",
    values: {
      placement: l
    }
  });
  return n.style && Object.keys(n.style).forEach((s) => n.style[s] === void 0 && delete n.style[s]), /* @__PURE__ */ de.createElement("div", {
    ...e,
    ...n,
    style: {
      ...o,
      ...n.style
    },
    ref: r,
    "data-placement": l
  });
});
export {
  Ne as $,
  He as a,
  Oe as b,
  Ce as c,
  W as d
};
