import { n as y, $ as S, b as K, d as W } from "./utils-DPfg4HqB.js";
import { $ as q, a as z } from "./OverlayArrow-BINAcvV5.js";
import { $ as B, a as G, c as H, d as h, e as C } from "./Dialog-QtDyK8mk.js";
import { $ as T } from "./filterDOMProps-D6KHYVBX.js";
import { $ as j, a as k, b as J } from "./useOverlayTriggerState-fZODjzBe.js";
import { t as Q } from "./useHover-r8IM8mvD.js";
import l, { forwardRef as V, createContext as I, useContext as M, useRef as R, useState as D, useEffect as X } from "react";
import { a as Y } from "./Hidden-B52Gs8Ba.js";
import { $ as Z } from "./context-DRz_xlLl.js";
import { a as A, $ as L } from "./ariaHideOutside-WC388v0M.js";
function U(s, r) {
  let { triggerRef: n, popoverRef: e, groupRef: t, isNonModal: a, isKeyboardDismissDisabled: c, shouldCloseOnInteractOutside: f, ...o } = s, d = o.trigger === "SubmenuTrigger", { overlayProps: m, underlayProps: g } = B({
    isOpen: r.isOpen,
    onClose: r.close,
    shouldCloseOnBlur: !0,
    isDismissable: !a || d,
    isKeyboardDismissDisabled: c,
    shouldCloseOnInteractOutside: f
  }, t ?? e), { overlayProps: p, arrowProps: v, placement: u } = q({
    ...o,
    targetRef: n,
    overlayRef: e,
    isOpen: r.isOpen,
    onClose: a && !d ? r.close : null
  });
  return G({
    isDisabled: a || !r.isOpen
  }), y(() => {
    if (r.isOpen && e.current) {
      var i, $;
      return a ? A((i = t == null ? void 0 : t.current) !== null && i !== void 0 ? i : e.current) : L([
        ($ = t == null ? void 0 : t.current) !== null && $ !== void 0 ? $ : e.current
      ]);
    }
  }, [
    a,
    r.isOpen,
    e,
    t
  ]), {
    popoverProps: S(m, p),
    arrowProps: v,
    underlayProps: g,
    placement: u
  };
}
const _ = /* @__PURE__ */ I(null), w = /* @__PURE__ */ I(null), ce = /* @__PURE__ */ V(function(r, n) {
  [r, n] = K(r, n, _);
  let e = M(H), t = j(r), a = r.isOpen != null || r.defaultOpen != null || !e ? t : e, c = k(n, a.isOpen) || r.isExiting || !1, f = Y(), { direction: o } = Z();
  if (f) {
    let d = r.children;
    return typeof d == "function" && (d = d({
      trigger: r.trigger || null,
      placement: "bottom",
      isEntering: !1,
      isExiting: !1,
      defaultChildren: null
    })), /* @__PURE__ */ l.createElement(l.Fragment, null, d);
  }
  return a && !a.isOpen && !c ? null : /* @__PURE__ */ l.createElement(ee, {
    ...r,
    triggerRef: r.triggerRef,
    state: a,
    popoverRef: n,
    isExiting: c,
    dir: o
  });
});
function ee({ state: s, isExiting: r, UNSTABLE_portalContainer: n, ...e }) {
  let t = R(null), [a, c] = D(0), f = R(null), o = M(w), d = o && e.trigger === "SubmenuTrigger";
  y(() => {
    t.current && s.isOpen && c(t.current.getBoundingClientRect().width);
  }, [
    s.isOpen,
    t
  ]);
  var m;
  let { popoverProps: g, underlayProps: p, arrowProps: v, placement: u } = U({
    ...e,
    offset: (m = e.offset) !== null && m !== void 0 ? m : 8,
    arrowSize: a,
    // If this is a submenu/subdialog, use the root popover's container 
    // to detect outside interaction and add aria-hidden.
    groupRef: d ? o : f
  }, s), i = e.popoverRef, $ = J(i, !!u) || e.isEntering || !1, x = W({
    ...e,
    defaultClassName: "react-aria-Popover",
    values: {
      trigger: e.trigger || null,
      placement: u,
      isEntering: $,
      isExiting: r
    }
  }), O = !e.isNonModal || e.trigger === "SubmenuTrigger", [b, N] = D(!1);
  y(() => {
    i.current && N(O && !i.current.querySelector("[role=dialog]"));
  }, [
    i,
    O
  ]), X(() => {
    b && i.current && !i.current.contains(document.activeElement) && Q(i.current);
  }, [
    b,
    i
  ]);
  let F = {
    ...g.style,
    ...x.style
  }, E = /* @__PURE__ */ l.createElement("div", {
    ...S(T(e), g),
    ...x,
    role: b ? "dialog" : void 0,
    tabIndex: b ? -1 : void 0,
    "aria-label": e["aria-label"],
    "aria-labelledby": e["aria-labelledby"],
    ref: i,
    slot: e.slot || void 0,
    style: F,
    dir: e.dir,
    "data-trigger": e.trigger,
    "data-placement": u,
    "data-entering": $ || void 0,
    "data-exiting": r || void 0
  }, !e.isNonModal && /* @__PURE__ */ l.createElement(h, {
    onDismiss: s.close
  }), /* @__PURE__ */ l.createElement(z.Provider, {
    value: {
      ...v,
      placement: u,
      ref: t
    }
  }, x.children), /* @__PURE__ */ l.createElement(h, {
    onDismiss: s.close
  }));
  if (!d) return /* @__PURE__ */ l.createElement(C, {
    ...e,
    shouldContainFocus: b,
    isExiting: r,
    portalContainer: n
  }, !e.isNonModal && s.isOpen && /* @__PURE__ */ l.createElement("div", {
    "data-testid": "underlay",
    ...p,
    style: {
      position: "fixed",
      inset: 0
    }
  }), /* @__PURE__ */ l.createElement("div", {
    ref: f,
    style: {
      display: "contents"
    }
  }, /* @__PURE__ */ l.createElement(w.Provider, {
    value: f
  }, E)));
  var P;
  return /* @__PURE__ */ l.createElement(C, {
    ...e,
    shouldContainFocus: b,
    isExiting: r,
    portalContainer: (P = n ?? (o == null ? void 0 : o.current)) !== null && P !== void 0 ? P : void 0
  }, E);
}
export {
  ce as $,
  _ as a
};
