import { j as I, c as O } from "../clsx-DsQc8enX.js";
import { a as _, $ as j, b as L } from "../FieldError-BcQ_xYIC.js";
import { a as z, $ as T } from "../Label-BhIlZh5B.js";
import { $ as g, a as E, b as M, f as W, g as G, d as q, e as A, c as H, i as K, h as J } from "../utils-DPfg4HqB.js";
import { a as Q, $ as X } from "../Form-CjZKgLHe.js";
import { a as Y } from "../Text-NEUq4Wl7.js";
import { $ as B } from "../filterDOMProps-D6KHYVBX.js";
import k, { useMemo as Z, useState as ee, forwardRef as N, createContext as S } from "react";
import { $ as ae } from "../useControlledState-Kv9K2AYu.js";
import { $ as ie } from "../FocusScope-B-R06ewx.js";
import { a as re, $ as le } from "../useFocusRing-DTBeynF4.js";
import { $ as de } from "../context-DRz_xlLl.js";
import { $ as te } from "../useFormReset-BFMiMslO.js";
import { a as F } from "../usePress-BKP_smFB.js";
import { $ as oe, a as se } from "../useHover-r8IM8mvD.js";
import { $ as ne } from "../useFormValidation-B8seeWsn.js";
import { $ as ce } from "../VisuallyHidden-5Sj7PJLN.js";
import { c as C } from "../index-h1rMlRhQ.js";
const U = /* @__PURE__ */ new WeakMap();
function fe(a, e, r) {
  let { value: d, children: o, "aria-label": l, "aria-labelledby": t } = a;
  const i = a.isDisabled || e.isDisabled;
  let f = o != null, n = l != null || t != null;
  !f && !n && console.warn("If you do not provide children, you must specify an aria-label for accessibility");
  let s = e.selectedValue === d, m = (y) => {
    y.stopPropagation(), e.setSelectedValue(d);
  }, { pressProps: p, isPressed: x } = F({
    isDisabled: i
  }), { pressProps: h, isPressed: $ } = F({
    isDisabled: i,
    onPress() {
      var y;
      e.setSelectedValue(d), (y = r.current) === null || y === void 0 || y.focus();
    }
  }), { focusableProps: D } = oe(g(a, {
    onFocus: () => e.setLastFocusedValue(d)
  }), r), R = g(p, D), V = B(a, {
    labelable: !0
  }), v = -1;
  e.selectedValue != null ? e.selectedValue === d && (v = 0) : (e.lastFocusedValue === d || e.lastFocusedValue == null) && (v = 0), i && (v = void 0);
  let { name: b, descriptionId: c, errorMessageId: P, validationBehavior: u } = U.get(e);
  return te(r, e.selectedValue, e.setSelectedValue), ne({
    validationBehavior: u
  }, e, r), {
    labelProps: g(h, {
      onClick: (y) => y.preventDefault()
    }),
    inputProps: g(V, {
      ...R,
      type: "radio",
      name: b,
      tabIndex: v,
      disabled: i,
      required: e.isRequired && u === "native",
      checked: s,
      value: d,
      onChange: m,
      "aria-describedby": [
        a["aria-describedby"],
        e.isInvalid ? P : null,
        c
      ].filter(Boolean).join(" ") || void 0
    }),
    isDisabled: i,
    isSelected: s,
    isPressed: x || $
  };
}
function ue(a, e) {
  let { name: r, isReadOnly: d, isRequired: o, isDisabled: l, orientation: t = "vertical", validationBehavior: i = "aria" } = a, { direction: f } = de(), { isInvalid: n, validationErrors: s, validationDetails: m } = e.displayValidation, { labelProps: p, fieldProps: x, descriptionProps: h, errorMessageProps: $ } = _({
    ...a,
    // Radio group is not an HTML input element so it
    // shouldn't be labeled by a <label> element.
    labelElementType: "span",
    isInvalid: e.isInvalid,
    errorMessage: a.errorMessage || s
  }), D = B(a, {
    labelable: !0
  }), { focusWithinProps: R } = re({
    onBlurWithin(b) {
      var c;
      (c = a.onBlur) === null || c === void 0 || c.call(a, b), e.selectedValue || e.setLastFocusedValue(null);
    },
    onFocusWithin: a.onFocus,
    onFocusWithinChange: a.onFocusChange
  }), V = (b) => {
    let c;
    switch (b.key) {
      case "ArrowRight":
        f === "rtl" && t !== "vertical" ? c = "prev" : c = "next";
        break;
      case "ArrowLeft":
        f === "rtl" && t !== "vertical" ? c = "next" : c = "prev";
        break;
      case "ArrowDown":
        c = "next";
        break;
      case "ArrowUp":
        c = "prev";
        break;
      default:
        return;
    }
    b.preventDefault();
    let P = ie(b.currentTarget, {
      from: b.target
    }), u;
    c === "next" ? (u = P.nextNode(), u || (P.currentNode = b.currentTarget, u = P.firstChild())) : (u = P.previousNode(), u || (P.currentNode = b.currentTarget, u = P.lastChild())), u && (u.focus(), e.setSelectedValue(u.value));
  }, v = E(r);
  return U.set(e, {
    name: v,
    descriptionId: h.id,
    errorMessageId: $.id,
    validationBehavior: i
  }), {
    radioGroupProps: g(D, {
      // https://www.w3.org/TR/wai-aria-1.2/#radiogroup
      role: "radiogroup",
      onKeyDown: V,
      "aria-invalid": e.isInvalid || void 0,
      "aria-errormessage": a["aria-errormessage"],
      "aria-readonly": d || void 0,
      "aria-required": o || void 0,
      "aria-disabled": l || void 0,
      "aria-orientation": t,
      ...x,
      ...R
    }),
    labelProps: p,
    descriptionProps: h,
    errorMessageProps: $,
    isInvalid: n,
    validationErrors: s,
    validationDetails: m
  };
}
let be = Math.round(Math.random() * 1e10), $e = 0;
function ve(a) {
  let e = Z(() => a.name || `radio-group-${be}-${++$e}`, [
    a.name
  ]);
  var r;
  let [d, o] = ae(a.value, (r = a.defaultValue) !== null && r !== void 0 ? r : null, a.onChange), [l, t] = ee(null), i = Q({
    ...a,
    value: d
  }), f = (s) => {
    !a.isReadOnly && !a.isDisabled && (o(s), i.commitValidation());
  }, n = i.displayValidation.isInvalid;
  return {
    ...i,
    name: e,
    selectedValue: d,
    setSelectedValue: f,
    lastFocusedValue: l,
    setLastFocusedValue: t,
    isDisabled: a.isDisabled || !1,
    isReadOnly: a.isReadOnly || !1,
    isRequired: a.isRequired || !1,
    validationState: a.validationState || (n ? "invalid" : null),
    isInvalid: n
  };
}
const me = /* @__PURE__ */ S(null), pe = /* @__PURE__ */ S(null), w = /* @__PURE__ */ S(null), xe = /* @__PURE__ */ N(function(e, r) {
  [e, r] = M(e, r, me);
  let { validationBehavior: d } = W(X) || {};
  var o, l;
  let t = (l = (o = e.validationBehavior) !== null && o !== void 0 ? o : d) !== null && l !== void 0 ? l : "native", i = ve({
    ...e,
    validationBehavior: t
  }), [f, n] = G(!e["aria-label"] && !e["aria-labelledby"]), { radioGroupProps: s, labelProps: m, descriptionProps: p, errorMessageProps: x, ...h } = ue({
    ...e,
    label: n,
    validationBehavior: t
  }, i), $ = q({
    ...e,
    values: {
      orientation: e.orientation || "vertical",
      isDisabled: i.isDisabled,
      isReadOnly: i.isReadOnly,
      isRequired: i.isRequired,
      isInvalid: i.isInvalid,
      state: i
    },
    defaultClassName: "react-aria-RadioGroup"
  });
  return /* @__PURE__ */ k.createElement("div", {
    ...s,
    ...$,
    ref: r,
    slot: e.slot || void 0,
    "data-orientation": e.orientation || "vertical",
    "data-invalid": i.isInvalid || void 0,
    "data-disabled": i.isDisabled || void 0,
    "data-readonly": i.isReadOnly || void 0,
    "data-required": i.isRequired || void 0
  }, /* @__PURE__ */ k.createElement(A, {
    values: [
      [
        w,
        i
      ],
      [
        z,
        {
          ...m,
          ref: f,
          elementType: "span"
        }
      ],
      [
        Y,
        {
          slots: {
            description: p,
            errorMessage: x
          }
        }
      ],
      [
        j,
        h
      ]
    ]
  }, $.children));
}), he = /* @__PURE__ */ N(function(e, r) {
  let { inputRef: d = null, ...o } = e;
  [e, r] = M(o, r, pe);
  let l = k.useContext(w), t = H(K(d, e.inputRef !== void 0 ? e.inputRef : null)), { labelProps: i, inputProps: f, isSelected: n, isDisabled: s, isPressed: m } = fe({
    ...J(e),
    // ReactNode type doesn't allow function children.
    children: typeof e.children == "function" ? !0 : e.children
  }, l, t), { isFocused: p, isFocusVisible: x, focusProps: h } = le(), $ = s || l.isReadOnly, { hoverProps: D, isHovered: R } = se({
    ...e,
    isDisabled: $
  }), V = q({
    ...e,
    defaultClassName: "react-aria-Radio",
    values: {
      isSelected: n,
      isPressed: m,
      isHovered: R,
      isFocused: p,
      isFocusVisible: x,
      isDisabled: s,
      isReadOnly: l.isReadOnly,
      isInvalid: l.isInvalid,
      isRequired: l.isRequired
    }
  }), v = B(e);
  return delete v.id, /* @__PURE__ */ k.createElement("label", {
    ...g(v, i, D, V),
    ref: r,
    "data-selected": n || void 0,
    "data-pressed": m || void 0,
    "data-hovered": R || void 0,
    "data-focused": p || void 0,
    "data-focus-visible": x || void 0,
    "data-disabled": s || void 0,
    "data-readonly": l.isReadOnly || void 0,
    "data-invalid": l.isInvalid || void 0,
    "data-required": l.isRequired || void 0
  }, /* @__PURE__ */ k.createElement(ce, {
    elementType: "span"
  }, /* @__PURE__ */ k.createElement("input", {
    ...g(f, h),
    ref: t
  })), V.children);
});
function _e({
  small: a = !1,
  groupLabel: e,
  options: r,
  className: d,
  fieldErrorProps: o,
  ...l
}) {
  return /* @__PURE__ */ I.jsxs(
    xe,
    {
      ...l,
      className: C(
        "relative flex flex-col gap-2",
        "orientation-horizontal:flex-row orientation-horizontal:items-center orientation-horizontal:gap-4",
        "orientation-horizontal:[&>span]:mr-2 orientation-vertical:[&>span]:mb-1",
        d
      ),
      children: [
        e && /* @__PURE__ */ I.jsx(
          T,
          {
            className: O(
              "text-klerosUIComponentsSecondaryText",
              a ? "text-sm" : "text-lg"
            ),
            children: e
          }
        ),
        r.map((t) => /* @__PURE__ */ I.jsx(
          he,
          {
            ...t,
            className: C(
              "relative box-border block cursor-pointer",
              "text-klerosUIComponentsPrimaryText disabled:text-klerosUIComponentsStroke",
              a ? "pl-7 text-base" : "pl-[35px] text-[22px]",
              t.className
            ),
            children: ({ isSelected: i, isHovered: f, isDisabled: n, isPressed: s }) => /* @__PURE__ */ I.jsxs(I.Fragment, { children: [
              /* @__PURE__ */ I.jsx(
                "span",
                {
                  className: C(
                    "border-klerosUIComponentsStroke absolute top-1 left-0 rounded-full border",
                    "after:bg-klerosUIComponentsPrimaryBlue after:absolute after:hidden after:rounded-full",
                    "ease-ease after:ease-ease transition-all after:transition-all",
                    a ? "size-4 after:top-0.75 after:left-0.75 after:size-2" : "size-6 after:top-1.25 after:left-1.25 after:size-3",
                    i && [
                      "bg-klerosUIComponentsWhiteBackground border-klerosUIComponentsPrimaryBlue after:block"
                    ],
                    f && [
                      "border-klerosUIComponentsSecondaryBlue bg-klerosUIComponentsLightBlue"
                    ],
                    s && [
                      "border-klerosUIComponentsSecondaryBlue after:bg-klerosUIComponentsSecondaryBlue"
                    ],
                    n && [
                      "border-klerosUIComponentsStroke after:hidden"
                    ]
                  )
                }
              ),
              t.label
            ] })
          },
          t.value
        )),
        /* @__PURE__ */ I.jsx(
          L,
          {
            ...o,
            className: C(
              "text-klerosUIComponentsError self-end text-sm",
              o == null ? void 0 : o.className
            )
          }
        )
      ]
    }
  );
}
export {
  _e as default
};
