import { r as d, a as f } from "./Collection-CYEl0MHQ.js";
import { $ as h } from "./isScrollable-BsTGzxij.js";
import { $ as y } from "./useCollator-UGgeWRRW.js";
import { useMemo as K } from "react";
class u {
  getItemRect(e) {
    let t = this.ref.current;
    if (!t) return null;
    let i = e != null ? d(this.ref, e) : null;
    if (!i) return null;
    let l = t.getBoundingClientRect(), o = i.getBoundingClientRect();
    return {
      x: o.left - l.left + t.scrollLeft,
      y: o.top - l.top + t.scrollTop,
      width: o.width,
      height: o.height
    };
  }
  getContentSize() {
    let e = this.ref.current;
    var t, i;
    return {
      width: (t = e == null ? void 0 : e.scrollWidth) !== null && t !== void 0 ? t : 0,
      height: (i = e == null ? void 0 : e.scrollHeight) !== null && i !== void 0 ? i : 0
    };
  }
  getVisibleRect() {
    let e = this.ref.current;
    var t, i, l, o;
    return {
      x: (t = e == null ? void 0 : e.scrollLeft) !== null && t !== void 0 ? t : 0,
      y: (i = e == null ? void 0 : e.scrollTop) !== null && i !== void 0 ? i : 0,
      width: (l = e == null ? void 0 : e.offsetWidth) !== null && l !== void 0 ? l : 0,
      height: (o = e == null ? void 0 : e.offsetHeight) !== null && o !== void 0 ? o : 0
    };
  }
  constructor(e) {
    this.ref = e;
  }
}
class b {
  isDisabled(e) {
    var t;
    return this.disabledBehavior === "all" && (((t = e.props) === null || t === void 0 ? void 0 : t.isDisabled) || this.disabledKeys.has(e.key));
  }
  findNextNonDisabled(e, t) {
    let i = e;
    for (; i != null; ) {
      let l = this.collection.getItem(i);
      if ((l == null ? void 0 : l.type) === "item" && !this.isDisabled(l)) return i;
      i = t(i);
    }
    return null;
  }
  getNextKey(e) {
    let t = e;
    return t = this.collection.getKeyAfter(t), this.findNextNonDisabled(t, (i) => this.collection.getKeyAfter(i));
  }
  getPreviousKey(e) {
    let t = e;
    return t = this.collection.getKeyBefore(t), this.findNextNonDisabled(t, (i) => this.collection.getKeyBefore(i));
  }
  findKey(e, t, i) {
    let l = e, o = this.layoutDelegate.getItemRect(l);
    if (!o || l == null) return null;
    let n = o;
    do {
      if (l = t(l), l == null) break;
      o = this.layoutDelegate.getItemRect(l);
    } while (o && i(n, o) && l != null);
    return l;
  }
  isSameRow(e, t) {
    return e.y === t.y || e.x !== t.x;
  }
  isSameColumn(e, t) {
    return e.x === t.x || e.y !== t.y;
  }
  getKeyBelow(e) {
    return this.layout === "grid" && this.orientation === "vertical" ? this.findKey(e, (t) => this.getNextKey(t), this.isSameRow) : this.getNextKey(e);
  }
  getKeyAbove(e) {
    return this.layout === "grid" && this.orientation === "vertical" ? this.findKey(e, (t) => this.getPreviousKey(t), this.isSameRow) : this.getPreviousKey(e);
  }
  getNextColumn(e, t) {
    return t ? this.getPreviousKey(e) : this.getNextKey(e);
  }
  getKeyRightOf(e) {
    let t = this.direction === "ltr" ? "getKeyRightOf" : "getKeyLeftOf";
    return this.layoutDelegate[t] ? (e = this.layoutDelegate[t](e), this.findNextNonDisabled(e, (i) => this.layoutDelegate[t](i))) : this.layout === "grid" ? this.orientation === "vertical" ? this.getNextColumn(e, this.direction === "rtl") : this.findKey(e, (i) => this.getNextColumn(i, this.direction === "rtl"), this.isSameColumn) : this.orientation === "horizontal" ? this.getNextColumn(e, this.direction === "rtl") : null;
  }
  getKeyLeftOf(e) {
    let t = this.direction === "ltr" ? "getKeyLeftOf" : "getKeyRightOf";
    return this.layoutDelegate[t] ? (e = this.layoutDelegate[t](e), this.findNextNonDisabled(e, (i) => this.layoutDelegate[t](i))) : this.layout === "grid" ? this.orientation === "vertical" ? this.getNextColumn(e, this.direction === "ltr") : this.findKey(e, (i) => this.getNextColumn(i, this.direction === "ltr"), this.isSameColumn) : this.orientation === "horizontal" ? this.getNextColumn(e, this.direction === "ltr") : null;
  }
  getFirstKey() {
    let e = this.collection.getFirstKey();
    return this.findNextNonDisabled(e, (t) => this.collection.getKeyAfter(t));
  }
  getLastKey() {
    let e = this.collection.getLastKey();
    return this.findNextNonDisabled(e, (t) => this.collection.getKeyBefore(t));
  }
  getKeyPageAbove(e) {
    let t = this.ref.current, i = this.layoutDelegate.getItemRect(e);
    if (!i) return null;
    if (t && !h(t)) return this.getFirstKey();
    let l = e;
    if (this.orientation === "horizontal") {
      let o = Math.max(0, i.x + i.width - this.layoutDelegate.getVisibleRect().width);
      for (; i && i.x > o && l != null; )
        l = this.getKeyAbove(l), i = l == null ? null : this.layoutDelegate.getItemRect(l);
    } else {
      let o = Math.max(0, i.y + i.height - this.layoutDelegate.getVisibleRect().height);
      for (; i && i.y > o && l != null; )
        l = this.getKeyAbove(l), i = l == null ? null : this.layoutDelegate.getItemRect(l);
    }
    return l ?? this.getFirstKey();
  }
  getKeyPageBelow(e) {
    let t = this.ref.current, i = this.layoutDelegate.getItemRect(e);
    if (!i) return null;
    if (t && !h(t)) return this.getLastKey();
    let l = e;
    if (this.orientation === "horizontal") {
      let o = Math.min(this.layoutDelegate.getContentSize().width, i.y - i.width + this.layoutDelegate.getVisibleRect().width);
      for (; i && i.x < o && l != null; )
        l = this.getKeyBelow(l), i = l == null ? null : this.layoutDelegate.getItemRect(l);
    } else {
      let o = Math.min(this.layoutDelegate.getContentSize().height, i.y - i.height + this.layoutDelegate.getVisibleRect().height);
      for (; i && i.y < o && l != null; )
        l = this.getKeyBelow(l), i = l == null ? null : this.layoutDelegate.getItemRect(l);
    }
    return l ?? this.getLastKey();
  }
  getKeyForSearch(e, t) {
    if (!this.collator) return null;
    let i = this.collection, l = t || this.getFirstKey();
    for (; l != null; ) {
      let o = i.getItem(l);
      if (!o) return null;
      let n = o.textValue.slice(0, e.length);
      if (o.textValue && this.collator.compare(n, e) === 0) return l;
      l = this.getNextKey(l);
    }
    return null;
  }
  constructor(...e) {
    if (e.length === 1) {
      let t = e[0];
      this.collection = t.collection, this.ref = t.ref, this.collator = t.collator, this.disabledKeys = t.disabledKeys || /* @__PURE__ */ new Set(), this.disabledBehavior = t.disabledBehavior || "all", this.orientation = t.orientation || "vertical", this.direction = t.direction, this.layout = t.layout || "stack", this.layoutDelegate = t.layoutDelegate || new u(t.ref);
    } else
      this.collection = e[0], this.disabledKeys = e[1], this.ref = e[2], this.collator = e[3], this.layout = "stack", this.orientation = "vertical", this.disabledBehavior = "all", this.layoutDelegate = new u(this.ref);
    this.layout === "stack" && this.orientation === "vertical" && (this.getKeyLeftOf = void 0, this.getKeyRightOf = void 0);
  }
}
function p(r) {
  let { selectionManager: e, collection: t, disabledKeys: i, ref: l, keyboardDelegate: o, layoutDelegate: n } = r, s = y({
    usage: "search",
    sensitivity: "base"
  }), a = e.disabledBehavior, c = K(() => o || new b({
    collection: t,
    disabledKeys: i,
    disabledBehavior: a,
    ref: l,
    collator: s,
    layoutDelegate: n
  }), [
    o,
    n,
    t,
    i,
    l,
    s,
    a
  ]), { collectionProps: g } = f({
    ...r,
    ref: l,
    selectionManager: e,
    keyboardDelegate: c
  });
  return {
    listProps: g
  };
}
export {
  b as $,
  p as a
};
