import { $ as x, b as D, d as w, a as y } from "./utils-DPfg4HqB.js";
import { a as F } from "./ProgressBar-Ct_89EKG.js";
import { $ as I } from "./Hidden-B52Gs8Ba.js";
import { $ as E } from "./filterDOMProps-D6KHYVBX.js";
import L, { createContext as N, useRef as O, useEffect as S } from "react";
import { a as V } from "./usePress-BKP_smFB.js";
import { $ as M, a as R } from "./useHover-r8IM8mvD.js";
import { $ as H } from "./useFocusRing-DTBeynF4.js";
function U(t, e) {
  let {
    elementType: i = "button",
    isDisabled: d,
    onPress: n,
    onPressStart: a,
    onPressEnd: r,
    onPressUp: v,
    onPressChange: l,
    preventFocusOnPress: $,
    allowFocusWhenDisabled: m,
    // @ts-ignore
    onClick: f,
    href: h,
    target: P,
    rel: u,
    type: c = "button"
  } = t, o;
  i === "button" ? o = {
    type: c,
    disabled: d
  } : o = {
    role: "button",
    href: i === "a" && !d ? h : void 0,
    target: i === "a" ? P : void 0,
    type: i === "input" ? c : void 0,
    disabled: i === "input" ? d : void 0,
    "aria-disabled": !d || i === "input" ? void 0 : d,
    rel: i === "a" ? u : void 0
  };
  let { pressProps: b, isPressed: p } = V({
    onPressStart: a,
    onPressEnd: r,
    onPressChange: l,
    onPress: n,
    onPressUp: v,
    isDisabled: d,
    preventFocusOnPress: $,
    ref: e
  }), { focusableProps: g } = M(t, e);
  m && (g.tabIndex = d ? -1 : g.tabIndex);
  let T = x(g, b, E(t, {
    labelable: !0
  }));
  return {
    isPressed: p,
    buttonProps: x(o, T, {
      "aria-haspopup": t["aria-haspopup"],
      "aria-expanded": t["aria-expanded"],
      "aria-controls": t["aria-controls"],
      "aria-pressed": t["aria-pressed"],
      "aria-current": t["aria-current"],
      onClick: (_) => {
        f && (f(_), console.warn("onClick is deprecated, please use onPress"));
      }
    })
  };
}
const A = 7e3;
let s = null;
function C(t, e = "assertive", i = A) {
  s ? s.announce(t, e, i) : (s = new k(), (typeof IS_REACT_ACT_ENVIRONMENT == "boolean" ? IS_REACT_ACT_ENVIRONMENT : typeof jest < "u") ? s.announce(t, e, i) : setTimeout(() => {
    s != null && s.isAttached() && (s == null || s.announce(t, e, i));
  }, 100));
}
function Z(t) {
  s && s.clear(t);
}
class k {
  isAttached() {
    var e;
    return (e = this.node) === null || e === void 0 ? void 0 : e.isConnected;
  }
  createLog(e) {
    let i = document.createElement("div");
    return i.setAttribute("role", "log"), i.setAttribute("aria-live", e), i.setAttribute("aria-relevant", "additions"), i;
  }
  destroy() {
    this.node && (document.body.removeChild(this.node), this.node = null);
  }
  announce(e, i = "assertive", d = A) {
    var n, a;
    if (!this.node) return;
    let r = document.createElement("div");
    typeof e == "object" ? (r.setAttribute("role", "img"), r.setAttribute("aria-labelledby", e["aria-labelledby"])) : r.textContent = e, i === "assertive" ? (n = this.assertiveLog) === null || n === void 0 || n.appendChild(r) : (a = this.politeLog) === null || a === void 0 || a.appendChild(r), e !== "" && setTimeout(() => {
      r.remove();
    }, d);
  }
  clear(e) {
    this.node && ((!e || e === "assertive") && this.assertiveLog && (this.assertiveLog.innerHTML = ""), (!e || e === "polite") && this.politeLog && (this.politeLog.innerHTML = ""));
  }
  constructor() {
    this.node = null, this.assertiveLog = null, this.politeLog = null, typeof document < "u" && (this.node = document.createElement("div"), this.node.dataset.liveAnnouncer = "true", Object.assign(this.node.style, {
      border: 0,
      clip: "rect(0 0 0 0)",
      clipPath: "inset(50%)",
      height: "1px",
      margin: "-1px",
      overflow: "hidden",
      padding: 0,
      position: "absolute",
      width: "1px",
      whiteSpace: "nowrap"
    }), this.assertiveLog = this.createLog("assertive"), this.node.appendChild(this.assertiveLog), this.politeLog = this.createLog("polite"), this.node.appendChild(this.politeLog), document.body.prepend(this.node));
  }
}
const j = /* @__PURE__ */ new Set([
  "form",
  "formAction",
  "formEncType",
  "formMethod",
  "formNoValidate",
  "formTarget",
  "name",
  "value"
]), B = /* @__PURE__ */ N({}), ee = /* @__PURE__ */ I(function(e, i) {
  [e, i] = D(e, i, B), e = K(e);
  let d = e, { isPending: n } = d, { buttonProps: a, isPressed: r } = U(e, i), { focusProps: v, isFocused: l, isFocusVisible: $ } = H(e), { hoverProps: m, isHovered: f } = R({
    ...e,
    isDisabled: e.isDisabled || n
  }), h = {
    isHovered: f,
    isPressed: (d.isPressed || r) && !n,
    isFocused: l,
    isFocusVisible: $,
    isDisabled: e.isDisabled || !1,
    isPending: n ?? !1
  }, P = w({
    ...e,
    values: h,
    defaultClassName: "react-aria-Button"
  }), u = y(a.id), c = y(), o = a["aria-labelledby"];
  n && (o ? o = `${o} ${c}` : a["aria-label"] && (o = `${u} ${c}`));
  let b = O(n);
  return S(() => {
    let p = {
      "aria-labelledby": o || u
    };
    (!b.current && l && n || b.current && l && !n) && C(p, "assertive"), b.current = n;
  }, [
    n,
    l,
    o,
    u
  ]), /* @__PURE__ */ L.createElement("button", {
    ...E(e, {
      propNames: j
    }),
    ...x(a, v, m),
    ...P,
    type: a.type === "submit" && n ? "button" : a.type,
    id: u,
    ref: i,
    "aria-labelledby": o,
    slot: e.slot || void 0,
    "aria-disabled": n ? "true" : a["aria-disabled"],
    "data-disabled": e.isDisabled || void 0,
    "data-pressed": h.isPressed || void 0,
    "data-hovered": f || void 0,
    "data-focused": l || void 0,
    "data-pending": n || void 0,
    "data-focus-visible": $ || void 0
  }, /* @__PURE__ */ L.createElement(F.Provider, {
    value: {
      id: c
    }
  }, P.children));
});
function K(t) {
  return t.isPending && (t.onPress = void 0, t.onPressStart = void 0, t.onPressEnd = void 0, t.onPressChange = void 0, t.onPressUp = void 0, t.onKeyDown = void 0, t.onKeyUp = void 0, t.onClick = void 0, t.href = void 0), t;
}
export {
  ee as $,
  B as a,
  U as b,
  C as c,
  Z as d
};
