import { b as _e } from "./Hidden-B52Gs8Ba.js";
import { createPortal as et, flushSync as tt } from "react-dom";
import { u as lt, b as it, s as Ve, d as pe, v as xe, w as nt, x as rt, t as ve, l as we } from "./useHover-r8IM8mvD.js";
import K, { useRef as k, useMemo as R, cloneElement as ot, forwardRef as Ne, useContext as q, createContext as H, useCallback as W, useState as _, useEffect as ee } from "react";
import { n as Se, $ as j, l as Ue, a as ze, j as Ce } from "./utils-DPfg4HqB.js";
import { a as qe, b as Ge, c as st } from "./usePress-BKP_smFB.js";
import { $ as Q } from "./useEvent-BRkcKkHt.js";
import { a as ut, $ as Ee } from "./scrollIntoView-DzN8eF1C.js";
import { $ as at } from "./FocusScope-B-R06ewx.js";
import { $ as ct } from "./context-DRz_xlLl.js";
import { $ as dt } from "./useDescription-DBX9pMU8.js";
import { $ as ft } from "./useControlledState-Kv9K2AYu.js";
function ke(n, e) {
  const t = k(!0), l = k(null);
  Se(() => (t.current = !0, () => {
    t.current = !1;
  }), []), Se(() => {
    t.current ? t.current = !1 : (!l.current || e.some((i, r) => !Object.is(i, l[r]))) && n(), l.current = e;
  }, e);
}
const ht = "react-aria-clear-focus", yt = "react-aria-focus";
function G(n) {
  return lt() ? n.metaKey : n.ctrlKey;
}
class ge {
  get childNodes() {
    throw new Error("childNodes is not supported");
  }
  clone() {
    let e = new ge(this.type, this.key);
    return e.value = this.value, e.level = this.level, e.hasChildNodes = this.hasChildNodes, e.rendered = this.rendered, e.textValue = this.textValue, e["aria-label"] = this["aria-label"], e.index = this.index, e.parentKey = this.parentKey, e.prevKey = this.prevKey, e.nextKey = this.nextKey, e.firstChildKey = this.firstChildKey, e.lastChildKey = this.lastChildKey, e.props = this.props, e.render = this.render, e.colSpan = this.colSpan, e.colIndex = this.colIndex, e;
  }
  constructor(e, t) {
    this.value = null, this.level = 0, this.hasChildNodes = !1, this.rendered = null, this.textValue = "", this["aria-label"] = void 0, this.index = 0, this.parentKey = null, this.prevKey = null, this.nextKey = null, this.firstChildKey = null, this.lastChildKey = null, this.props = {}, this.colSpan = null, this.colIndex = null, this.type = e, this.key = t;
  }
}
class $e {
  get size() {
    return this.keyMap.size;
  }
  getKeys() {
    return this.keyMap.keys();
  }
  *[Symbol.iterator]() {
    let e = this.firstKey != null ? this.keyMap.get(this.firstKey) : void 0;
    for (; e; )
      yield e, e = e.nextKey != null ? this.keyMap.get(e.nextKey) : void 0;
  }
  getChildren(e) {
    let t = this.keyMap;
    return {
      *[Symbol.iterator]() {
        let l = t.get(e), i = (l == null ? void 0 : l.firstChildKey) != null ? t.get(l.firstChildKey) : null;
        for (; i; )
          yield i, i = i.nextKey != null ? t.get(i.nextKey) : void 0;
      }
    };
  }
  getKeyBefore(e) {
    let t = this.keyMap.get(e);
    if (!t) return null;
    if (t.prevKey != null) {
      for (t = this.keyMap.get(t.prevKey); t && t.type !== "item" && t.lastChildKey != null; ) t = this.keyMap.get(t.lastChildKey);
      var l;
      return (l = t == null ? void 0 : t.key) !== null && l !== void 0 ? l : null;
    }
    return t.parentKey;
  }
  getKeyAfter(e) {
    let t = this.keyMap.get(e);
    if (!t) return null;
    if (t.type !== "item" && t.firstChildKey != null) return t.firstChildKey;
    for (; t; ) {
      if (t.nextKey != null) return t.nextKey;
      if (t.parentKey != null) t = this.keyMap.get(t.parentKey);
      else return null;
    }
    return null;
  }
  getFirstKey() {
    return this.firstKey;
  }
  getLastKey() {
    let e = this.lastKey != null ? this.keyMap.get(this.lastKey) : null;
    for (; (e == null ? void 0 : e.lastChildKey) != null; ) e = this.keyMap.get(e.lastChildKey);
    var t;
    return (t = e == null ? void 0 : e.key) !== null && t !== void 0 ? t : null;
  }
  getItem(e) {
    var t;
    return (t = this.keyMap.get(e)) !== null && t !== void 0 ? t : null;
  }
  at() {
    throw new Error("Not implemented");
  }
  clone() {
    let e = this.constructor, t = new e();
    return t.keyMap = new Map(this.keyMap), t.firstKey = this.firstKey, t.lastKey = this.lastKey, t;
  }
  addNode(e) {
    if (this.frozen) throw new Error("Cannot add a node to a frozen collection");
    this.keyMap.set(e.key, e);
  }
  removeNode(e) {
    if (this.frozen) throw new Error("Cannot remove a node to a frozen collection");
    this.keyMap.delete(e);
  }
  commit(e, t, l = !1) {
    if (this.frozen) throw new Error("Cannot commit a frozen collection");
    this.firstKey = e, this.lastKey = t, this.frozen = !l;
  }
  // TODO: this is pretty specific to menu, will need to check if it is generic enough
  // Will need to handle varying levels I assume but will revisit after I get searchable menu working for base menu
  // TODO: an alternative is to simply walk the collection and add all item nodes that match the filter and any sections/separators we encounter
  // to an array, then walk that new array and fix all the next/Prev keys while adding them to the new collection
  UNSTABLE_filter(e) {
    let t = new $e(), l = null;
    for (let i of this)
      if (i.type === "section" && i.hasChildNodes) {
        let r = i.clone(), o = null;
        for (let c of this.getChildren(i.key)) if (De(c, e, this, t)) {
          let s = c.clone();
          o == null && (r.firstChildKey = s.key), t.firstKey == null && (t.firstKey = r.key), o && o.parentKey === s.parentKey ? (o.nextKey = s.key, s.prevKey = o.key) : s.prevKey = null, s.nextKey = null, t.addNode(s), o = s;
        }
        o && (o.type !== "header" ? (r.lastChildKey = o.key, l == null ? r.prevKey = null : (l.type === "section" || l.type === "separator") && (l.nextKey = r.key, r.prevKey = l.key), r.nextKey = null, l = r, t.addNode(r)) : (t.firstKey === r.key && (t.firstKey = null), t.removeNode(o.key)));
      } else if (i.type === "separator") {
        let r = i.clone();
        r.nextKey = null, (l == null ? void 0 : l.type) === "section" && (l.nextKey = r.key, r.prevKey = l.key, l = r, t.addNode(r));
      } else {
        let r = i.clone();
        De(r, e, this, t) && (t.firstKey == null && (t.firstKey = r.key), l != null && l.type !== "section" && l.type !== "separator" && l.parentKey === r.parentKey ? (l.nextKey = r.key, r.prevKey = l.key) : r.prevKey = null, r.nextKey = null, t.addNode(r), l = r);
      }
    if ((l == null ? void 0 : l.type) === "separator" && l.nextKey === null) {
      let i;
      l.prevKey != null && (i = t.getItem(l.prevKey), i.nextKey = null), t.removeNode(l.key), l = i;
    }
    return t.lastKey = (l == null ? void 0 : l.key) || null, t;
  }
  constructor() {
    this.keyMap = /* @__PURE__ */ new Map(), this.firstKey = null, this.lastKey = null, this.frozen = !1;
  }
}
function De(n, e, t, l) {
  if (n.type === "subdialogtrigger" || n.type === "submenutrigger") {
    let i = [
      ...t.getChildren(n.key)
    ][0];
    if (i && e(i.textValue)) {
      let r = i.clone();
      return l.addNode(r), !0;
    } else return !1;
  } else return n.type === "header" ? !0 : e(n.textValue);
}
class He {
  *[Symbol.iterator]() {
    let e = this.firstChild;
    for (; e; )
      yield e, e = e.nextSibling;
  }
  get firstChild() {
    return this._firstChild;
  }
  set firstChild(e) {
    this._firstChild = e, this.ownerDocument.markDirty(this);
  }
  get lastChild() {
    return this._lastChild;
  }
  set lastChild(e) {
    this._lastChild = e, this.ownerDocument.markDirty(this);
  }
  get previousSibling() {
    return this._previousSibling;
  }
  set previousSibling(e) {
    this._previousSibling = e, this.ownerDocument.markDirty(this);
  }
  get nextSibling() {
    return this._nextSibling;
  }
  set nextSibling(e) {
    this._nextSibling = e, this.ownerDocument.markDirty(this);
  }
  get parentNode() {
    return this._parentNode;
  }
  set parentNode(e) {
    this._parentNode = e, this.ownerDocument.markDirty(this);
  }
  get isConnected() {
    var e;
    return ((e = this.parentNode) === null || e === void 0 ? void 0 : e.isConnected) || !1;
  }
  appendChild(e) {
    this.ownerDocument.startTransaction(), e.parentNode && e.parentNode.removeChild(e), this.firstChild == null && (this.firstChild = e), this.lastChild ? (this.lastChild.nextSibling = e, e.index = this.lastChild.index + 1, e.previousSibling = this.lastChild) : (e.previousSibling = null, e.index = 0), e.parentNode = this, e.nextSibling = null, this.lastChild = e, this.ownerDocument.markDirty(this), e.hasSetProps && this.ownerDocument.addNode(e), this.ownerDocument.endTransaction(), this.ownerDocument.queueUpdate();
  }
  insertBefore(e, t) {
    if (t == null) return this.appendChild(e);
    this.ownerDocument.startTransaction(), e.parentNode && e.parentNode.removeChild(e), e.nextSibling = t, e.previousSibling = t.previousSibling, e.index = t.index, this.firstChild === t ? this.firstChild = e : t.previousSibling && (t.previousSibling.nextSibling = e), t.previousSibling = e, e.parentNode = t.parentNode;
    let l = t;
    for (; l; )
      l.index++, l = l.nextSibling;
    e.hasSetProps && this.ownerDocument.addNode(e), this.ownerDocument.endTransaction(), this.ownerDocument.queueUpdate();
  }
  removeChild(e) {
    if (e.parentNode !== this || !this.ownerDocument.isMounted) return;
    this.ownerDocument.startTransaction();
    let t = e.nextSibling;
    for (; t; )
      t.index--, t = t.nextSibling;
    e.nextSibling && (e.nextSibling.previousSibling = e.previousSibling), e.previousSibling && (e.previousSibling.nextSibling = e.nextSibling), this.firstChild === e && (this.firstChild = e.nextSibling), this.lastChild === e && (this.lastChild = e.previousSibling), e.parentNode = null, e.nextSibling = null, e.previousSibling = null, e.index = 0, this.ownerDocument.removeNode(e), this.ownerDocument.endTransaction(), this.ownerDocument.queueUpdate();
  }
  addEventListener() {
  }
  removeEventListener() {
  }
  constructor(e) {
    this._firstChild = null, this._lastChild = null, this._previousSibling = null, this._nextSibling = null, this._parentNode = null, this.ownerDocument = e;
  }
}
class Y extends He {
  get index() {
    return this._index;
  }
  set index(e) {
    this._index = e, this.ownerDocument.markDirty(this);
  }
  get level() {
    return this.parentNode instanceof Y ? this.parentNode.level + (this.node.type === "item" ? 1 : 0) : 0;
  }
  updateNode() {
    var e, t, l, i;
    let r = this.ownerDocument.getMutableNode(this);
    r.index = this.index, r.level = this.level, r.parentKey = this.parentNode instanceof Y ? this.parentNode.node.key : null;
    var o;
    r.prevKey = (o = (e = this.previousSibling) === null || e === void 0 ? void 0 : e.node.key) !== null && o !== void 0 ? o : null;
    var c;
    r.nextKey = (c = (t = this.nextSibling) === null || t === void 0 ? void 0 : t.node.key) !== null && c !== void 0 ? c : null, r.hasChildNodes = !!this.firstChild;
    var s;
    r.firstChildKey = (s = (l = this.firstChild) === null || l === void 0 ? void 0 : l.node.key) !== null && s !== void 0 ? s : null;
    var S;
    if (r.lastChildKey = (S = (i = this.lastChild) === null || i === void 0 ? void 0 : i.node.key) !== null && S !== void 0 ? S : null, (r.colSpan != null || r.colIndex != null) && this.nextSibling) {
      var g, h;
      let f = ((g = r.colIndex) !== null && g !== void 0 ? g : r.index) + ((h = r.colSpan) !== null && h !== void 0 ? h : 1);
      if (f !== this.nextSibling.node.colIndex) {
        let d = this.ownerDocument.getMutableNode(this.nextSibling);
        d.colIndex = f;
      }
    }
  }
  setProps(e, t, l, i) {
    let r = this.ownerDocument.getMutableNode(this), { value: o, textValue: c, id: s, ...S } = e;
    if (S.ref = t, r.props = S, r.rendered = l, r.render = i, r.value = o, r.textValue = c || (typeof S.children == "string" ? S.children : "") || e["aria-label"] || "", s != null && s !== r.key) {
      if (this.hasSetProps) throw new Error("Cannot change the id of an item");
      r.key = s;
    }
    S.colSpan != null && (r.colSpan = S.colSpan), this.hasSetProps || (this.ownerDocument.addNode(this), this.ownerDocument.endTransaction(), this.hasSetProps = !0), this.ownerDocument.queueUpdate();
  }
  get style() {
    return {};
  }
  hasAttribute() {
  }
  setAttribute() {
  }
  setAttributeNS() {
  }
  removeAttribute() {
  }
  constructor(e, t) {
    super(t), this.nodeType = 8, this._index = 0, this.hasSetProps = !1, this.node = new ge(e, `react-aria-${++t.nodeId}`), this.ownerDocument.startTransaction();
  }
}
class pt extends He {
  get isConnected() {
    return this.isMounted;
  }
  createElement(e) {
    return new Y(e, this);
  }
  /**
  * Lazily gets a mutable instance of a Node. If the node has already
  * been cloned during this update cycle, it just returns the existing one.
  */
  getMutableNode(e) {
    let t = e.node;
    return this.mutatedNodes.has(e) || (t = e.node.clone(), this.mutatedNodes.add(e), e.node = t), this.markDirty(e), t;
  }
  getMutableCollection() {
    return !this.isSSR && !this.collectionMutated && (this.collection = this.collection.clone(), this.collectionMutated = !0), this.collection;
  }
  markDirty(e) {
    this.dirtyNodes.add(e);
  }
  startTransaction() {
    this.transactionCount++;
  }
  endTransaction() {
    this.transactionCount--;
  }
  addNode(e) {
    let t = this.getMutableCollection();
    if (!t.getItem(e.node.key)) {
      t.addNode(e.node);
      for (let l of e) this.addNode(l);
    }
    this.markDirty(e);
  }
  removeNode(e) {
    for (let l of e) this.removeNode(l);
    this.getMutableCollection().removeNode(e.node.key), this.markDirty(e);
  }
  /** Finalizes the collection update, updating all nodes and freezing the collection. */
  getCollection() {
    return this.transactionCount > 0 ? this.collection : (this.updateCollection(), this.collection);
  }
  updateCollection() {
    for (let r of this.dirtyNodes) r instanceof Y && r.isConnected && r.updateNode();
    if (this.dirtyNodes.clear(), this.mutatedNodes.size || this.collectionMutated) {
      var e, t;
      let r = this.getMutableCollection();
      for (let o of this.mutatedNodes) o.isConnected && r.addNode(o.node);
      this.mutatedNodes.clear();
      var l, i;
      r.commit((l = (e = this.firstChild) === null || e === void 0 ? void 0 : e.node.key) !== null && l !== void 0 ? l : null, (i = (t = this.lastChild) === null || t === void 0 ? void 0 : t.node.key) !== null && i !== void 0 ? i : null, this.isSSR);
    }
    this.collectionMutated = !1;
  }
  queueUpdate() {
    if (!(this.dirtyNodes.size === 0 || this.transactionCount > 0))
      for (let e of this.subscriptions) e();
  }
  subscribe(e) {
    return this.subscriptions.add(e), () => this.subscriptions.delete(e);
  }
  resetAfterSSR() {
    this.isSSR && (this.isSSR = !1, this.firstChild = null, this.lastChild = null, this.nodeId = 0);
  }
  constructor(e) {
    super(null), this.nodeType = 11, this.ownerDocument = this, this.dirtyNodes = /* @__PURE__ */ new Set(), this.isSSR = !1, this.nodeId = 0, this.nodesByProps = /* @__PURE__ */ new WeakMap(), this.isMounted = !0, this.mutatedNodes = /* @__PURE__ */ new Set(), this.subscriptions = /* @__PURE__ */ new Set(), this.transactionCount = 0, this.collection = e, this.collectionMutated = !0;
  }
}
function We(n) {
  let { children: e, items: t, idScope: l, addIdAndValue: i, dependencies: r = [] } = n, o = R(() => /* @__PURE__ */ new WeakMap(), r);
  return R(() => {
    if (t && typeof e == "function") {
      let S = [];
      for (let g of t) {
        let h = o.get(g);
        if (!h) {
          h = e(g);
          var c, s;
          let f = (s = (c = h.props.id) !== null && c !== void 0 ? c : g.key) !== null && s !== void 0 ? s : g.id;
          if (f == null) throw new Error("Could not determine key for item");
          l && (f = l + ":" + f), h = ot(h, i ? {
            key: f,
            id: f,
            value: g
          } : {
            key: f
          }), o.set(g, h);
        }
        S.push(h);
      }
      return S;
    } else if (typeof e != "function") return e;
  }, [
    e,
    t,
    o,
    l,
    i
  ]);
}
const vt = 500;
function St(n) {
  let { isDisabled: e, onLongPressStart: t, onLongPressEnd: l, onLongPress: i, threshold: r = vt, accessibilityDescription: o } = n;
  const c = k(void 0);
  let { addGlobalListener: s, removeGlobalListener: S } = it(), { pressProps: g } = qe({
    isDisabled: e,
    onPressStart(f) {
      if (f.continuePropagation(), (f.pointerType === "mouse" || f.pointerType === "touch") && (t && t({
        ...f,
        type: "longpressstart"
      }), c.current = setTimeout(() => {
        f.target.dispatchEvent(new PointerEvent("pointercancel", {
          bubbles: !0
        })), Ve(f.target).activeElement !== f.target && pe(f.target), i && i({
          ...f,
          type: "longpress"
        }), c.current = void 0;
      }, r), f.pointerType === "touch")) {
        let d = (v) => {
          v.preventDefault();
        };
        s(f.target, "contextmenu", d, {
          once: !0
        }), s(window, "pointerup", () => {
          setTimeout(() => {
            S(f.target, "contextmenu", d);
          }, 30);
        }, {
          once: !0
        });
      }
    },
    onPressEnd(f) {
      c.current && clearTimeout(c.current), l && (f.pointerType === "mouse" || f.pointerType === "touch") && l({
        ...f,
        type: "longpressend"
      });
    }
  }), h = dt(i && !e ? o : void 0);
  return {
    longPressProps: j(g, h)
  };
}
var X = { exports: {} }, ce = {};
/**
 * @license React
 * use-sync-external-store-shim.production.js
 *
 * Copyright (c) Meta Platforms, Inc. and affiliates.
 *
 * This source code is licensed under the MIT license found in the
 * LICENSE file in the root directory of this source tree.
 */
var Pe;
function mt() {
  if (Pe) return ce;
  Pe = 1;
  var n = K;
  function e(h, f) {
    return h === f && (h !== 0 || 1 / h === 1 / f) || h !== h && f !== f;
  }
  var t = typeof Object.is == "function" ? Object.is : e, l = n.useState, i = n.useEffect, r = n.useLayoutEffect, o = n.useDebugValue;
  function c(h, f) {
    var d = f(), v = l({ inst: { value: d, getSnapshot: f } }), $ = v[0].inst, m = v[1];
    return r(
      function() {
        $.value = d, $.getSnapshot = f, s($) && m({ inst: $ });
      },
      [h, d, f]
    ), i(
      function() {
        return s($) && m({ inst: $ }), h(function() {
          s($) && m({ inst: $ });
        });
      },
      [h]
    ), o(d), d;
  }
  function s(h) {
    var f = h.getSnapshot;
    h = h.value;
    try {
      var d = f();
      return !t(h, d);
    } catch {
      return !0;
    }
  }
  function S(h, f) {
    return f();
  }
  var g = typeof window > "u" || typeof window.document > "u" || typeof window.document.createElement > "u" ? S : c;
  return ce.useSyncExternalStore = n.useSyncExternalStore !== void 0 ? n.useSyncExternalStore : g, ce;
}
var de = {};
/**
 * @license React
 * use-sync-external-store-shim.development.js
 *
 * Copyright (c) Meta Platforms, Inc. and affiliates.
 *
 * This source code is licensed under the MIT license found in the
 * LICENSE file in the root directory of this source tree.
 */
var Te;
function bt() {
  return Te || (Te = 1, process.env.NODE_ENV !== "production" && function() {
    function n(d, v) {
      return d === v && (d !== 0 || 1 / d === 1 / v) || d !== d && v !== v;
    }
    function e(d, v) {
      g || i.startTransition === void 0 || (g = !0, console.error(
        "You are using an outdated, pre-release alpha of React 18 that does not support useSyncExternalStore. The use-sync-external-store shim will not work correctly. Upgrade to a newer pre-release."
      ));
      var $ = v();
      if (!h) {
        var m = v();
        r($, m) || (console.error(
          "The result of getSnapshot should be cached to avoid an infinite loop"
        ), h = !0);
      }
      m = o({
        inst: { value: $, getSnapshot: v }
      });
      var p = m[0].inst, w = m[1];
      return s(
        function() {
          p.value = $, p.getSnapshot = v, t(p) && w({ inst: p });
        },
        [d, $, v]
      ), c(
        function() {
          return t(p) && w({ inst: p }), d(function() {
            t(p) && w({ inst: p });
          });
        },
        [d]
      ), S($), $;
    }
    function t(d) {
      var v = d.getSnapshot;
      d = d.value;
      try {
        var $ = v();
        return !r(d, $);
      } catch {
        return !0;
      }
    }
    function l(d, v) {
      return v();
    }
    typeof __REACT_DEVTOOLS_GLOBAL_HOOK__ < "u" && typeof __REACT_DEVTOOLS_GLOBAL_HOOK__.registerInternalModuleStart == "function" && __REACT_DEVTOOLS_GLOBAL_HOOK__.registerInternalModuleStart(Error());
    var i = K, r = typeof Object.is == "function" ? Object.is : n, o = i.useState, c = i.useEffect, s = i.useLayoutEffect, S = i.useDebugValue, g = !1, h = !1, f = typeof window > "u" || typeof window.document > "u" || typeof window.document.createElement > "u" ? l : e;
    de.useSyncExternalStore = i.useSyncExternalStore !== void 0 ? i.useSyncExternalStore : f, typeof __REACT_DEVTOOLS_GLOBAL_HOOK__ < "u" && typeof __REACT_DEVTOOLS_GLOBAL_HOOK__.registerInternalModuleStop == "function" && __REACT_DEVTOOLS_GLOBAL_HOOK__.registerInternalModuleStop(Error());
  }()), de;
}
var Me;
function gt() {
  return Me || (Me = 1, process.env.NODE_ENV === "production" ? X.exports = mt() : X.exports = bt()), X.exports;
}
var $t = gt();
const je = /* @__PURE__ */ H(!1), Z = /* @__PURE__ */ H(null);
function el(n) {
  if (q(Z))
    return n.content;
  let { collection: t, document: l } = Ct(n.createCollection);
  return /* @__PURE__ */ K.createElement(K.Fragment, null, /* @__PURE__ */ K.createElement(_e, null, /* @__PURE__ */ K.createElement(Z.Provider, {
    value: l
  }, n.content)), /* @__PURE__ */ K.createElement(Kt, {
    render: n.children,
    collection: t
  }));
}
function Kt({ collection: n, render: e }) {
  return e(n);
}
function xt(n, e, t) {
  let l = Ue(), i = k(l);
  i.current = l;
  let r = W(() => i.current ? t() : e(), [
    e,
    t
  ]);
  return $t.useSyncExternalStore(n, r);
}
const wt = typeof K.useSyncExternalStore == "function" ? K.useSyncExternalStore : xt;
function Ct(n) {
  let [e] = _(() => new pt((n == null ? void 0 : n()) || new $e())), t = W((o) => e.subscribe(o), [
    e
  ]), l = W(() => {
    let o = e.getCollection();
    return e.isSSR && e.resetAfterSSR(), o;
  }, [
    e
  ]), i = W(() => (e.isSSR = !0, e.getCollection()), [
    e
  ]), r = wt(t, l, i);
  return Se(() => (e.isMounted = !0, () => {
    e.isMounted = !1;
  }), [
    e
  ]), {
    collection: r,
    document: e
  };
}
const me = /* @__PURE__ */ H(null);
function Ye(n, e, t, l, i, r) {
  let o = W((s) => {
    s == null || s.setProps(e, t, l, r);
  }, [
    e,
    t,
    l,
    r
  ]), c = q(me);
  if (c) {
    let s = c.ownerDocument.nodesByProps.get(e);
    return s || (s = c.ownerDocument.createElement(n), s.setProps(e, t, l, r), c.appendChild(s), c.ownerDocument.updateCollection(), c.ownerDocument.nodesByProps.set(e, s)), i ? /* @__PURE__ */ K.createElement(me.Provider, {
      value: s
    }, i) : null;
  }
  return /* @__PURE__ */ K.createElement(n, {
    ref: o
  }, i);
}
function tl(n, e) {
  let t = ({ node: i }) => e(i.props, i.props.ref, i), l = Ne((i, r) => {
    let o = q(xe);
    if (!q(je)) {
      if (e.length >= 3) throw new Error(e.name + " cannot be rendered outside a collection.");
      return e(i, r);
    }
    return Ye(n, i, r, "children" in i ? i.children : null, null, (s) => (
      // Forward FocusableContext to real DOM tree so tooltips work.
      /* @__PURE__ */ K.createElement(xe.Provider, {
        value: o
      }, /* @__PURE__ */ K.createElement(t, {
        node: s
      }))
    ));
  });
  return l.displayName = e.name, l;
}
function ll(n, e, t = Ze) {
  let l = ({ node: r }) => e(r.props, r.props.ref, r), i = Ne((r, o) => {
    let c = t(r);
    var s;
    return (s = Ye(n, r, o, null, c, (S) => /* @__PURE__ */ K.createElement(l, {
      node: S
    }))) !== null && s !== void 0 ? s : /* @__PURE__ */ K.createElement(K.Fragment, null);
  });
  return i.displayName = e.name, i;
}
function Ze(n) {
  return We({
    ...n,
    addIdAndValue: !0
  });
}
const Fe = /* @__PURE__ */ H(null);
function il(n) {
  let e = q(Fe), t = ((e == null ? void 0 : e.dependencies) || []).concat(n.dependencies), l = n.idScope || (e == null ? void 0 : e.idScope), i = Ze({
    ...n,
    idScope: l,
    dependencies: t
  });
  return q(Z) && (i = /* @__PURE__ */ K.createElement(Et, null, i)), e = R(() => ({
    dependencies: t,
    idScope: l
  }), [
    l,
    ...t
  ]), /* @__PURE__ */ K.createElement(Fe.Provider, {
    value: e
  }, i);
}
function Et({ children: n }) {
  let e = q(Z), t = R(() => /* @__PURE__ */ K.createElement(Z.Provider, {
    value: null
  }, /* @__PURE__ */ K.createElement(je.Provider, {
    value: !0
  }, n)), [
    n
  ]);
  return Ue() ? /* @__PURE__ */ K.createElement(me.Provider, {
    value: e
  }, t) : /* @__PURE__ */ et(t, e);
}
function Je(n) {
  let e = Pt(Ve(n));
  e !== n && (e && kt(e, n), n && Dt(n, e));
}
function kt(n, e) {
  n.dispatchEvent(new FocusEvent("blur", {
    relatedTarget: e
  })), n.dispatchEvent(new FocusEvent("focusout", {
    bubbles: !0,
    relatedTarget: e
  }));
}
function Dt(n, e) {
  n.dispatchEvent(new FocusEvent("focus", {
    relatedTarget: e
  })), n.dispatchEvent(new FocusEvent("focusin", {
    bubbles: !0,
    relatedTarget: e
  }));
}
function Pt(n) {
  let e = nt(n), t = e == null ? void 0 : e.getAttribute("aria-activedescendant");
  return t && n.getElementById(t) || e;
}
function be(n) {
  return rt() ? n.altKey : n.ctrlKey;
}
function fe(n, e) {
  var t, l;
  let i = `[data-key="${CSS.escape(String(e))}"]`, r = (t = n.current) === null || t === void 0 ? void 0 : t.dataset.collection;
  return r && (i = `[data-collection="${CSS.escape(r)}"]${i}`), (l = n.current) === null || l === void 0 ? void 0 : l.querySelector(i);
}
const Qe = /* @__PURE__ */ new WeakMap();
function Tt(n) {
  let e = ze();
  return Qe.set(n, e), e;
}
function Mt(n) {
  return Qe.get(n);
}
const Ft = 1e3;
function At(n) {
  let { keyboardDelegate: e, selectionManager: t, onTypeSelect: l } = n, i = k({
    search: "",
    timeout: void 0
  }).current, r = (o) => {
    let c = It(o.key);
    if (!(!c || o.ctrlKey || o.metaKey || !o.currentTarget.contains(o.target))) {
      if (c === " " && i.search.trim().length > 0 && (o.preventDefault(), "continuePropagation" in o || o.stopPropagation()), i.search += c, e.getKeyForSearch != null) {
        let s = e.getKeyForSearch(i.search, t.focusedKey);
        s == null && (s = e.getKeyForSearch(i.search)), s != null && (t.setFocusedKey(s), l && l(s));
      }
      clearTimeout(i.timeout), i.timeout = setTimeout(() => {
        i.search = "";
      }, Ft);
    }
  };
  return {
    typeSelectProps: {
      // Using a capturing listener to catch the keydown event before
      // other hooks in order to handle the Spacebar event.
      onKeyDownCapture: e.getKeyForSearch ? r : void 0
    }
  };
}
function It(n) {
  return n.length === 1 || !/^[A-Z]/i.test(n) ? n : "";
}
function nl(n) {
  let { selectionManager: e, keyboardDelegate: t, ref: l, autoFocus: i = !1, shouldFocusWrap: r = !1, disallowEmptySelection: o = !1, disallowSelectAll: c = !1, selectOnFocus: s = e.selectionBehavior === "replace", disallowTypeAhead: S = !1, shouldUseVirtualFocus: g, allowsTabNavigation: h = !1, isVirtualized: f, scrollRef: d = l, linkBehavior: v = "action" } = n, { direction: $ } = ct(), m = Ge(), p = (a) => {
    var b;
    if (a.altKey && a.key === "Tab" && a.preventDefault(), !(!((b = l.current) === null || b === void 0) && b.contains(a.target))) return;
    const C = (y, U) => {
      if (y != null) {
        if (e.isLink(y) && v === "selection" && s && !be(a)) {
          tt(() => {
            e.setFocusedKey(y, U);
          });
          let z = fe(l, y), Ke = e.getItemProps(y);
          z && m.open(z, a, Ke.href, Ke.routerOptions);
          return;
        }
        if (e.setFocusedKey(y, U), e.isLink(y) && v === "override") return;
        a.shiftKey && e.selectionMode === "multiple" ? e.extendSelection(y) : s && !be(a) && e.replaceSelection(y);
      }
    };
    switch (a.key) {
      case "ArrowDown":
        if (t.getKeyBelow) {
          var u, E, F;
          let y = e.focusedKey != null ? (u = t.getKeyBelow) === null || u === void 0 ? void 0 : u.call(t, e.focusedKey) : (E = t.getFirstKey) === null || E === void 0 ? void 0 : E.call(t);
          y == null && r && (y = (F = t.getFirstKey) === null || F === void 0 ? void 0 : F.call(t, e.focusedKey)), y != null && (a.preventDefault(), C(y));
        }
        break;
      case "ArrowUp":
        if (t.getKeyAbove) {
          var O, V, ie;
          let y = e.focusedKey != null ? (O = t.getKeyAbove) === null || O === void 0 ? void 0 : O.call(t, e.focusedKey) : (V = t.getLastKey) === null || V === void 0 ? void 0 : V.call(t);
          y == null && r && (y = (ie = t.getLastKey) === null || ie === void 0 ? void 0 : ie.call(t, e.focusedKey)), y != null && (a.preventDefault(), C(y));
        }
        break;
      case "ArrowLeft":
        if (t.getKeyLeftOf) {
          var ne, re, oe;
          let y = e.focusedKey != null ? (ne = t.getKeyLeftOf) === null || ne === void 0 ? void 0 : ne.call(t, e.focusedKey) : null;
          y == null && r && (y = $ === "rtl" ? (re = t.getFirstKey) === null || re === void 0 ? void 0 : re.call(t, e.focusedKey) : (oe = t.getLastKey) === null || oe === void 0 ? void 0 : oe.call(t, e.focusedKey)), y != null && (a.preventDefault(), C(y, $ === "rtl" ? "first" : "last"));
        }
        break;
      case "ArrowRight":
        if (t.getKeyRightOf) {
          var se, ue, ae;
          let y = e.focusedKey != null ? (se = t.getKeyRightOf) === null || se === void 0 ? void 0 : se.call(t, e.focusedKey) : null;
          y == null && r && (y = $ === "rtl" ? (ue = t.getLastKey) === null || ue === void 0 ? void 0 : ue.call(t, e.focusedKey) : (ae = t.getFirstKey) === null || ae === void 0 ? void 0 : ae.call(t, e.focusedKey)), y != null && (a.preventDefault(), C(y, $ === "rtl" ? "last" : "first"));
        }
        break;
      case "Home":
        if (t.getFirstKey) {
          if (e.focusedKey === null && a.shiftKey) return;
          a.preventDefault();
          let y = t.getFirstKey(e.focusedKey, G(a));
          e.setFocusedKey(y), y != null && (G(a) && a.shiftKey && e.selectionMode === "multiple" ? e.extendSelection(y) : s && e.replaceSelection(y));
        }
        break;
      case "End":
        if (t.getLastKey) {
          if (e.focusedKey === null && a.shiftKey) return;
          a.preventDefault();
          let y = t.getLastKey(e.focusedKey, G(a));
          e.setFocusedKey(y), y != null && (G(a) && a.shiftKey && e.selectionMode === "multiple" ? e.extendSelection(y) : s && e.replaceSelection(y));
        }
        break;
      case "PageDown":
        if (t.getKeyPageBelow && e.focusedKey != null) {
          let y = t.getKeyPageBelow(e.focusedKey);
          y != null && (a.preventDefault(), C(y));
        }
        break;
      case "PageUp":
        if (t.getKeyPageAbove && e.focusedKey != null) {
          let y = t.getKeyPageAbove(e.focusedKey);
          y != null && (a.preventDefault(), C(y));
        }
        break;
      case "a":
        G(a) && e.selectionMode === "multiple" && c !== !0 && (a.preventDefault(), e.selectAll());
        break;
      case "Escape":
        !o && e.selectedKeys.size !== 0 && (a.stopPropagation(), a.preventDefault(), e.clearSelection());
        break;
      case "Tab":
        if (!h) {
          if (a.shiftKey) l.current.focus();
          else {
            let y = at(l.current, {
              tabbable: !0
            }), U, z;
            do
              z = y.lastChild(), z && (U = z);
            while (z);
            U && !U.contains(document.activeElement) && pe(U);
          }
          break;
        }
    }
  }, w = k({
    top: 0,
    left: 0
  });
  Q(d, "scroll", f ? void 0 : () => {
    var a, b, C, u;
    w.current = {
      top: (C = (a = d.current) === null || a === void 0 ? void 0 : a.scrollTop) !== null && C !== void 0 ? C : 0,
      left: (u = (b = d.current) === null || b === void 0 ? void 0 : b.scrollLeft) !== null && u !== void 0 ? u : 0
    };
  });
  let x = (a) => {
    if (e.isFocused) {
      a.currentTarget.contains(a.target) || e.setFocused(!1);
      return;
    }
    if (a.currentTarget.contains(a.target)) {
      if (e.setFocused(!0), e.focusedKey == null) {
        var b, C;
        let F = (V) => {
          V != null && (e.setFocusedKey(V), s && !e.isSelected(V) && e.replaceSelection(V));
        }, O = a.relatedTarget;
        var u, E;
        O && a.currentTarget.compareDocumentPosition(O) & Node.DOCUMENT_POSITION_FOLLOWING ? F((u = e.lastSelectedKey) !== null && u !== void 0 ? u : (b = t.getLastKey) === null || b === void 0 ? void 0 : b.call(t)) : F((E = e.firstSelectedKey) !== null && E !== void 0 ? E : (C = t.getFirstKey) === null || C === void 0 ? void 0 : C.call(t));
      } else !f && d.current && (d.current.scrollTop = w.current.top, d.current.scrollLeft = w.current.left);
      if (e.focusedKey != null && d.current) {
        let F = fe(l, e.focusedKey);
        F instanceof HTMLElement && (!F.contains(document.activeElement) && !g && pe(F), we() === "keyboard" && Ee(F, {
          containingElement: l.current
        }));
      }
    }
  }, D = (a) => {
    a.currentTarget.contains(a.relatedTarget) || e.setFocused(!1);
  }, P = k(!1);
  Q(l, yt, g ? (a) => {
    let { detail: b } = a;
    a.stopPropagation(), e.setFocused(!0), (b == null ? void 0 : b.focusStrategy) === "first" && (P.current = !0);
  } : void 0);
  let L = Ce(() => {
    var a, b;
    let C = (b = (a = t.getFirstKey) === null || a === void 0 ? void 0 : a.call(t)) !== null && b !== void 0 ? b : null;
    C == null ? (Je(l.current), e.collection.size > 0 && (P.current = !1)) : (e.setFocusedKey(C), P.current = !1);
  });
  ke(() => {
    P.current && L();
  }, [
    e.collection,
    L
  ]);
  let I = Ce(() => {
    e.collection.size > 0 && (P.current = !1);
  });
  ke(() => {
    I();
  }, [
    e.focusedKey,
    I
  ]), Q(l, ht, g ? (a) => {
    var b;
    a.stopPropagation(), e.setFocused(!1), !((b = a.detail) === null || b === void 0) && b.clearFocusKey && e.setFocusedKey(null);
  } : void 0);
  const T = k(i), N = k(!1);
  ee(() => {
    if (T.current) {
      var a, b;
      let E = null;
      var C;
      i === "first" && (E = (C = (a = t.getFirstKey) === null || a === void 0 ? void 0 : a.call(t)) !== null && C !== void 0 ? C : null);
      var u;
      i === "last" && (E = (u = (b = t.getLastKey) === null || b === void 0 ? void 0 : b.call(t)) !== null && u !== void 0 ? u : null);
      let F = e.selectedKeys;
      if (F.size) {
        for (let O of F) if (e.canSelectItem(O)) {
          E = O;
          break;
        }
      }
      e.setFocused(!0), e.setFocusedKey(E), E == null && !g && l.current && ve(l.current), e.collection.size > 0 && (T.current = !1, N.current = !0);
    }
  });
  let B = k(e.focusedKey);
  ee(() => {
    if (e.isFocused && e.focusedKey != null && (e.focusedKey !== B.current || N.current) && d.current && l.current) {
      let a = we(), b = fe(l, e.focusedKey);
      if (!(b instanceof HTMLElement))
        return;
      (a === "keyboard" || N.current) && (ut(d.current, b), a !== "virtual" && Ee(b, {
        containingElement: l.current
      }));
    }
    !g && e.isFocused && e.focusedKey == null && B.current != null && l.current && ve(l.current), B.current = e.focusedKey, N.current = !1;
  }), Q(l, "react-aria-focus-scope-restore", (a) => {
    a.preventDefault(), e.setFocused(!0);
  });
  let M = {
    onKeyDown: p,
    onFocus: x,
    onBlur: D,
    onMouseDown(a) {
      d.current === a.target && a.preventDefault();
    }
  }, { typeSelectProps: te } = At({
    keyboardDelegate: t,
    selectionManager: e
  });
  S || (M = j(te, M));
  let J;
  g || (J = e.focusedKey == null ? 0 : -1);
  let le = Tt(e.collection);
  return {
    collectionProps: j(M, {
      tabIndex: J,
      "data-collection": le
    })
  };
}
function rl(n) {
  let { id: e, selectionManager: t, key: l, ref: i, shouldSelectOnPressUp: r, shouldUseVirtualFocus: o, focus: c, isDisabled: s, onAction: S, allowsDifferentPressOrigin: g, linkBehavior: h = "action" } = n, f = Ge();
  e = ze(e);
  let d = (u) => {
    if (u.pointerType === "keyboard" && be(u)) t.toggleSelection(l);
    else {
      if (t.selectionMode === "none") return;
      if (t.isLink(l)) {
        if (h === "selection" && i.current) {
          let E = t.getItemProps(l);
          f.open(i.current, u, E.href, E.routerOptions), t.setSelectedKeys(t.selectedKeys);
          return;
        } else if (h === "override" || h === "none") return;
      }
      t.selectionMode === "single" ? t.isSelected(l) && !t.disallowEmptySelection ? t.toggleSelection(l) : t.replaceSelection(l) : u && u.shiftKey ? t.extendSelection(l) : t.selectionBehavior === "toggle" || u && (G(u) || u.pointerType === "touch" || u.pointerType === "virtual") ? t.toggleSelection(l) : t.replaceSelection(l);
    }
  };
  ee(() => {
    l === t.focusedKey && t.isFocused && (o ? Je(i.current) : c ? c() : document.activeElement !== i.current && i.current && ve(i.current));
  }, [
    i,
    l,
    t.focusedKey,
    t.childFocusStrategy,
    t.isFocused,
    o
  ]), s = s || t.isDisabled(l);
  let v = {};
  !o && !s ? v = {
    tabIndex: l === t.focusedKey ? 0 : -1,
    onFocus(u) {
      u.target === i.current && t.setFocusedKey(l);
    }
  } : s && (v.onMouseDown = (u) => {
    u.preventDefault();
  });
  let $ = t.isLink(l) && h === "override", m = t.isLink(l) && h !== "selection" && h !== "none", p = !s && t.canSelectItem(l) && !$, w = (S || m) && !s, x = w && (t.selectionBehavior === "replace" ? !p : !p || t.isEmpty), D = w && p && t.selectionBehavior === "replace", P = x || D, L = k(null), I = P && p, T = k(!1), N = k(!1), B = (u) => {
    if (S && S(), m && i.current) {
      let E = t.getItemProps(l);
      f.open(i.current, u, E.href, E.routerOptions);
    }
  }, M = {};
  r ? (M.onPressStart = (u) => {
    L.current = u.pointerType, T.current = I, u.pointerType === "keyboard" && (!P || Ie()) && d(u);
  }, g ? (M.onPressUp = x ? void 0 : (u) => {
    u.pointerType === "mouse" && p && d(u);
  }, M.onPress = x ? B : (u) => {
    u.pointerType !== "keyboard" && u.pointerType !== "mouse" && p && d(u);
  }) : M.onPress = (u) => {
    if (x || D && u.pointerType !== "mouse") {
      if (u.pointerType === "keyboard" && !Ae()) return;
      B(u);
    } else u.pointerType !== "keyboard" && p && d(u);
  }) : (M.onPressStart = (u) => {
    L.current = u.pointerType, T.current = I, N.current = x, p && (u.pointerType === "mouse" && !x || u.pointerType === "keyboard" && (!w || Ie())) && d(u);
  }, M.onPress = (u) => {
    (u.pointerType === "touch" || u.pointerType === "pen" || u.pointerType === "virtual" || u.pointerType === "keyboard" && P && Ae() || u.pointerType === "mouse" && N.current) && (P ? B(u) : p && d(u));
  }), v["data-collection"] = Mt(t.collection), v["data-key"] = l, M.preventFocusOnPress = o, o && (M = j(M, {
    onPressStart(u) {
      u.pointerType !== "touch" && (t.setFocused(!0), t.setFocusedKey(l));
    },
    onPress(u) {
      u.pointerType === "touch" && (t.setFocused(!0), t.setFocusedKey(l));
    }
  }));
  let { pressProps: te, isPressed: J } = qe(M), le = D ? (u) => {
    L.current === "mouse" && (u.stopPropagation(), u.preventDefault(), B(u));
  } : void 0, { longPressProps: a } = St({
    isDisabled: !I,
    onLongPress(u) {
      u.pointerType === "touch" && (d(u), t.setSelectionBehavior("toggle"));
    }
  }), b = (u) => {
    L.current === "touch" && T.current && u.preventDefault();
  }, C = t.isLink(l) ? (u) => {
    st.isOpening || u.preventDefault();
  } : void 0;
  return {
    itemProps: j(
      v,
      p || x || o ? te : {},
      I ? a : {},
      {
        onDoubleClick: le,
        onDragStartCapture: b,
        onClick: C,
        id: e
      },
      // Prevent DOM focus from moving on mouse down when using virtual focus
      o ? {
        onMouseDown: (u) => u.preventDefault()
      } : void 0
    ),
    isPressed: J,
    isSelected: t.isSelected(l),
    isFocused: t.isFocused && t.focusedKey === l,
    isDisabled: s,
    allowsSelection: p,
    hasAction: P
  };
}
function Ae() {
  let n = window.event;
  return (n == null ? void 0 : n.key) === "Enter";
}
function Ie() {
  let n = window.event;
  return (n == null ? void 0 : n.key) === " " || (n == null ? void 0 : n.code) === "Space";
}
class Ot {
  build(e, t) {
    return this.context = t, Oe(() => this.iterateCollection(e));
  }
  *iterateCollection(e) {
    let { children: t, items: l } = e;
    if (K.isValidElement(t) && t.type === K.Fragment) yield* this.iterateCollection({
      children: t.props.children,
      items: l
    });
    else if (typeof t == "function") {
      if (!l) throw new Error("props.children was a function but props.items is missing");
      let i = 0;
      for (let r of l)
        yield* this.getFullNode({
          value: r,
          index: i
        }, {
          renderer: t
        }), i++;
    } else {
      let i = [];
      K.Children.forEach(t, (o) => {
        o && i.push(o);
      });
      let r = 0;
      for (let o of i) {
        let c = this.getFullNode({
          element: o,
          index: r
        }, {});
        for (let s of c)
          r++, yield s;
      }
    }
  }
  getKey(e, t, l, i) {
    if (e.key != null) return e.key;
    if (t.type === "cell" && t.key != null) return `${i}${t.key}`;
    let r = t.value;
    if (r != null) {
      var o;
      let c = (o = r.key) !== null && o !== void 0 ? o : r.id;
      if (c == null) throw new Error("No key found for item");
      return c;
    }
    return i ? `${i}.${t.index}` : `$.${t.index}`;
  }
  getChildState(e, t) {
    return {
      renderer: t.renderer || e.renderer
    };
  }
  *getFullNode(e, t, l, i) {
    if (K.isValidElement(e.element) && e.element.type === K.Fragment) {
      let m = [];
      K.Children.forEach(e.element.props.children, (w) => {
        m.push(w);
      });
      var r;
      let p = (r = e.index) !== null && r !== void 0 ? r : 0;
      for (const w of m) yield* this.getFullNode({
        element: w,
        index: p++
      }, t, l, i);
      return;
    }
    let o = e.element;
    if (!o && e.value && t && t.renderer) {
      let m = this.cache.get(e.value);
      if (m && (!m.shouldInvalidate || !m.shouldInvalidate(this.context))) {
        m.index = e.index, m.parentKey = i ? i.key : null, yield m;
        return;
      }
      o = t.renderer(e.value);
    }
    if (K.isValidElement(o)) {
      let m = o.type;
      if (typeof m != "function" && typeof m.getCollectionNode != "function") {
        let D = o.type;
        throw new Error(`Unknown element <${D}> in collection.`);
      }
      let p = m.getCollectionNode(o.props, this.context);
      var c;
      let w = (c = e.index) !== null && c !== void 0 ? c : 0, x = p.next();
      for (; !x.done && x.value; ) {
        let D = x.value;
        e.index = w;
        var s;
        let P = (s = D.key) !== null && s !== void 0 ? s : null;
        P == null && (P = D.element ? null : this.getKey(o, e, t, l));
        let I = [
          ...this.getFullNode({
            ...D,
            key: P,
            index: w,
            wrapper: Rt(e.wrapper, D.wrapper)
          }, this.getChildState(t, D), l ? `${l}${o.key}` : o.key, i)
        ];
        for (let T of I) {
          var S, g;
          T.value = (g = (S = D.value) !== null && S !== void 0 ? S : e.value) !== null && g !== void 0 ? g : null, T.value && this.cache.set(T.value, T);
          var h;
          if (e.type && T.type !== e.type) throw new Error(`Unsupported type <${he(T.type)}> in <${he((h = i == null ? void 0 : i.type) !== null && h !== void 0 ? h : "unknown parent type")}>. Only <${he(e.type)}> is supported.`);
          w++, yield T;
        }
        x = p.next(I);
      }
      return;
    }
    if (e.key == null || e.type == null) return;
    let f = this;
    var d, v;
    let $ = {
      type: e.type,
      props: e.props,
      key: e.key,
      parentKey: i ? i.key : null,
      value: (d = e.value) !== null && d !== void 0 ? d : null,
      level: i ? i.level + 1 : 0,
      index: e.index,
      rendered: e.rendered,
      textValue: (v = e.textValue) !== null && v !== void 0 ? v : "",
      "aria-label": e["aria-label"],
      wrapper: e.wrapper,
      shouldInvalidate: e.shouldInvalidate,
      hasChildNodes: e.hasChildNodes || !1,
      childNodes: Oe(function* () {
        if (!e.hasChildNodes || !e.childNodes) return;
        let m = 0;
        for (let p of e.childNodes()) {
          p.key != null && (p.key = `${$.key}${p.key}`);
          let w = f.getFullNode({
            ...p,
            index: m
          }, f.getChildState(t, p), $.key, $);
          for (let x of w)
            m++, yield x;
        }
      })
    };
    yield $;
  }
  constructor() {
    this.cache = /* @__PURE__ */ new WeakMap();
  }
}
function Oe(n) {
  let e = [], t = null;
  return {
    *[Symbol.iterator]() {
      for (let l of e) yield l;
      t || (t = n());
      for (let l of t)
        e.push(l), yield l;
    }
  };
}
function Rt(n, e) {
  if (n && e) return (t) => n(e(t));
  if (n) return n;
  if (e) return e;
}
function he(n) {
  return n[0].toUpperCase() + n.slice(1);
}
function ol(n, e, t) {
  let l = R(() => new Ot(), []), { children: i, items: r, collection: o } = n;
  return R(() => {
    if (o) return o;
    let s = l.build({
      children: i,
      items: r
    }, t);
    return e(s);
  }, [
    l,
    i,
    r,
    o,
    t,
    e
  ]);
}
function Lt(n, e) {
  return typeof e.getChildren == "function" ? e.getChildren(n.key) : n.childNodes;
}
function Bt(n) {
  return Vt(n);
}
function Vt(n, e) {
  for (let t of n)
    return t;
}
function sl(n) {
  let e;
  for (let t of n) e = t;
  return e;
}
function ye(n, e, t) {
  if (e.parentKey === t.parentKey) return e.index - t.index;
  let l = [
    ...Re(n, e),
    e
  ], i = [
    ...Re(n, t),
    t
  ], r = l.slice(0, i.length).findIndex((o, c) => o !== i[c]);
  return r !== -1 ? (e = l[r], t = i[r], e.index - t.index) : l.findIndex((o) => o === t) >= 0 ? 1 : (i.findIndex((o) => o === e) >= 0, -1);
}
function Re(n, e) {
  let t = [], l = e;
  for (; (l == null ? void 0 : l.parentKey) != null; )
    l = n.getItem(l.parentKey), l && t.unshift(l);
  return t;
}
class A extends Set {
  constructor(e, t, l) {
    super(e), e instanceof A ? (this.anchorKey = t ?? e.anchorKey, this.currentKey = l ?? e.currentKey) : (this.anchorKey = t ?? null, this.currentKey = l ?? null);
  }
}
function Nt(n, e) {
  if (n.size !== e.size) return !1;
  for (let t of n)
    if (!e.has(t)) return !1;
  return !0;
}
function ul(n) {
  let { selectionMode: e = "none", disallowEmptySelection: t = !1, allowDuplicateSelectionEvents: l, selectionBehavior: i = "toggle", disabledBehavior: r = "all" } = n, o = k(!1), [, c] = _(!1), s = k(null), S = k(null), [, g] = _(null), h = R(() => Le(n.selectedKeys), [
    n.selectedKeys
  ]), f = R(() => Le(n.defaultSelectedKeys, new A()), [
    n.defaultSelectedKeys
  ]), [d, v] = ft(h, f, n.onSelectionChange), $ = R(() => n.disabledKeys ? new Set(n.disabledKeys) : /* @__PURE__ */ new Set(), [
    n.disabledKeys
  ]), [m, p] = _(i);
  i === "replace" && m === "toggle" && typeof d == "object" && d.size === 0 && p("replace");
  let w = k(i);
  return ee(() => {
    i !== w.current && (p(i), w.current = i);
  }, [
    i
  ]), {
    selectionMode: e,
    disallowEmptySelection: t,
    selectionBehavior: m,
    setSelectionBehavior: p,
    get isFocused() {
      return o.current;
    },
    setFocused(x) {
      o.current = x, c(x);
    },
    get focusedKey() {
      return s.current;
    },
    get childFocusStrategy() {
      return S.current;
    },
    setFocusedKey(x, D = "first") {
      s.current = x, S.current = D, g(x);
    },
    selectedKeys: d,
    setSelectedKeys(x) {
      (l || !Nt(x, d)) && v(x);
    },
    disabledKeys: $,
    disabledBehavior: r
  };
}
function Le(n, e) {
  return n ? n === "all" ? "all" : new A(n) : e;
}
class Xe {
  /**
  * The type of selection that is allowed in the collection.
  */
  get selectionMode() {
    return this.state.selectionMode;
  }
  /**
  * Whether the collection allows empty selection.
  */
  get disallowEmptySelection() {
    return this.state.disallowEmptySelection;
  }
  /**
  * The selection behavior for the collection.
  */
  get selectionBehavior() {
    return this.state.selectionBehavior;
  }
  /**
  * Sets the selection behavior for the collection.
  */
  setSelectionBehavior(e) {
    this.state.setSelectionBehavior(e);
  }
  /**
  * Whether the collection is currently focused.
  */
  get isFocused() {
    return this.state.isFocused;
  }
  /**
  * Sets whether the collection is focused.
  */
  setFocused(e) {
    this.state.setFocused(e);
  }
  /**
  * The current focused key in the collection.
  */
  get focusedKey() {
    return this.state.focusedKey;
  }
  /** Whether the first or last child of the focused key should receive focus. */
  get childFocusStrategy() {
    return this.state.childFocusStrategy;
  }
  /**
  * Sets the focused key.
  */
  setFocusedKey(e, t) {
    (e == null || this.collection.getItem(e)) && this.state.setFocusedKey(e, t);
  }
  /**
  * The currently selected keys in the collection.
  */
  get selectedKeys() {
    return this.state.selectedKeys === "all" ? new Set(this.getSelectAllKeys()) : this.state.selectedKeys;
  }
  /**
  * The raw selection value for the collection.
  * Either 'all' for select all, or a set of keys.
  */
  get rawSelection() {
    return this.state.selectedKeys;
  }
  /**
  * Returns whether a key is selected.
  */
  isSelected(e) {
    if (this.state.selectionMode === "none") return !1;
    let t = this.getKey(e);
    return t == null ? !1 : this.state.selectedKeys === "all" ? this.canSelectItem(t) : this.state.selectedKeys.has(t);
  }
  /**
  * Whether the selection is empty.
  */
  get isEmpty() {
    return this.state.selectedKeys !== "all" && this.state.selectedKeys.size === 0;
  }
  /**
  * Whether all items in the collection are selected.
  */
  get isSelectAll() {
    if (this.isEmpty) return !1;
    if (this.state.selectedKeys === "all") return !0;
    if (this._isSelectAll != null) return this._isSelectAll;
    let e = this.getSelectAllKeys(), t = this.state.selectedKeys;
    return this._isSelectAll = e.every((l) => t.has(l)), this._isSelectAll;
  }
  get firstSelectedKey() {
    let e = null;
    for (let l of this.state.selectedKeys) {
      let i = this.collection.getItem(l);
      (!e || i && ye(this.collection, i, e) < 0) && (e = i);
    }
    var t;
    return (t = e == null ? void 0 : e.key) !== null && t !== void 0 ? t : null;
  }
  get lastSelectedKey() {
    let e = null;
    for (let l of this.state.selectedKeys) {
      let i = this.collection.getItem(l);
      (!e || i && ye(this.collection, i, e) > 0) && (e = i);
    }
    var t;
    return (t = e == null ? void 0 : e.key) !== null && t !== void 0 ? t : null;
  }
  get disabledKeys() {
    return this.state.disabledKeys;
  }
  get disabledBehavior() {
    return this.state.disabledBehavior;
  }
  /**
  * Extends the selection to the given key.
  */
  extendSelection(e) {
    if (this.selectionMode === "none") return;
    if (this.selectionMode === "single") {
      this.replaceSelection(e);
      return;
    }
    let t = this.getKey(e);
    if (t == null) return;
    let l;
    if (this.state.selectedKeys === "all") l = new A([
      t
    ], t, t);
    else {
      let o = this.state.selectedKeys;
      var i;
      let c = (i = o.anchorKey) !== null && i !== void 0 ? i : t;
      l = new A(o, c, t);
      var r;
      for (let s of this.getKeyRange(c, (r = o.currentKey) !== null && r !== void 0 ? r : t)) l.delete(s);
      for (let s of this.getKeyRange(t, c)) this.canSelectItem(s) && l.add(s);
    }
    this.state.setSelectedKeys(l);
  }
  getKeyRange(e, t) {
    let l = this.collection.getItem(e), i = this.collection.getItem(t);
    return l && i ? ye(this.collection, l, i) <= 0 ? this.getKeyRangeInternal(e, t) : this.getKeyRangeInternal(t, e) : [];
  }
  getKeyRangeInternal(e, t) {
    var l;
    if (!((l = this.layoutDelegate) === null || l === void 0) && l.getKeyRange) return this.layoutDelegate.getKeyRange(e, t);
    let i = [], r = e;
    for (; r != null; ) {
      let o = this.collection.getItem(r);
      if (o && (o.type === "item" || o.type === "cell" && this.allowsCellSelection) && i.push(r), r === t) return i;
      r = this.collection.getKeyAfter(r);
    }
    return [];
  }
  getKey(e) {
    let t = this.collection.getItem(e);
    if (!t || t.type === "cell" && this.allowsCellSelection) return e;
    for (; t && t.type !== "item" && t.parentKey != null; ) t = this.collection.getItem(t.parentKey);
    return !t || t.type !== "item" ? null : t.key;
  }
  /**
  * Toggles whether the given key is selected.
  */
  toggleSelection(e) {
    if (this.selectionMode === "none") return;
    if (this.selectionMode === "single" && !this.isSelected(e)) {
      this.replaceSelection(e);
      return;
    }
    let t = this.getKey(e);
    if (t == null) return;
    let l = new A(this.state.selectedKeys === "all" ? this.getSelectAllKeys() : this.state.selectedKeys);
    l.has(t) ? l.delete(t) : this.canSelectItem(t) && (l.add(t), l.anchorKey = t, l.currentKey = t), !(this.disallowEmptySelection && l.size === 0) && this.state.setSelectedKeys(l);
  }
  /**
  * Replaces the selection with only the given key.
  */
  replaceSelection(e) {
    if (this.selectionMode === "none") return;
    let t = this.getKey(e);
    if (t == null) return;
    let l = this.canSelectItem(t) ? new A([
      t
    ], t, t) : new A();
    this.state.setSelectedKeys(l);
  }
  /**
  * Replaces the selection with the given keys.
  */
  setSelectedKeys(e) {
    if (this.selectionMode === "none") return;
    let t = new A();
    for (let l of e) {
      let i = this.getKey(l);
      if (i != null && (t.add(i), this.selectionMode === "single"))
        break;
    }
    this.state.setSelectedKeys(t);
  }
  getSelectAllKeys() {
    let e = [], t = (l) => {
      for (; l != null; ) {
        if (this.canSelectItem(l)) {
          var i;
          let o = this.collection.getItem(l);
          (o == null ? void 0 : o.type) === "item" && e.push(l);
          var r;
          o != null && o.hasChildNodes && (this.allowsCellSelection || o.type !== "item") && t((r = (i = Bt(Lt(o, this.collection))) === null || i === void 0 ? void 0 : i.key) !== null && r !== void 0 ? r : null);
        }
        l = this.collection.getKeyAfter(l);
      }
    };
    return t(this.collection.getFirstKey()), e;
  }
  /**
  * Selects all items in the collection.
  */
  selectAll() {
    !this.isSelectAll && this.selectionMode === "multiple" && this.state.setSelectedKeys("all");
  }
  /**
  * Removes all keys from the selection.
  */
  clearSelection() {
    !this.disallowEmptySelection && (this.state.selectedKeys === "all" || this.state.selectedKeys.size > 0) && this.state.setSelectedKeys(new A());
  }
  /**
  * Toggles between select all and an empty selection.
  */
  toggleSelectAll() {
    this.isSelectAll ? this.clearSelection() : this.selectAll();
  }
  select(e, t) {
    this.selectionMode !== "none" && (this.selectionMode === "single" ? this.isSelected(e) && !this.disallowEmptySelection ? this.toggleSelection(e) : this.replaceSelection(e) : this.selectionBehavior === "toggle" || t && (t.pointerType === "touch" || t.pointerType === "virtual") ? this.toggleSelection(e) : this.replaceSelection(e));
  }
  /**
  * Returns whether the current selection is equal to the given selection.
  */
  isSelectionEqual(e) {
    if (e === this.state.selectedKeys) return !0;
    let t = this.selectedKeys;
    if (e.size !== t.size) return !1;
    for (let l of e)
      if (!t.has(l)) return !1;
    for (let l of t)
      if (!e.has(l)) return !1;
    return !0;
  }
  canSelectItem(e) {
    var t;
    if (this.state.selectionMode === "none" || this.state.disabledKeys.has(e)) return !1;
    let l = this.collection.getItem(e);
    return !(!l || !(l == null || (t = l.props) === null || t === void 0) && t.isDisabled || l.type === "cell" && !this.allowsCellSelection);
  }
  isDisabled(e) {
    var t, l;
    return this.state.disabledBehavior === "all" && (this.state.disabledKeys.has(e) || !!(!((l = this.collection.getItem(e)) === null || l === void 0 || (t = l.props) === null || t === void 0) && t.isDisabled));
  }
  isLink(e) {
    var t, l;
    return !!(!((l = this.collection.getItem(e)) === null || l === void 0 || (t = l.props) === null || t === void 0) && t.href);
  }
  getItemProps(e) {
    var t;
    return (t = this.collection.getItem(e)) === null || t === void 0 ? void 0 : t.props;
  }
  withCollection(e) {
    return new Xe(e, this.state, {
      allowsCellSelection: this.allowsCellSelection,
      layoutDelegate: this.layoutDelegate || void 0
    });
  }
  constructor(e, t, l) {
    this.collection = e, this.state = t;
    var i;
    this.allowsCellSelection = (i = l == null ? void 0 : l.allowsCellSelection) !== null && i !== void 0 ? i : !1, this._isSelectAll = null, this.layoutDelegate = (l == null ? void 0 : l.layoutDelegate) || null;
  }
}
const al = /* @__PURE__ */ H(null), Ut = {
  CollectionRoot({ collection: n, renderDropIndicator: e }) {
    return Be(n, null, e);
  },
  CollectionBranch({ collection: n, parent: e, renderDropIndicator: t }) {
    return Be(n, e, t);
  }
};
function Be(n, e, t) {
  return We({
    items: e ? n.getChildren(e.key) : n,
    dependencies: [
      t
    ],
    children(l) {
      var i;
      let r = l.render(l);
      if (!t || l.type !== "item") return r;
      let o = l.key, c = n.getKeyAfter(o);
      return /* @__PURE__ */ K.createElement(K.Fragment, null, t({
        type: "item",
        key: o,
        dropPosition: "before"
      }), r, (c == null || ((i = n.getItem(c)) === null || i === void 0 ? void 0 : i.type) !== "item") && t({
        type: "item",
        key: o,
        dropPosition: "after"
      }));
    }
  });
}
const cl = /* @__PURE__ */ H(Ut);
function dl(n) {
  return R(() => n != null ? /* @__PURE__ */ new Set([
    n
  ]) : null, [
    n
  ]);
}
export {
  rl as $,
  nl as a,
  tl as b,
  el as c,
  il as d,
  cl as e,
  Ut as f,
  dl as g,
  St as h,
  At as i,
  Lt as j,
  al as k,
  sl as l,
  ul as m,
  ol as n,
  Xe as o,
  ll as p,
  We as q,
  fe as r
};
