import { a as du } from "./Button-CXfbBbgl.js";
import { b as ie, c as ue, d as lu, e as G, f as ou, $ as su, a as cu, g as ge, h as Ee, i as mu, j as fu, k as Du, l as $u, m as yu } from "./Calendar-hkITWBXi.js";
import { $ as J, a as le, n as bu, c as vu, d as Fe, b as Pe, e as ke, f as xu, g as hu, h as pu } from "./utils-DPfg4HqB.js";
import { $ as Bu, a as Ve } from "./Group-BFfmkIFk.js";
import { $ as Cu, a as gu } from "./Input-BJGrlDHw.js";
import { $ as me } from "./filterDOMProps-D6KHYVBX.js";
import Z, { useCallback as oe, useMemo as C, useRef as M, useEffect as we, useState as Y, forwardRef as te, createContext as re, useContext as Q, cloneElement as Eu } from "react";
import { c as be, $ as Ae } from "./FocusScope-B-R06ewx.js";
import { a as Fu } from "./usePress-BKP_smFB.js";
import { $ as ne } from "./context-DRz_xlLl.js";
import { $ as Re } from "./useDescription-DBX9pMU8.js";
import { $ as Pu } from "./useFormReset-BFMiMslO.js";
import { a as Oe, $ as Te } from "./useFocusRing-DTBeynF4.js";
import { a as je, $ as ku } from "./FieldError-BcQ_xYIC.js";
import { $ as Vu } from "./useFormValidation-B8seeWsn.js";
import { $ as Se, a as wu, b as ve, c as Au } from "./useLocalizedStringFormatter-BXegnzqm.js";
import { $ as Ru } from "./useLabels-vObMberA.js";
import { $ as Ou } from "./getScrollParent-mRV3mdwj.js";
import { i as Tu, u as ju, a as Su } from "./useHover-r8IM8mvD.js";
import { $ as ye } from "./useEvent-BRkcKkHt.js";
import { $ as Iu } from "./scrollIntoView-DzN8eF1C.js";
import { a as zu, $ as Nu } from "./useSpinButton-ChDCfd7O.js";
import { $ as Zu } from "./useCollator-UGgeWRRW.js";
import { b as Mu, a as Ie, $ as Uu } from "./Form-CjZKgLHe.js";
import { $ as ze } from "./useControlledState-Kv9K2AYu.js";
import { c as Ku, g as Lu } from "./Dialog-QtDyK8mk.js";
import { a as Wu } from "./Label-BhIlZh5B.js";
import { a as _u } from "./Popover-CyRF53A6.js";
import { a as Gu } from "./Text-NEUq4Wl7.js";
import { d as Hu } from "./OverlayArrow-BINAcvV5.js";
import { $ as qu } from "./useOverlayTriggerState-fZODjzBe.js";
function Ju(e) {
  let a = Zu({
    usage: "search",
    ...e
  }), u = oe((l, d) => d.length === 0 ? !0 : (l = l.normalize("NFC"), d = d.normalize("NFC"), a.compare(l.slice(0, d.length), d) === 0), [
    a
  ]), t = oe((l, d) => d.length === 0 ? !0 : (l = l.normalize("NFC"), d = d.normalize("NFC"), a.compare(l.slice(-d.length), d) === 0), [
    a
  ]), r = oe((l, d) => {
    if (d.length === 0) return !0;
    l = l.normalize("NFC"), d = d.normalize("NFC");
    let m = 0, n = d.length;
    for (; m + n <= l.length; m++) {
      let f = l.slice(m, m + n);
      if (a.compare(d, f) === 0) return !0;
    }
    return !1;
  }, [
    a
  ]);
  return C(() => ({
    startsWith: u,
    endsWith: t,
    contains: r
  }), [
    u,
    t,
    r
  ]);
}
var Ne = {};
Ne = {
  calendar: "التقويم",
  day: "يوم",
  dayPeriod: "ص/م",
  endDate: "تاريخ الانتهاء",
  era: "العصر",
  hour: "الساعات",
  minute: "الدقائق",
  month: "الشهر",
  second: "الثواني",
  selectedDateDescription: (e) => `تاريخ محدد: ${e.date}`,
  selectedRangeDescription: (e) => `المدى الزمني المحدد: ${e.startDate} إلى ${e.endDate}`,
  selectedTimeDescription: (e) => `الوقت المحدد: ${e.time}`,
  startDate: "تاريخ البدء",
  timeZoneName: "التوقيت",
  weekday: "اليوم",
  year: "السنة"
};
var Ze = {};
Ze = {
  calendar: "Календар",
  day: "ден",
  dayPeriod: "пр.об./сл.об.",
  endDate: "Крайна дата",
  era: "ера",
  hour: "час",
  minute: "минута",
  month: "месец",
  second: "секунда",
  selectedDateDescription: (e) => `Избрана дата: ${e.date}`,
  selectedRangeDescription: (e) => `Избран диапазон: ${e.startDate} до ${e.endDate}`,
  selectedTimeDescription: (e) => `Избрано време: ${e.time}`,
  startDate: "Начална дата",
  timeZoneName: "часова зона",
  weekday: "ден от седмицата",
  year: "година"
};
var Me = {};
Me = {
  calendar: "Kalendář",
  day: "den",
  dayPeriod: "část dne",
  endDate: "Konečné datum",
  era: "letopočet",
  hour: "hodina",
  minute: "minuta",
  month: "měsíc",
  second: "sekunda",
  selectedDateDescription: (e) => `Vybrané datum: ${e.date}`,
  selectedRangeDescription: (e) => `Vybrané období: ${e.startDate} až ${e.endDate}`,
  selectedTimeDescription: (e) => `Vybraný čas: ${e.time}`,
  startDate: "Počáteční datum",
  timeZoneName: "časové pásmo",
  weekday: "den v týdnu",
  year: "rok"
};
var Ue = {};
Ue = {
  calendar: "Kalender",
  day: "dag",
  dayPeriod: "AM/PM",
  endDate: "Slutdato",
  era: "æra",
  hour: "time",
  minute: "minut",
  month: "måned",
  second: "sekund",
  selectedDateDescription: (e) => `Valgt dato: ${e.date}`,
  selectedRangeDescription: (e) => `Valgt interval: ${e.startDate} til ${e.endDate}`,
  selectedTimeDescription: (e) => `Valgt tidspunkt: ${e.time}`,
  startDate: "Startdato",
  timeZoneName: "tidszone",
  weekday: "ugedag",
  year: "år"
};
var Ke = {};
Ke = {
  calendar: "Kalender",
  day: "Tag",
  dayPeriod: "Tageshälfte",
  endDate: "Enddatum",
  era: "Epoche",
  hour: "Stunde",
  minute: "Minute",
  month: "Monat",
  second: "Sekunde",
  selectedDateDescription: (e) => `Ausgewähltes Datum: ${e.date}`,
  selectedRangeDescription: (e) => `Ausgewählter Bereich: ${e.startDate} bis ${e.endDate}`,
  selectedTimeDescription: (e) => `Ausgewählte Zeit: ${e.time}`,
  startDate: "Anfangsdatum",
  timeZoneName: "Zeitzone",
  weekday: "Wochentag",
  year: "Jahr"
};
var Le = {};
Le = {
  calendar: "Ημερολόγιο",
  day: "ημέρα",
  dayPeriod: "π.μ./μ.μ.",
  endDate: "Ημερομηνία λήξης",
  era: "περίοδος",
  hour: "ώρα",
  minute: "λεπτό",
  month: "μήνας",
  second: "δευτερόλεπτο",
  selectedDateDescription: (e) => `Επιλεγμένη ημερομηνία: ${e.date}`,
  selectedRangeDescription: (e) => `Επιλεγμένο εύρος: ${e.startDate} έως ${e.endDate}`,
  selectedTimeDescription: (e) => `Επιλεγμένη ώρα: ${e.time}`,
  startDate: "Ημερομηνία έναρξης",
  timeZoneName: "ζώνη ώρας",
  weekday: "καθημερινή",
  year: "έτος"
};
var We = {};
We = {
  era: "era",
  year: "year",
  month: "month",
  day: "day",
  hour: "hour",
  minute: "minute",
  second: "second",
  dayPeriod: "AM/PM",
  calendar: "Calendar",
  startDate: "Start Date",
  endDate: "End Date",
  weekday: "day of the week",
  timeZoneName: "time zone",
  selectedDateDescription: (e) => `Selected Date: ${e.date}`,
  selectedRangeDescription: (e) => `Selected Range: ${e.startDate} to ${e.endDate}`,
  selectedTimeDescription: (e) => `Selected Time: ${e.time}`
};
var _e = {};
_e = {
  calendar: "Calendario",
  day: "día",
  dayPeriod: "a. m./p. m.",
  endDate: "Fecha final",
  era: "era",
  hour: "hora",
  minute: "minuto",
  month: "mes",
  second: "segundo",
  selectedDateDescription: (e) => `Fecha seleccionada: ${e.date}`,
  selectedRangeDescription: (e) => `Rango seleccionado: ${e.startDate} a ${e.endDate}`,
  selectedTimeDescription: (e) => `Hora seleccionada: ${e.time}`,
  startDate: "Fecha de inicio",
  timeZoneName: "zona horaria",
  weekday: "día de la semana",
  year: "año"
};
var Ge = {};
Ge = {
  calendar: "Kalender",
  day: "päev",
  dayPeriod: "enne/pärast lõunat",
  endDate: "Lõppkuupäev",
  era: "ajastu",
  hour: "tund",
  minute: "minut",
  month: "kuu",
  second: "sekund",
  selectedDateDescription: (e) => `Valitud kuupäev: ${e.date}`,
  selectedRangeDescription: (e) => `Valitud vahemik: ${e.startDate} kuni ${e.endDate}`,
  selectedTimeDescription: (e) => `Valitud aeg: ${e.time}`,
  startDate: "Alguskuupäev",
  timeZoneName: "ajavöönd",
  weekday: "nädalapäev",
  year: "aasta"
};
var He = {};
He = {
  calendar: "Kalenteri",
  day: "päivä",
  dayPeriod: "vuorokaudenaika",
  endDate: "Päättymispäivä",
  era: "aikakausi",
  hour: "tunti",
  minute: "minuutti",
  month: "kuukausi",
  second: "sekunti",
  selectedDateDescription: (e) => `Valittu päivämäärä: ${e.date}`,
  selectedRangeDescription: (e) => `Valittu aikaväli: ${e.startDate} – ${e.endDate}`,
  selectedTimeDescription: (e) => `Valittu aika: ${e.time}`,
  startDate: "Alkamispäivä",
  timeZoneName: "aikavyöhyke",
  weekday: "viikonpäivä",
  year: "vuosi"
};
var qe = {};
qe = {
  calendar: "Calendrier",
  day: "jour",
  dayPeriod: "cadran",
  endDate: "Date de fin",
  era: "ère",
  hour: "heure",
  minute: "minute",
  month: "mois",
  second: "seconde",
  selectedDateDescription: (e) => `Date sélectionnée : ${e.date}`,
  selectedRangeDescription: (e) => `Plage sélectionnée : ${e.startDate} au ${e.endDate}`,
  selectedTimeDescription: (e) => `Heure choisie : ${e.time}`,
  startDate: "Date de début",
  timeZoneName: "fuseau horaire",
  weekday: "jour de la semaine",
  year: "année"
};
var Je = {};
Je = {
  calendar: "לוח שנה",
  day: "יום",
  dayPeriod: "לפנה״צ/אחה״צ",
  endDate: "תאריך סיום",
  era: "תקופה",
  hour: "שעה",
  minute: "דקה",
  month: "חודש",
  second: "שנייה",
  selectedDateDescription: (e) => `תאריך נבחר: ${e.date}`,
  selectedRangeDescription: (e) => `טווח נבחר: ${e.startDate} עד ${e.endDate}`,
  selectedTimeDescription: (e) => `זמן נבחר: ${e.time}`,
  startDate: "תאריך התחלה",
  timeZoneName: "אזור זמן",
  weekday: "יום בשבוע",
  year: "שנה"
};
var Ye = {};
Ye = {
  calendar: "Kalendar",
  day: "dan",
  dayPeriod: "AM/PM",
  endDate: "Datum završetka",
  era: "era",
  hour: "sat",
  minute: "minuta",
  month: "mjesec",
  second: "sekunda",
  selectedDateDescription: (e) => `Odabrani datum: ${e.date}`,
  selectedRangeDescription: (e) => `Odabrani raspon: ${e.startDate} do ${e.endDate}`,
  selectedTimeDescription: (e) => `Odabrano vrijeme: ${e.time}`,
  startDate: "Datum početka",
  timeZoneName: "vremenska zona",
  weekday: "dan u tjednu",
  year: "godina"
};
var Qe = {};
Qe = {
  calendar: "Naptár",
  day: "nap",
  dayPeriod: "napszak",
  endDate: "Befejező dátum",
  era: "éra",
  hour: "óra",
  minute: "perc",
  month: "hónap",
  second: "másodperc",
  selectedDateDescription: (e) => `Kijelölt dátum: ${e.date}`,
  selectedRangeDescription: (e) => `Kijelölt tartomány: ${e.startDate}–${e.endDate}`,
  selectedTimeDescription: (e) => `Kijelölt idő: ${e.time}`,
  startDate: "Kezdő dátum",
  timeZoneName: "időzóna",
  weekday: "hét napja",
  year: "év"
};
var Xe = {};
Xe = {
  calendar: "Calendario",
  day: "giorno",
  dayPeriod: "AM/PM",
  endDate: "Data finale",
  era: "era",
  hour: "ora",
  minute: "minuto",
  month: "mese",
  second: "secondo",
  selectedDateDescription: (e) => `Data selezionata: ${e.date}`,
  selectedRangeDescription: (e) => `Intervallo selezionato: da ${e.startDate} a ${e.endDate}`,
  selectedTimeDescription: (e) => `Ora selezionata: ${e.time}`,
  startDate: "Data iniziale",
  timeZoneName: "fuso orario",
  weekday: "giorno della settimana",
  year: "anno"
};
var ea = {};
ea = {
  calendar: "カレンダー",
  day: "日",
  dayPeriod: "午前/午後",
  endDate: "終了日",
  era: "時代",
  hour: "時",
  minute: "分",
  month: "月",
  second: "秒",
  selectedDateDescription: (e) => `選択した日付 : ${e.date}`,
  selectedRangeDescription: (e) => `選択範囲 : ${e.startDate} から ${e.endDate}`,
  selectedTimeDescription: (e) => `選択した時間 : ${e.time}`,
  startDate: "開始日",
  timeZoneName: "タイムゾーン",
  weekday: "曜日",
  year: "年"
};
var aa = {};
aa = {
  calendar: "달력",
  day: "일",
  dayPeriod: "오전/오후",
  endDate: "종료일",
  era: "연호",
  hour: "시",
  minute: "분",
  month: "월",
  second: "초",
  selectedDateDescription: (e) => `선택 일자: ${e.date}`,
  selectedRangeDescription: (e) => `선택 범위: ${e.startDate} ~ ${e.endDate}`,
  selectedTimeDescription: (e) => `선택 시간: ${e.time}`,
  startDate: "시작일",
  timeZoneName: "시간대",
  weekday: "요일",
  year: "년"
};
var ua = {};
ua = {
  calendar: "Kalendorius",
  day: "diena",
  dayPeriod: "iki pietų / po pietų",
  endDate: "Pabaigos data",
  era: "era",
  hour: "valanda",
  minute: "minutė",
  month: "mėnuo",
  second: "sekundė",
  selectedDateDescription: (e) => `Pasirinkta data: ${e.date}`,
  selectedRangeDescription: (e) => `Pasirinktas intervalas: nuo ${e.startDate} iki ${e.endDate}`,
  selectedTimeDescription: (e) => `Pasirinktas laikas: ${e.time}`,
  startDate: "Pradžios data",
  timeZoneName: "laiko juosta",
  weekday: "savaitės diena",
  year: "metai"
};
var ta = {};
ta = {
  calendar: "Kalendārs",
  day: "diena",
  dayPeriod: "priekšpusdienā/pēcpusdienā",
  endDate: "Beigu datums",
  era: "ēra",
  hour: "stundas",
  minute: "minūtes",
  month: "mēnesis",
  second: "sekundes",
  selectedDateDescription: (e) => `Atlasītais datums: ${e.date}`,
  selectedRangeDescription: (e) => `Atlasītais diapazons: no ${e.startDate} līdz ${e.endDate}`,
  selectedTimeDescription: (e) => `Atlasītais laiks: ${e.time}`,
  startDate: "Sākuma datums",
  timeZoneName: "laika josla",
  weekday: "nedēļas diena",
  year: "gads"
};
var ra = {};
ra = {
  calendar: "Kalender",
  day: "dag",
  dayPeriod: "a.m./p.m.",
  endDate: "Sluttdato",
  era: "tidsalder",
  hour: "time",
  minute: "minutt",
  month: "måned",
  second: "sekund",
  selectedDateDescription: (e) => `Valgt dato: ${e.date}`,
  selectedRangeDescription: (e) => `Valgt område: ${e.startDate} til ${e.endDate}`,
  selectedTimeDescription: (e) => `Valgt tid: ${e.time}`,
  startDate: "Startdato",
  timeZoneName: "tidssone",
  weekday: "ukedag",
  year: "år"
};
var na = {};
na = {
  calendar: "Kalender",
  day: "dag",
  dayPeriod: "a.m./p.m.",
  endDate: "Einddatum",
  era: "tijdperk",
  hour: "uur",
  minute: "minuut",
  month: "maand",
  second: "seconde",
  selectedDateDescription: (e) => `Geselecteerde datum: ${e.date}`,
  selectedRangeDescription: (e) => `Geselecteerd bereik: ${e.startDate} tot ${e.endDate}`,
  selectedTimeDescription: (e) => `Geselecteerde tijd: ${e.time}`,
  startDate: "Startdatum",
  timeZoneName: "tijdzone",
  weekday: "dag van de week",
  year: "jaar"
};
var ia = {};
ia = {
  calendar: "Kalendarz",
  day: "dzień",
  dayPeriod: "rano / po południu / wieczorem",
  endDate: "Data końcowa",
  era: "era",
  hour: "godzina",
  minute: "minuta",
  month: "miesiąc",
  second: "sekunda",
  selectedDateDescription: (e) => `Wybrana data: ${e.date}`,
  selectedRangeDescription: (e) => `Wybrany zakres: ${e.startDate} do ${e.endDate}`,
  selectedTimeDescription: (e) => `Wybrany czas: ${e.time}`,
  startDate: "Data początkowa",
  timeZoneName: "strefa czasowa",
  weekday: "dzień tygodnia",
  year: "rok"
};
var da = {};
da = {
  calendar: "Calendário",
  day: "dia",
  dayPeriod: "AM/PM",
  endDate: "Data final",
  era: "era",
  hour: "hora",
  minute: "minuto",
  month: "mês",
  second: "segundo",
  selectedDateDescription: (e) => `Data selecionada: ${e.date}`,
  selectedRangeDescription: (e) => `Intervalo selecionado: ${e.startDate} a ${e.endDate}`,
  selectedTimeDescription: (e) => `Hora selecionada: ${e.time}`,
  startDate: "Data inicial",
  timeZoneName: "fuso horário",
  weekday: "dia da semana",
  year: "ano"
};
var la = {};
la = {
  calendar: "Calendário",
  day: "dia",
  dayPeriod: "am/pm",
  endDate: "Data de Término",
  era: "era",
  hour: "hora",
  minute: "minuto",
  month: "mês",
  second: "segundo",
  selectedDateDescription: (e) => `Data selecionada: ${e.date}`,
  selectedRangeDescription: (e) => `Intervalo selecionado: ${e.startDate} a ${e.endDate}`,
  selectedTimeDescription: (e) => `Hora selecionada: ${e.time}`,
  startDate: "Data de Início",
  timeZoneName: "fuso horário",
  weekday: "dia da semana",
  year: "ano"
};
var oa = {};
oa = {
  calendar: "Calendar",
  day: "zi",
  dayPeriod: "a.m/p.m.",
  endDate: "Dată final",
  era: "eră",
  hour: "oră",
  minute: "minut",
  month: "lună",
  second: "secundă",
  selectedDateDescription: (e) => `Dată selectată: ${e.date}`,
  selectedRangeDescription: (e) => `Interval selectat: de la ${e.startDate} până la ${e.endDate}`,
  selectedTimeDescription: (e) => `Ora selectată: ${e.time}`,
  startDate: "Dată început",
  timeZoneName: "fus orar",
  weekday: "ziua din săptămână",
  year: "an"
};
var sa = {};
sa = {
  calendar: "Календарь",
  day: "день",
  dayPeriod: "AM/PM",
  endDate: "Дата окончания",
  era: "эра",
  hour: "час",
  minute: "минута",
  month: "месяц",
  second: "секунда",
  selectedDateDescription: (e) => `Выбранная дата: ${e.date}`,
  selectedRangeDescription: (e) => `Выбранный диапазон: с ${e.startDate} по ${e.endDate}`,
  selectedTimeDescription: (e) => `Выбранное время: ${e.time}`,
  startDate: "Дата начала",
  timeZoneName: "часовой пояс",
  weekday: "день недели",
  year: "год"
};
var ca = {};
ca = {
  calendar: "Kalendár",
  day: "deň",
  dayPeriod: "AM/PM",
  endDate: "Dátum ukončenia",
  era: "letopočet",
  hour: "hodina",
  minute: "minúta",
  month: "mesiac",
  second: "sekunda",
  selectedDateDescription: (e) => `Vybratý dátum: ${e.date}`,
  selectedRangeDescription: (e) => `Vybratý rozsah: od ${e.startDate} do ${e.endDate}`,
  selectedTimeDescription: (e) => `Vybratý čas: ${e.time}`,
  startDate: "Dátum začatia",
  timeZoneName: "časové pásmo",
  weekday: "deň týždňa",
  year: "rok"
};
var ma = {};
ma = {
  calendar: "Koledar",
  day: "dan",
  dayPeriod: "dop/pop",
  endDate: "Datum konca",
  era: "doba",
  hour: "ura",
  minute: "minuta",
  month: "mesec",
  second: "sekunda",
  selectedDateDescription: (e) => `Izbrani datum: ${e.date}`,
  selectedRangeDescription: (e) => `Izbrano območje: ${e.startDate} do ${e.endDate}`,
  selectedTimeDescription: (e) => `Izbrani čas: ${e.time}`,
  startDate: "Datum začetka",
  timeZoneName: "časovni pas",
  weekday: "dan v tednu",
  year: "leto"
};
var fa = {};
fa = {
  calendar: "Kalendar",
  day: "дан",
  dayPeriod: "пре подне/по подне",
  endDate: "Datum završetka",
  era: "ера",
  hour: "сат",
  minute: "минут",
  month: "месец",
  second: "секунд",
  selectedDateDescription: (e) => `Izabrani datum: ${e.date}`,
  selectedRangeDescription: (e) => `Izabrani opseg: od ${e.startDate} do ${e.endDate}`,
  selectedTimeDescription: (e) => `Izabrano vreme: ${e.time}`,
  startDate: "Datum početka",
  timeZoneName: "временска зона",
  weekday: "дан у недељи",
  year: "година"
};
var Da = {};
Da = {
  calendar: "Kalender",
  day: "dag",
  dayPeriod: "fm/em",
  endDate: "Slutdatum",
  era: "era",
  hour: "timme",
  minute: "minut",
  month: "månad",
  second: "sekund",
  selectedDateDescription: (e) => `Valt datum: ${e.date}`,
  selectedRangeDescription: (e) => `Valt intervall: ${e.startDate} till ${e.endDate}`,
  selectedTimeDescription: (e) => `Vald tid: ${e.time}`,
  startDate: "Startdatum",
  timeZoneName: "tidszon",
  weekday: "veckodag",
  year: "år"
};
var $a = {};
$a = {
  calendar: "Takvim",
  day: "gün",
  dayPeriod: "ÖÖ/ÖS",
  endDate: "Bitiş Tarihi",
  era: "çağ",
  hour: "saat",
  minute: "dakika",
  month: "ay",
  second: "saniye",
  selectedDateDescription: (e) => `Seçilen Tarih: ${e.date}`,
  selectedRangeDescription: (e) => `Seçilen Aralık: ${e.startDate} - ${e.endDate}`,
  selectedTimeDescription: (e) => `Seçilen Zaman: ${e.time}`,
  startDate: "Başlangıç Tarihi",
  timeZoneName: "saat dilimi",
  weekday: "haftanın günü",
  year: "yıl"
};
var ya = {};
ya = {
  calendar: "Календар",
  day: "день",
  dayPeriod: "дп/пп",
  endDate: "Дата завершення",
  era: "ера",
  hour: "година",
  minute: "хвилина",
  month: "місяць",
  second: "секунда",
  selectedDateDescription: (e) => `Вибрана дата: ${e.date}`,
  selectedRangeDescription: (e) => `Вибраний діапазон: ${e.startDate} — ${e.endDate}`,
  selectedTimeDescription: (e) => `Вибраний час: ${e.time}`,
  startDate: "Дата початку",
  timeZoneName: "часовий пояс",
  weekday: "день тижня",
  year: "рік"
};
var ba = {};
ba = {
  calendar: "日历",
  day: "日",
  dayPeriod: "上午/下午",
  endDate: "结束日期",
  era: "纪元",
  hour: "小时",
  minute: "分钟",
  month: "月",
  second: "秒",
  selectedDateDescription: (e) => `选定的日期：${e.date}`,
  selectedRangeDescription: (e) => `选定的范围：${e.startDate} 至 ${e.endDate}`,
  selectedTimeDescription: (e) => `选定的时间：${e.time}`,
  startDate: "开始日期",
  timeZoneName: "时区",
  weekday: "工作日",
  year: "年"
};
var va = {};
va = {
  calendar: "日曆",
  day: "日",
  dayPeriod: "上午/下午",
  endDate: "結束日期",
  era: "纪元",
  hour: "小时",
  minute: "分钟",
  month: "月",
  second: "秒",
  selectedDateDescription: (e) => `選定的日期：${e.date}`,
  selectedRangeDescription: (e) => `選定的範圍：${e.startDate} 至 ${e.endDate}`,
  selectedTimeDescription: (e) => `選定的時間：${e.time}`,
  startDate: "開始日期",
  timeZoneName: "时区",
  weekday: "工作日",
  year: "年"
};
var fe = {};
fe = {
  "ar-AE": Ne,
  "bg-BG": Ze,
  "cs-CZ": Me,
  "da-DK": Ue,
  "de-DE": Ke,
  "el-GR": Le,
  "en-US": We,
  "es-ES": _e,
  "et-EE": Ge,
  "fi-FI": He,
  "fr-FR": qe,
  "he-IL": Je,
  "hr-HR": Ye,
  "hu-HU": Qe,
  "it-IT": Xe,
  "ja-JP": ea,
  "ko-KR": aa,
  "lt-LT": ua,
  "lv-LV": ta,
  "nb-NO": ra,
  "nl-NL": na,
  "pl-PL": ia,
  "pt-BR": da,
  "pt-PT": la,
  "ro-RO": oa,
  "ru-RU": sa,
  "sk-SK": ca,
  "sl-SI": ma,
  "sr-SP": fa,
  "sv-SE": Da,
  "tr-TR": $a,
  "uk-UA": ya,
  "zh-CN": ba,
  "zh-TW": va
};
function xa(e, a, u) {
  let { direction: t } = ne(), r = C(() => be(a), [
    a
  ]), l = (n) => {
    if (n.currentTarget.contains(n.target) && (n.altKey && (n.key === "ArrowDown" || n.key === "ArrowUp") && "setOpen" in e && (n.preventDefault(), n.stopPropagation(), e.setOpen(!0)), !u))
      switch (n.key) {
        case "ArrowLeft":
          if (n.preventDefault(), n.stopPropagation(), t === "rtl") {
            if (a.current) {
              let f = n.target, c = pe(a.current, f.getBoundingClientRect().left, -1);
              c && c.focus();
            }
          } else r.focusPrevious();
          break;
        case "ArrowRight":
          if (n.preventDefault(), n.stopPropagation(), t === "rtl") {
            if (a.current) {
              let f = n.target, c = pe(a.current, f.getBoundingClientRect().left, 1);
              c && c.focus();
            }
          } else r.focusNext();
          break;
      }
  }, d = () => {
    var n;
    if (!a.current) return;
    let f = (n = window.event) === null || n === void 0 ? void 0 : n.target, c = Ae(a.current, {
      tabbable: !0
    });
    if (f && (c.currentNode = f, f = c.previousNode()), !f) {
      let i;
      do
        i = c.lastChild(), i && (f = i);
      while (i);
    }
    for (; f != null && f.hasAttribute("data-placeholder"); ) {
      let i = c.previousNode();
      if (i && i.hasAttribute("data-placeholder")) f = i;
      else break;
    }
    f && f.focus();
  }, { pressProps: m } = Fu({
    preventFocusOnPress: !0,
    allowTextSelectionOnPress: !0,
    onPressStart(n) {
      n.pointerType === "mouse" && d();
    },
    onPress(n) {
      n.pointerType !== "mouse" && d();
    }
  });
  return J(m, {
    onKeyDown: l
  });
}
function pe(e, a, u) {
  let t = Ae(e, {
    tabbable: !0
  }), r = t.nextNode(), l = null, d = 1 / 0;
  for (; r; ) {
    let n = r.getBoundingClientRect().left - a, f = Math.abs(n);
    Math.sign(n) === u && f < d && (l = r, d = f), r = t.nextNode();
  }
  return l;
}
function Yu(e) {
  return e && e.__esModule ? e.default : e;
}
const ha = /* @__PURE__ */ new WeakMap(), se = "__role_" + Date.now(), Qu = "__focusManager_" + Date.now();
function Xu(e, a, u) {
  var t;
  let { isInvalid: r, validationErrors: l, validationDetails: d } = a.displayValidation, { labelProps: m, fieldProps: n, descriptionProps: f, errorMessageProps: c } = je({
    ...e,
    labelElementType: "span",
    isInvalid: r,
    errorMessage: e.errorMessage || l
  }), i = M(null), { focusWithinProps: v } = Oe({
    ...e,
    onFocusWithin(h) {
      var D;
      i.current = a.value, (D = e.onFocus) === null || D === void 0 || D.call(e, h);
    },
    onBlurWithin: (h) => {
      var D;
      a.confirmPlaceholder(), a.value !== i.current && a.commitValidation(), (D = e.onBlur) === null || D === void 0 || D.call(e, h);
    },
    onFocusWithinChange: e.onFocusChange
  }), p = Se(Yu(fe), "@react-aria/datepicker"), k = a.maxGranularity === "hour" ? "selectedTimeDescription" : "selectedDateDescription", y = a.maxGranularity === "hour" ? "time" : "date", g = a.value ? p.format(k, {
    [y]: a.formatValue({
      month: "long"
    })
  }) : "", w = Re(g), S = e[se] === "presentation" ? n["aria-describedby"] : [
    w["aria-describedby"],
    n["aria-describedby"]
  ].filter(Boolean).join(" ") || void 0, E = e[Qu], V = C(() => E || be(u), [
    E,
    u
  ]), O = xa(a, u, e[se] === "presentation");
  ha.set(a, {
    ariaLabel: e["aria-label"],
    ariaLabelledBy: [
      m.id,
      e["aria-labelledby"]
    ].filter(Boolean).join(" ") || void 0,
    ariaDescribedBy: S,
    focusManager: V
  });
  let I = M(e.autoFocus), T;
  e[se] === "presentation" ? T = {
    role: "presentation"
  } : T = J(n, {
    role: "group",
    "aria-disabled": e.isDisabled || void 0,
    "aria-describedby": S
  }), we(() => {
    I.current && V.focusFirst(), I.current = !1;
  }, [
    V
  ]), Pu(e.inputRef, a.value, a.setValue), Vu({
    ...e,
    focus() {
      V.focusFirst();
    }
  }, a, e.inputRef);
  let F = {
    type: "hidden",
    name: e.name,
    value: ((t = a.value) === null || t === void 0 ? void 0 : t.toString()) || "",
    disabled: e.isDisabled
  };
  e.validationBehavior === "native" && (F.type = "text", F.hidden = !0, F.required = e.isRequired, F.onChange = () => {
  });
  let A = me(e);
  return {
    labelProps: {
      ...m,
      onClick: () => {
        V.focusFirst();
      }
    },
    fieldProps: J(A, T, O, v, {
      onKeyDown(h) {
        e.onKeyDown && e.onKeyDown(h);
      },
      onKeyUp(h) {
        e.onKeyUp && e.onKeyUp(h);
      },
      style: {
        unicodeBidi: "isolate"
      }
    }),
    inputProps: F,
    descriptionProps: f,
    errorMessageProps: c,
    isInvalid: r,
    validationErrors: l,
    validationDetails: d
  };
}
function et(e) {
  return e && e.__esModule ? e.default : e;
}
function at(e, a, u) {
  let t = le(), r = le(), l = le(), d = Se(et(fe), "@react-aria/datepicker"), { isInvalid: m, validationErrors: n, validationDetails: f } = a.displayValidation, { labelProps: c, fieldProps: i, descriptionProps: v, errorMessageProps: p } = je({
    ...e,
    labelElementType: "span",
    isInvalid: m,
    errorMessage: e.errorMessage || n
  }), k = xa(a, u), y = i["aria-labelledby"] || i.id, { locale: g } = ne(), w = a.formatValue(g, {
    month: "long"
  }), S = w ? d.format("selectedDateDescription", {
    date: w
  }) : "", E = Re(S), V = [
    E["aria-describedby"],
    i["aria-describedby"]
  ].filter(Boolean).join(" ") || void 0, O = me(e), I = C(() => be(u), [
    u
  ]), T = M(!1), { focusWithinProps: F } = Oe({
    ...e,
    isDisabled: a.isOpen,
    onBlurWithin: (A) => {
      let h = document.getElementById(r);
      if (!(h != null && h.contains(A.relatedTarget))) {
        var D, b;
        T.current = !1, (D = e.onBlur) === null || D === void 0 || D.call(e, A), (b = e.onFocusChange) === null || b === void 0 || b.call(e, !1);
      }
    },
    onFocusWithin: (A) => {
      if (!T.current) {
        var h, D;
        T.current = !0, (h = e.onFocus) === null || h === void 0 || h.call(e, A), (D = e.onFocusChange) === null || D === void 0 || D.call(e, !0);
      }
    }
  });
  return {
    groupProps: J(O, k, i, E, F, {
      role: "group",
      "aria-disabled": e.isDisabled || null,
      "aria-labelledby": y,
      "aria-describedby": V,
      onKeyDown(A) {
        a.isOpen || e.onKeyDown && e.onKeyDown(A);
      },
      onKeyUp(A) {
        a.isOpen || e.onKeyUp && e.onKeyUp(A);
      }
    }),
    labelProps: {
      ...c,
      onClick: () => {
        I.focusFirst();
      }
    },
    fieldProps: {
      ...i,
      id: l,
      [se]: "presentation",
      "aria-describedby": V,
      value: a.value,
      onChange: a.setValue,
      placeholderValue: e.placeholderValue,
      hideTimeZone: e.hideTimeZone,
      hourCycle: e.hourCycle,
      shouldForceLeadingZeros: e.shouldForceLeadingZeros,
      granularity: e.granularity,
      isDisabled: e.isDisabled,
      isReadOnly: e.isReadOnly,
      isRequired: e.isRequired,
      validationBehavior: e.validationBehavior,
      // DatePicker owns the validation state for the date field.
      [Mu]: a,
      autoFocus: e.autoFocus,
      name: e.name
    },
    descriptionProps: v,
    errorMessageProps: p,
    buttonProps: {
      ...E,
      id: t,
      "aria-haspopup": "dialog",
      "aria-label": d.format("calendar"),
      "aria-labelledby": `${t} ${y}`,
      "aria-describedby": V,
      "aria-expanded": a.isOpen,
      isDisabled: e.isDisabled || e.isReadOnly,
      onPress: () => a.setOpen(!0)
    },
    dialogProps: {
      id: r,
      "aria-labelledby": `${t} ${y}`
    },
    calendarProps: {
      autoFocus: !0,
      value: a.dateValue,
      onChange: a.setDateValue,
      minValue: e.minValue,
      maxValue: e.maxValue,
      isDisabled: e.isDisabled,
      isReadOnly: e.isReadOnly,
      isDateUnavailable: e.isDateUnavailable,
      defaultFocusedValue: a.dateValue ? void 0 : e.placeholderValue,
      isInvalid: a.isInvalid,
      errorMessage: typeof e.errorMessage == "function" ? e.errorMessage(a.displayValidation) : e.errorMessage || a.displayValidation.validationErrors.join(" ")
    },
    isInvalid: m,
    validationErrors: n,
    validationDetails: f
  };
}
function ut(e) {
  return e && e.__esModule ? e.default : e;
}
function tt() {
  let { locale: e } = ne(), a = wu(ut(fe), "@react-aria/datepicker");
  return C(() => {
    try {
      return new Intl.DisplayNames(e, {
        type: "dateTimeField"
      });
    } catch {
      return new rt(e, a);
    }
  }, [
    e,
    a
  ]);
}
class rt {
  of(a) {
    return this.dictionary.getStringForLocale(a, this.locale);
  }
  constructor(a, u) {
    this.locale = a, this.dictionary = u;
  }
}
function nt(e, a, u) {
  let t = M(""), { locale: r, direction: l } = ne(), d = tt(), { ariaLabel: m, ariaLabelledBy: n, ariaDescribedBy: f, focusManager: c } = ha.get(a), i = e.isPlaceholder ? "" : e.text, v = C(() => a.dateFormatter.resolvedOptions(), [
    a.dateFormatter
  ]), p = ie({
    month: "long",
    timeZone: v.timeZone
  }), k = ie({
    hour: "numeric",
    hour12: v.hour12,
    timeZone: v.timeZone
  });
  if (e.type === "month" && !e.isPlaceholder) {
    let o = p.format(a.dateValue);
    i = o !== i ? `${i} – ${o}` : o;
  } else e.type === "hour" && !e.isPlaceholder && (i = k.format(a.dateValue));
  let { spinButtonProps: y } = zu({
    // The ARIA spec says aria-valuenow is optional if there's no value, but aXe seems to require it.
    // This doesn't seem to have any negative effects with real AT since we also use aria-valuetext.
    // https://github.com/dequelabs/axe-core/issues/3505
    value: e.value,
    textValue: i,
    minValue: e.minValue,
    maxValue: e.maxValue,
    isDisabled: a.isDisabled,
    isReadOnly: a.isReadOnly || !e.isEditable,
    isRequired: a.isRequired,
    onIncrement: () => {
      t.current = "", a.increment(e.type);
    },
    onDecrement: () => {
      t.current = "", a.decrement(e.type);
    },
    onIncrementPage: () => {
      t.current = "", a.incrementPage(e.type);
    },
    onDecrementPage: () => {
      t.current = "", a.decrementPage(e.type);
    },
    onIncrementToMax: () => {
      t.current = "", e.maxValue !== void 0 && a.setSegment(e.type, e.maxValue);
    },
    onDecrementToMin: () => {
      t.current = "", e.minValue !== void 0 && a.setSegment(e.type, e.minValue);
    }
  }), g = C(() => new Nu(r, {
    maximumFractionDigits: 0
  }), [
    r
  ]), w = () => {
    if (e.text === e.placeholder && c.focusPrevious(), g.isValidPartialNumber(e.text) && !a.isReadOnly && !e.isPlaceholder) {
      let o = e.text.slice(0, -1), x = g.parse(o);
      o = x === 0 ? "" : o, o.length === 0 || x === 0 ? a.clearSegment(e.type) : a.setSegment(e.type, x), t.current = o;
    } else e.type === "dayPeriod" && a.clearSegment(e.type);
  }, S = (o) => {
    if (o.key === "a" && (ju() ? o.metaKey : o.ctrlKey) && o.preventDefault(), !(o.ctrlKey || o.metaKey || o.shiftKey || o.altKey))
      switch (o.key) {
        case "Backspace":
        case "Delete":
          o.preventDefault(), o.stopPropagation(), w();
          break;
      }
  }, { startsWith: E } = Ju({
    sensitivity: "base"
  }), V = ie({
    hour: "numeric",
    hour12: !0
  }), O = C(() => {
    let o = /* @__PURE__ */ new Date();
    return o.setHours(0), V.formatToParts(o).find((x) => x.type === "dayPeriod").value;
  }, [
    V
  ]), I = C(() => {
    let o = /* @__PURE__ */ new Date();
    return o.setHours(12), V.formatToParts(o).find((x) => x.type === "dayPeriod").value;
  }, [
    V
  ]), T = ie({
    year: "numeric",
    era: "narrow",
    timeZone: "UTC"
  }), F = C(() => {
    if (e.type !== "era") return [];
    let o = ue(new lu(1, 1, 1), a.calendar), x = a.calendar.getEras().map((j) => {
      let W = o.set({
        year: 1,
        month: 1,
        day: 1,
        era: j
      }).toDate("UTC"), $e = T.formatToParts(W).find((ee) => ee.type === "era").value;
      return {
        era: j,
        formatted: $e
      };
    }), B = it(x.map((j) => j.formatted));
    if (B) for (let j of x) j.formatted = j.formatted.slice(B);
    return x;
  }, [
    T,
    a.calendar,
    e.type
  ]), A = (o) => {
    if (a.isDisabled || a.isReadOnly) return;
    let x = t.current + o;
    switch (e.type) {
      case "dayPeriod":
        if (E(O, o)) a.setSegment("dayPeriod", 0);
        else if (E(I, o)) a.setSegment("dayPeriod", 12);
        else break;
        c.focusNext();
        break;
      case "era": {
        let B = F.find((j) => E(j.formatted, o));
        B && (a.setSegment("era", B.era), c.focusNext());
        break;
      }
      case "day":
      case "hour":
      case "minute":
      case "second":
      case "month":
      case "year": {
        if (!g.isValidPartialNumber(x)) return;
        let B = g.parse(x), j = B, W = e.minValue === 0;
        if (e.type === "hour" && a.dateFormatter.resolvedOptions().hour12) {
          switch (a.dateFormatter.resolvedOptions().hourCycle) {
            case "h11":
              B > 11 && (j = g.parse(o));
              break;
            case "h12":
              W = !1, B > 12 && (j = g.parse(o));
              break;
          }
          e.value !== void 0 && e.value >= 12 && B > 1 && (B += 12);
        } else e.maxValue !== void 0 && B > e.maxValue && (j = g.parse(o));
        if (isNaN(B)) return;
        let H = j !== 0 || W;
        H && a.setSegment(e.type, j), e.maxValue !== void 0 && (+(B + "0") > e.maxValue || x.length >= String(e.maxValue).length) ? (t.current = "", H && c.focusNext()) : t.current = x;
        break;
      }
    }
  }, h = () => {
    t.current = "", u.current && Iu(u.current, {
      containingElement: Ou(u.current)
    });
    let o = window.getSelection();
    o == null || o.collapse(u.current);
  }, D = M(typeof document < "u" ? document : null);
  ye(D, "selectionchange", () => {
    var o;
    let x = window.getSelection();
    x != null && x.anchorNode && (!((o = u.current) === null || o === void 0) && o.contains(x == null ? void 0 : x.anchorNode)) && x.collapse(u.current);
  });
  let b = M("");
  ye(u, "beforeinput", (o) => {
    if (u.current)
      switch (o.preventDefault(), o.inputType) {
        case "deleteContentBackward":
        case "deleteContentForward":
          g.isValidPartialNumber(e.text) && !a.isReadOnly && w();
          break;
        case "insertCompositionText":
          b.current = u.current.textContent, u.current.textContent = u.current.textContent;
          break;
        default:
          o.data != null && A(o.data);
          break;
      }
  }), ye(u, "input", (o) => {
    let { inputType: x, data: B } = o;
    switch (x) {
      case "insertCompositionText":
        u.current && (u.current.textContent = b.current), B != null && (E(O, B) || E(I, B)) && A(B);
        break;
    }
  }), bu(() => {
    let o = u.current;
    return () => {
      document.activeElement === o && (c.focusPrevious() || c.focusNext());
    };
  }, [
    u,
    c
  ]);
  let $ = Tu() || e.type === "timeZoneName" ? {
    role: "textbox",
    "aria-valuemax": null,
    "aria-valuemin": null,
    "aria-valuetext": null,
    "aria-valuenow": null
  } : {}, N = C(() => a.segments.find((o) => o.isEditable), [
    a.segments
  ]);
  e !== N && !a.isInvalid && (f = void 0);
  let X = le(), U = !a.isDisabled && !a.isReadOnly && e.isEditable, P = e.type === "literal" ? "" : d.of(e.type), K = Ru({
    "aria-label": `${P}${m ? `, ${m}` : ""}${n ? ", " : ""}`,
    "aria-labelledby": n
  });
  if (e.type === "literal") return {
    segmentProps: {
      "aria-hidden": !0
    }
  };
  let L = {
    caretColor: "transparent"
  };
  if (l === "rtl") {
    L.unicodeBidi = "embed";
    let o = v[e.type];
    (o === "numeric" || o === "2-digit") && (L.direction = "ltr");
  }
  return {
    segmentProps: J(y, K, {
      id: X,
      ...$,
      "aria-invalid": a.isInvalid ? "true" : void 0,
      "aria-describedby": f,
      "aria-readonly": a.isReadOnly || !e.isEditable ? "true" : void 0,
      "data-placeholder": e.isPlaceholder || void 0,
      contentEditable: U,
      suppressContentEditableWarning: U,
      spellCheck: U ? "false" : void 0,
      autoCorrect: U ? "off" : void 0,
      // Capitalization was changed in React 17...
      [parseInt(Z.version, 10) >= 17 ? "enterKeyHint" : "enterkeyhint"]: U ? "next" : void 0,
      inputMode: a.isDisabled || e.type === "dayPeriod" || e.type === "era" || !U ? void 0 : "numeric",
      tabIndex: a.isDisabled ? void 0 : 0,
      onKeyDown: S,
      onFocus: h,
      style: L,
      // Prevent pointer events from reaching useDatePickerGroup, and allow native browser behavior to focus the segment.
      onPointerDown(o) {
        o.stopPropagation();
      },
      onMouseDown(o) {
        o.stopPropagation();
      }
    })
  };
}
function it(e) {
  e.sort();
  let a = e[0], u = e[e.length - 1];
  for (let t = 0; t < a.length; t++)
    if (a[t] !== u[t]) return t;
  return 0;
}
var pa = {};
pa = {
  rangeOverflow: (e) => `يجب أن تكون القيمة ${e.maxValue} أو قبل ذلك.`,
  rangeReversed: "تاريخ البدء يجب أن يكون قبل تاريخ الانتهاء.",
  rangeUnderflow: (e) => `يجب أن تكون القيمة ${e.minValue} أو بعد ذلك.`,
  unavailableDate: "البيانات المحددة غير متاحة."
};
var Ba = {};
Ba = {
  rangeOverflow: (e) => `Стойността трябва да е ${e.maxValue} или по-ранна.`,
  rangeReversed: "Началната дата трябва да е преди крайната.",
  rangeUnderflow: (e) => `Стойността трябва да е ${e.minValue} или по-късно.`,
  unavailableDate: "Избраната дата не е налична."
};
var Ca = {};
Ca = {
  rangeOverflow: (e) => `Hodnota musí být ${e.maxValue} nebo dřívější.`,
  rangeReversed: "Datum zahájení musí předcházet datu ukončení.",
  rangeUnderflow: (e) => `Hodnota musí být ${e.minValue} nebo pozdější.`,
  unavailableDate: "Vybrané datum není k dispozici."
};
var ga = {};
ga = {
  rangeOverflow: (e) => `Værdien skal være ${e.maxValue} eller tidligere.`,
  rangeReversed: "Startdatoen skal være før slutdatoen.",
  rangeUnderflow: (e) => `Værdien skal være ${e.minValue} eller nyere.`,
  unavailableDate: "Den valgte dato er ikke tilgængelig."
};
var Ea = {};
Ea = {
  rangeOverflow: (e) => `Der Wert muss ${e.maxValue} oder früher sein.`,
  rangeReversed: "Das Anfangsdatum muss vor dem Enddatum liegen.",
  rangeUnderflow: (e) => `Der Wert muss ${e.minValue} oder später sein.`,
  unavailableDate: "Das ausgewählte Datum ist nicht verfügbar."
};
var Fa = {};
Fa = {
  rangeOverflow: (e) => `Η τιμή πρέπει να είναι ${e.maxValue} ή παλαιότερη.`,
  rangeReversed: "Η ημερομηνία έναρξης πρέπει να είναι πριν από την ημερομηνία λήξης.",
  rangeUnderflow: (e) => `Η τιμή πρέπει να είναι ${e.minValue} ή μεταγενέστερη.`,
  unavailableDate: "Η επιλεγμένη ημερομηνία δεν είναι διαθέσιμη."
};
var Pa = {};
Pa = {
  rangeUnderflow: (e) => `Value must be ${e.minValue} or later.`,
  rangeOverflow: (e) => `Value must be ${e.maxValue} or earlier.`,
  rangeReversed: "Start date must be before end date.",
  unavailableDate: "Selected date unavailable."
};
var ka = {};
ka = {
  rangeOverflow: (e) => `El valor debe ser ${e.maxValue} o anterior.`,
  rangeReversed: "La fecha de inicio debe ser anterior a la fecha de finalización.",
  rangeUnderflow: (e) => `El valor debe ser ${e.minValue} o posterior.`,
  unavailableDate: "Fecha seleccionada no disponible."
};
var Va = {};
Va = {
  rangeOverflow: (e) => `Väärtus peab olema ${e.maxValue} või varasem.`,
  rangeReversed: "Alguskuupäev peab olema enne lõppkuupäeva.",
  rangeUnderflow: (e) => `Väärtus peab olema ${e.minValue} või hilisem.`,
  unavailableDate: "Valitud kuupäev pole saadaval."
};
var wa = {};
wa = {
  rangeOverflow: (e) => `Arvon on oltava ${e.maxValue} tai sitä aikaisempi.`,
  rangeReversed: "Aloituspäivän on oltava ennen lopetuspäivää.",
  rangeUnderflow: (e) => `Arvon on oltava ${e.minValue} tai sitä myöhäisempi.`,
  unavailableDate: "Valittu päivämäärä ei ole käytettävissä."
};
var Aa = {};
Aa = {
  rangeOverflow: (e) => `La valeur doit être ${e.maxValue} ou antérieure.`,
  rangeReversed: "La date de début doit être antérieure à la date de fin.",
  rangeUnderflow: (e) => `La valeur doit être ${e.minValue} ou ultérieure.`,
  unavailableDate: "La date sélectionnée n’est pas disponible."
};
var Ra = {};
Ra = {
  rangeOverflow: (e) => `הערך חייב להיות ${e.maxValue} או מוקדם יותר.`,
  rangeReversed: "תאריך ההתחלה חייב להיות לפני תאריך הסיום.",
  rangeUnderflow: (e) => `הערך חייב להיות ${e.minValue} או מאוחר יותר.`,
  unavailableDate: "התאריך הנבחר אינו זמין."
};
var Oa = {};
Oa = {
  rangeOverflow: (e) => `Vrijednost mora biti ${e.maxValue} ili ranije.`,
  rangeReversed: "Datum početka mora biti prije datuma završetka.",
  rangeUnderflow: (e) => `Vrijednost mora biti ${e.minValue} ili kasnije.`,
  unavailableDate: "Odabrani datum nije dostupan."
};
var Ta = {};
Ta = {
  rangeOverflow: (e) => `Az értéknek ${e.maxValue} vagy korábbinak kell lennie.`,
  rangeReversed: "A kezdő dátumnak a befejező dátumnál korábbinak kell lennie.",
  rangeUnderflow: (e) => `Az értéknek ${e.minValue} vagy későbbinek kell lennie.`,
  unavailableDate: "A kiválasztott dátum nem érhető el."
};
var ja = {};
ja = {
  rangeOverflow: (e) => `Il valore deve essere ${e.maxValue} o precedente.`,
  rangeReversed: "La data di inizio deve essere antecedente alla data di fine.",
  rangeUnderflow: (e) => `Il valore deve essere ${e.minValue} o successivo.`,
  unavailableDate: "Data selezionata non disponibile."
};
var Sa = {};
Sa = {
  rangeOverflow: (e) => `値は ${e.maxValue} 以下にする必要があります。`,
  rangeReversed: "開始日は終了日より前にする必要があります。",
  rangeUnderflow: (e) => `値は ${e.minValue} 以上にする必要があります。`,
  unavailableDate: "選択した日付は使用できません。"
};
var Ia = {};
Ia = {
  rangeOverflow: (e) => `값은 ${e.maxValue} 이전이어야 합니다.`,
  rangeReversed: "시작일은 종료일 이전이어야 합니다.",
  rangeUnderflow: (e) => `값은 ${e.minValue} 이상이어야 합니다.`,
  unavailableDate: "선택한 날짜를 사용할 수 없습니다."
};
var za = {};
za = {
  rangeOverflow: (e) => `Reikšmė turi būti ${e.maxValue} arba ankstesnė.`,
  rangeReversed: "Pradžios data turi būti ankstesnė nei pabaigos data.",
  rangeUnderflow: (e) => `Reikšmė turi būti ${e.minValue} arba naujesnė.`,
  unavailableDate: "Pasirinkta data nepasiekiama."
};
var Na = {};
Na = {
  rangeOverflow: (e) => `Vērtībai ir jābūt ${e.maxValue} vai agrākai.`,
  rangeReversed: "Sākuma datumam ir jābūt pirms beigu datuma.",
  rangeUnderflow: (e) => `Vērtībai ir jābūt ${e.minValue} vai vēlākai.`,
  unavailableDate: "Atlasītais datums nav pieejams."
};
var Za = {};
Za = {
  rangeOverflow: (e) => `Verdien må være ${e.maxValue} eller tidligere.`,
  rangeReversed: "Startdatoen må være før sluttdatoen.",
  rangeUnderflow: (e) => `Verdien må være ${e.minValue} eller senere.`,
  unavailableDate: "Valgt dato utilgjengelig."
};
var Ma = {};
Ma = {
  rangeOverflow: (e) => `Waarde moet ${e.maxValue} of eerder zijn.`,
  rangeReversed: "De startdatum moet voor de einddatum liggen.",
  rangeUnderflow: (e) => `Waarde moet ${e.minValue} of later zijn.`,
  unavailableDate: "Geselecteerde datum niet beschikbaar."
};
var Ua = {};
Ua = {
  rangeOverflow: (e) => `Wartość musi mieć wartość ${e.maxValue} lub wcześniejszą.`,
  rangeReversed: "Data rozpoczęcia musi być wcześniejsza niż data zakończenia.",
  rangeUnderflow: (e) => `Wartość musi mieć wartość ${e.minValue} lub późniejszą.`,
  unavailableDate: "Wybrana data jest niedostępna."
};
var Ka = {};
Ka = {
  rangeOverflow: (e) => `O valor deve ser ${e.maxValue} ou anterior.`,
  rangeReversed: "A data inicial deve ser anterior à data final.",
  rangeUnderflow: (e) => `O valor deve ser ${e.minValue} ou posterior.`,
  unavailableDate: "Data selecionada indisponível."
};
var La = {};
La = {
  rangeOverflow: (e) => `O valor tem de ser ${e.maxValue} ou anterior.`,
  rangeReversed: "A data de início deve ser anterior à data de fim.",
  rangeUnderflow: (e) => `O valor tem de ser ${e.minValue} ou posterior.`,
  unavailableDate: "Data selecionada indisponível."
};
var Wa = {};
Wa = {
  rangeOverflow: (e) => `Valoarea trebuie să fie ${e.maxValue} sau anterioară.`,
  rangeReversed: "Data de început trebuie să fie anterioară datei de sfârșit.",
  rangeUnderflow: (e) => `Valoarea trebuie să fie ${e.minValue} sau ulterioară.`,
  unavailableDate: "Data selectată nu este disponibilă."
};
var _a = {};
_a = {
  rangeOverflow: (e) => `Значение должно быть не позже ${e.maxValue}.`,
  rangeReversed: "Дата начала должна предшествовать дате окончания.",
  rangeUnderflow: (e) => `Значение должно быть не раньше ${e.minValue}.`,
  unavailableDate: "Выбранная дата недоступна."
};
var Ga = {};
Ga = {
  rangeOverflow: (e) => `Hodnota musí byť ${e.maxValue} alebo skoršia.`,
  rangeReversed: "Dátum začiatku musí byť skorší ako dátum konca.",
  rangeUnderflow: (e) => `Hodnota musí byť ${e.minValue} alebo neskoršia.`,
  unavailableDate: "Vybratý dátum je nedostupný."
};
var Ha = {};
Ha = {
  rangeOverflow: (e) => `Vrednost mora biti ${e.maxValue} ali starejša.`,
  rangeReversed: "Začetni datum mora biti pred končnim datumom.",
  rangeUnderflow: (e) => `Vrednost mora biti ${e.minValue} ali novejša.`,
  unavailableDate: "Izbrani datum ni na voljo."
};
var qa = {};
qa = {
  rangeOverflow: (e) => `Vrednost mora da bude ${e.maxValue} ili starija.`,
  rangeReversed: "Datum početka mora biti pre datuma završetka.",
  rangeUnderflow: (e) => `Vrednost mora da bude ${e.minValue} ili novija.`,
  unavailableDate: "Izabrani datum nije dostupan."
};
var Ja = {};
Ja = {
  rangeOverflow: (e) => `Värdet måste vara ${e.maxValue} eller tidigare.`,
  rangeReversed: "Startdatumet måste vara före slutdatumet.",
  rangeUnderflow: (e) => `Värdet måste vara ${e.minValue} eller senare.`,
  unavailableDate: "Det valda datumet är inte tillgängligt."
};
var Ya = {};
Ya = {
  rangeOverflow: (e) => `Değer, ${e.maxValue} veya öncesi olmalıdır.`,
  rangeReversed: "Başlangıç tarihi bitiş tarihinden önce olmalıdır.",
  rangeUnderflow: (e) => `Değer, ${e.minValue} veya sonrası olmalıdır.`,
  unavailableDate: "Seçilen tarih kullanılamıyor."
};
var Qa = {};
Qa = {
  rangeOverflow: (e) => `Значення має бути не пізніше ${e.maxValue}.`,
  rangeReversed: "Дата початку має передувати даті завершення.",
  rangeUnderflow: (e) => `Значення має бути не раніше ${e.minValue}.`,
  unavailableDate: "Вибрана дата недоступна."
};
var Xa = {};
Xa = {
  rangeOverflow: (e) => `值必须是 ${e.maxValue} 或更早日期。`,
  rangeReversed: "开始日期必须早于结束日期。",
  rangeUnderflow: (e) => `值必须是 ${e.minValue} 或更晚日期。`,
  unavailableDate: "所选日期不可用。"
};
var eu = {};
eu = {
  rangeOverflow: (e) => `值必須是 ${e.maxValue} 或更早。`,
  rangeReversed: "開始日期必須在結束日期之前。",
  rangeUnderflow: (e) => `值必須是 ${e.minValue} 或更晚。`,
  unavailableDate: "所選日期無法使用。"
};
var au = {};
au = {
  "ar-AE": pa,
  "bg-BG": Ba,
  "cs-CZ": Ca,
  "da-DK": ga,
  "de-DE": Ea,
  "el-GR": Fa,
  "en-US": Pa,
  "es-ES": ka,
  "et-EE": Va,
  "fi-FI": wa,
  "fr-FR": Aa,
  "he-IL": Ra,
  "hr-HR": Oa,
  "hu-HU": Ta,
  "it-IT": ja,
  "ja-JP": Sa,
  "ko-KR": Ia,
  "lt-LT": za,
  "lv-LV": Na,
  "nb-NO": Za,
  "nl-NL": Ma,
  "pl-PL": Ua,
  "pt-BR": Ka,
  "pt-PT": La,
  "ro-RO": Wa,
  "ru-RU": _a,
  "sk-SK": Ga,
  "sl-SI": Ha,
  "sr-SP": qa,
  "sv-SE": Ja,
  "tr-TR": Ya,
  "uk-UA": Qa,
  "zh-CN": Xa,
  "zh-TW": eu
};
function dt(e) {
  return e && e.__esModule ? e.default : e;
}
const lt = new ve(dt(au));
function ot() {
  return typeof navigator < "u" && (navigator.language || navigator.userLanguage) || "en-US";
}
function uu(e, a, u, t, r) {
  let l = e != null && u != null && e.compare(u) > 0, d = e != null && a != null && e.compare(a) < 0, m = e != null && (t == null ? void 0 : t(e)) || !1, n = l || d || m, f = [];
  if (n) {
    let c = ot(), i = ve.getGlobalDictionaryForPackage("@react-stately/datepicker") || lt, v = new Au(c, i), p = new G(c, q({}, r)), k = p.resolvedOptions().timeZone;
    d && a != null && f.push(v.format("rangeUnderflow", {
      minValue: p.format(a.toDate(k))
    })), l && u != null && f.push(v.format("rangeOverflow", {
      maxValue: p.format(u.toDate(k))
    })), m && f.push(v.format("unavailableDate"));
  }
  return {
    isInvalid: n,
    validationErrors: f,
    validationDetails: {
      badInput: m,
      customError: !1,
      patternMismatch: !1,
      rangeOverflow: l,
      rangeUnderflow: d,
      stepMismatch: !1,
      tooLong: !1,
      tooShort: !1,
      typeMismatch: !1,
      valueMissing: !1,
      valid: !n
    }
  };
}
const st = {
  year: "numeric",
  month: "numeric",
  day: "numeric",
  hour: "numeric",
  minute: "2-digit",
  second: "2-digit"
}, ct = {
  year: "numeric",
  month: "2-digit",
  day: "2-digit",
  hour: "2-digit",
  minute: "2-digit",
  second: "2-digit"
};
function q(e, a) {
  e = {
    ...a.shouldForceLeadingZeros ? ct : st,
    ...e
  };
  let t = a.granularity || "minute", r = Object.keys(e);
  var l;
  let d = r.indexOf((l = a.maxGranularity) !== null && l !== void 0 ? l : "year");
  d < 0 && (d = 0);
  let m = r.indexOf(t);
  if (m < 0 && (m = 2), d > m) throw new Error("maxGranularity must be greater than granularity");
  let n = r.slice(d, m + 1).reduce((c, i) => (c[i] = e[i], c), {});
  return a.hourCycle != null && (n.hour12 = a.hourCycle === 12), n.timeZone = a.timeZone || "UTC", (t === "hour" || t === "minute" || t === "second") && a.timeZone && !a.hideTimeZone && (n.timeZoneName = "short"), a.showEra && d === 0 && (n.era = "short"), n;
}
function Be(e) {
  return e && "hour" in e ? e : new ou();
}
function tu(e, a) {
  if (e === null) return null;
  if (e)
    return ue(e, a);
}
function ae(e, a, u, t) {
  if (e) return tu(e, u);
  let r = ue(su(t ?? cu()).set({
    hour: 0,
    minute: 0,
    second: 0,
    millisecond: 0
  }), u);
  return a === "year" || a === "month" || a === "day" ? ge(r) : t ? r : Ee(r);
}
function ru(e, a) {
  let u = e && "timeZone" in e ? e.timeZone : void 0, t = e && "minute" in e ? "minute" : "day";
  if (e && a && !(a in e)) throw new Error("Invalid granularity " + a + " for value " + e.toString());
  let [r, l] = Y([
    t,
    u
  ]);
  e && (r[0] !== t || r[1] !== u) && l([
    t,
    u
  ]), a || (a = e ? t : r[0]);
  let d = e ? u : r[1];
  return [
    a,
    d
  ];
}
function mt(e) {
  let a = qu(e), [u, t] = ze(e.value, e.defaultValue || null, e.onChange), r = u || e.placeholderValue || null, [l, d] = ru(r, e.granularity), m = u != null ? u.toDate(d ?? "UTC") : null, n = l === "hour" || l === "minute" || l === "second";
  var f;
  let c = (f = e.shouldCloseOnSelect) !== null && f !== void 0 ? f : !0, [i, v] = Y(null), [p, k] = Y(null);
  if (u && (i = u, "hour" in u && (p = u)), r && !(l in r)) throw new Error("Invalid granularity " + l + " for value " + r.toString());
  let y = (u == null ? void 0 : u.calendar.identifier) === "gregory" && u.era === "BC", g = C(() => ({
    granularity: l,
    timeZone: d,
    hideTimeZone: e.hideTimeZone,
    hourCycle: e.hourCycle,
    shouldForceLeadingZeros: e.shouldForceLeadingZeros,
    showEra: y
  }), [
    l,
    e.hourCycle,
    e.shouldForceLeadingZeros,
    d,
    e.hideTimeZone,
    y
  ]), { minValue: w, maxValue: S, isDateUnavailable: E } = e, V = C(() => uu(u, w, S, E, g), [
    u,
    w,
    S,
    E,
    g
  ]), O = Ie({
    ...e,
    value: u,
    builtinValidation: V
  }), I = O.displayValidation.isInvalid, T = e.validationState || (I ? "invalid" : null), F = (D, b) => {
    t("timeZone" in b ? b.set(ge(D)) : Ee(D, b)), v(null), k(null), O.commitValidation();
  };
  return {
    ...O,
    value: u,
    setValue: t,
    dateValue: i,
    timeValue: p,
    setDateValue: (D) => {
      let b = typeof c == "function" ? c() : c;
      n ? p || b ? F(D, p || Be(e.defaultValue || e.placeholderValue)) : v(D) : (t(D), O.commitValidation()), b && a.setOpen(!1);
    },
    setTimeValue: (D) => {
      i && D ? F(i, D) : k(D);
    },
    granularity: l,
    hasTime: n,
    ...a,
    setOpen(D) {
      !D && !u && i && n && F(i, p || Be(e.defaultValue || e.placeholderValue)), a.setOpen(D);
    },
    validationState: T,
    isInvalid: I,
    formatValue(D, b) {
      if (!m) return "";
      let $ = q(b, g);
      return new G(D, $).format(m);
    },
    getDateFormatter(D, b) {
      let $ = {
        ...g,
        ...b
      }, N = q({}, $);
      return new G(D, N);
    }
  };
}
const ft = new ve({
  ach: {
    year: "mwaka",
    month: "dwe",
    day: "nino"
  },
  af: {
    year: "jjjj",
    month: "mm",
    day: "dd"
  },
  am: {
    year: "ዓዓዓዓ",
    month: "ሚሜ",
    day: "ቀቀ"
  },
  an: {
    year: "aaaa",
    month: "mm",
    day: "dd"
  },
  ar: {
    year: "سنة",
    month: "شهر",
    day: "يوم"
  },
  ast: {
    year: "aaaa",
    month: "mm",
    day: "dd"
  },
  az: {
    year: "iiii",
    month: "aa",
    day: "gg"
  },
  be: {
    year: "гггг",
    month: "мм",
    day: "дд"
  },
  bg: {
    year: "гггг",
    month: "мм",
    day: "дд"
  },
  bn: {
    year: "yyyy",
    month: "মিমি",
    day: "dd"
  },
  br: {
    year: "bbbb",
    month: "mm",
    day: "dd"
  },
  bs: {
    year: "gggg",
    month: "mm",
    day: "dd"
  },
  ca: {
    year: "aaaa",
    month: "mm",
    day: "dd"
  },
  cak: {
    year: "jjjj",
    month: "ii",
    day: "q'q'"
  },
  ckb: {
    year: "ساڵ",
    month: "مانگ",
    day: "ڕۆژ"
  },
  cs: {
    year: "rrrr",
    month: "mm",
    day: "dd"
  },
  cy: {
    year: "bbbb",
    month: "mm",
    day: "dd"
  },
  da: {
    year: "åååå",
    month: "mm",
    day: "dd"
  },
  de: {
    year: "jjjj",
    month: "mm",
    day: "tt"
  },
  dsb: {
    year: "llll",
    month: "mm",
    day: "źź"
  },
  el: {
    year: "εεεε",
    month: "μμ",
    day: "ηη"
  },
  en: {
    year: "yyyy",
    month: "mm",
    day: "dd"
  },
  eo: {
    year: "jjjj",
    month: "mm",
    day: "tt"
  },
  es: {
    year: "aaaa",
    month: "mm",
    day: "dd"
  },
  et: {
    year: "aaaa",
    month: "kk",
    day: "pp"
  },
  eu: {
    year: "uuuu",
    month: "hh",
    day: "ee"
  },
  fa: {
    year: "سال",
    month: "ماه",
    day: "روز"
  },
  ff: {
    year: "hhhh",
    month: "ll",
    day: "ññ"
  },
  fi: {
    year: "vvvv",
    month: "kk",
    day: "pp"
  },
  fr: {
    year: "aaaa",
    month: "mm",
    day: "jj"
  },
  fy: {
    year: "jjjj",
    month: "mm",
    day: "dd"
  },
  ga: {
    year: "bbbb",
    month: "mm",
    day: "ll"
  },
  gd: {
    year: "bbbb",
    month: "mm",
    day: "ll"
  },
  gl: {
    year: "aaaa",
    month: "mm",
    day: "dd"
  },
  he: {
    year: "שנה",
    month: "חודש",
    day: "יום"
  },
  hr: {
    year: "gggg",
    month: "mm",
    day: "dd"
  },
  hsb: {
    year: "llll",
    month: "mm",
    day: "dd"
  },
  hu: {
    year: "éééé",
    month: "hh",
    day: "nn"
  },
  ia: {
    year: "aaaa",
    month: "mm",
    day: "dd"
  },
  id: {
    year: "tttt",
    month: "bb",
    day: "hh"
  },
  it: {
    year: "aaaa",
    month: "mm",
    day: "gg"
  },
  ja: {
    year: "年",
    month: "月",
    day: "日"
  },
  ka: {
    year: "წწწწ",
    month: "თთ",
    day: "რრ"
  },
  kk: {
    year: "жжжж",
    month: "аа",
    day: "кк"
  },
  kn: {
    year: "ವವವವ",
    month: "ಮಿಮೀ",
    day: "ದಿದಿ"
  },
  ko: {
    year: "연도",
    month: "월",
    day: "일"
  },
  lb: {
    year: "jjjj",
    month: "mm",
    day: "dd"
  },
  lo: {
    year: "ປປປປ",
    month: "ດດ",
    day: "ວວ"
  },
  lt: {
    year: "mmmm",
    month: "mm",
    day: "dd"
  },
  lv: {
    year: "gggg",
    month: "mm",
    day: "dd"
  },
  meh: {
    year: "aaaa",
    month: "mm",
    day: "dd"
  },
  ml: {
    year: "വർഷം",
    month: "മാസം",
    day: "തീയതി"
  },
  ms: {
    year: "tttt",
    month: "mm",
    day: "hh"
  },
  nl: {
    year: "jjjj",
    month: "mm",
    day: "dd"
  },
  nn: {
    year: "åååå",
    month: "mm",
    day: "dd"
  },
  no: {
    year: "åååå",
    month: "mm",
    day: "dd"
  },
  oc: {
    year: "aaaa",
    month: "mm",
    day: "jj"
  },
  pl: {
    year: "rrrr",
    month: "mm",
    day: "dd"
  },
  pt: {
    year: "aaaa",
    month: "mm",
    day: "dd"
  },
  rm: {
    year: "oooo",
    month: "mm",
    day: "dd"
  },
  ro: {
    year: "aaaa",
    month: "ll",
    day: "zz"
  },
  ru: {
    year: "гггг",
    month: "мм",
    day: "дд"
  },
  sc: {
    year: "aaaa",
    month: "mm",
    day: "dd"
  },
  scn: {
    year: "aaaa",
    month: "mm",
    day: "jj"
  },
  sk: {
    year: "rrrr",
    month: "mm",
    day: "dd"
  },
  sl: {
    year: "llll",
    month: "mm",
    day: "dd"
  },
  sr: {
    year: "гггг",
    month: "мм",
    day: "дд"
  },
  sv: {
    year: "åååå",
    month: "mm",
    day: "dd"
  },
  szl: {
    year: "rrrr",
    month: "mm",
    day: "dd"
  },
  tg: {
    year: "сссс",
    month: "мм",
    day: "рр"
  },
  th: {
    year: "ปปปป",
    month: "ดด",
    day: "วว"
  },
  tr: {
    year: "yyyy",
    month: "aa",
    day: "gg"
  },
  uk: {
    year: "рррр",
    month: "мм",
    day: "дд"
  },
  "zh-CN": {
    year: "年",
    month: "月",
    day: "日"
  },
  "zh-TW": {
    year: "年",
    month: "月",
    day: "日"
  }
}, "en");
function Dt(e, a, u) {
  return e === "era" || e === "dayPeriod" ? a : e === "year" || e === "month" || e === "day" ? ft.getStringForLocale(e, u) : "––";
}
const ce = {
  year: !0,
  month: !0,
  day: !0,
  hour: !0,
  minute: !0,
  second: !0,
  dayPeriod: !0,
  era: !0
}, Ce = {
  year: 5,
  month: 2,
  day: 7,
  hour: 2,
  minute: 15,
  second: 15
}, $t = {
  dayperiod: "dayPeriod"
};
function yt(e) {
  let { locale: a, createCalendar: u, hideTimeZone: t, isDisabled: r = !1, isReadOnly: l = !1, isRequired: d = !1, minValue: m, maxValue: n, isDateUnavailable: f } = e, c = e.value || e.defaultValue || e.placeholderValue || null, [i, v] = ru(c, e.granularity), p = v || "UTC";
  if (c && !(i in c)) throw new Error("Invalid granularity " + i + " for value " + c.toString());
  let k = C(() => new G(a), [
    a
  ]), y = C(() => u(k.resolvedOptions().calendar), [
    u,
    k
  ]);
  var g;
  let [w, S] = ze(e.value, (g = e.defaultValue) !== null && g !== void 0 ? g : null, e.onChange), E = C(() => {
    var s;
    return (s = tu(w, y)) !== null && s !== void 0 ? s : null;
  }, [
    w,
    y
  ]), [V, O] = Y(() => ae(e.placeholderValue, i, y, v)), I = E || V, T = y.identifier === "gregory" && I.era === "BC", F = C(() => {
    var s;
    return {
      granularity: i,
      maxGranularity: (s = e.maxGranularity) !== null && s !== void 0 ? s : "year",
      timeZone: v,
      hideTimeZone: t,
      hourCycle: e.hourCycle,
      showEra: T,
      shouldForceLeadingZeros: e.shouldForceLeadingZeros
    };
  }, [
    e.maxGranularity,
    i,
    e.hourCycle,
    e.shouldForceLeadingZeros,
    v,
    t,
    T
  ]), A = C(() => q({}, F), [
    F
  ]), h = C(() => new G(a, A), [
    a,
    A
  ]), D = C(() => h.resolvedOptions(), [
    h
  ]), b = C(() => h.formatToParts(/* @__PURE__ */ new Date()).filter((s) => ce[s.type]).reduce((s, R) => (s[R.type] = !0, s), {}), [
    h
  ]), [$, N] = Y(() => e.value || e.defaultValue ? {
    ...b
  } : {}), X = M(null), U = M(y.identifier);
  we(() => {
    y.identifier !== U.current && (U.current = y.identifier, O((s) => Object.keys($).length > 0 ? ue(s, y) : ae(e.placeholderValue, i, y, v)));
  }, [
    y,
    i,
    $,
    v,
    e.placeholderValue
  ]), w && Object.keys($).length < Object.keys(b).length && ($ = {
    ...b
  }, N($)), w == null && Object.keys($).length === Object.keys(b).length && ($ = {}, N($), O(ae(e.placeholderValue, i, y, v)));
  let P = E && Object.keys($).length >= Object.keys(b).length ? E : V, K = (s) => {
    if (e.isDisabled || e.isReadOnly) return;
    let R = Object.keys($), z = Object.keys(b);
    s == null ? (S(null), O(ae(e.placeholderValue, i, y, v)), N({})) : R.length >= z.length || R.length === z.length - 1 && b.dayPeriod && !$.dayPeriod && X.current !== "dayPeriod" ? (s = ue(s, (c == null ? void 0 : c.calendar) || new mu()), S(s)) : O(s), X.current = null;
  }, L = C(() => P.toDate(p), [
    P,
    p
  ]), o = C(() => bt(L, $, h, D, P, y, a, i), [
    L,
    $,
    h,
    D,
    P,
    y,
    a,
    i
  ]);
  b.era && $.year && !$.era ? ($.era = !0, N({
    ...$
  })) : !b.era && $.era && (delete $.era, N({
    ...$
  }));
  let x = (s) => {
    $[s] = !0, s === "year" && b.era && ($.era = !0), N({
      ...$
    });
  }, B = (s, R) => {
    if ($[s])
      K(vt(P, s, R, D));
    else {
      x(s);
      let z = Object.keys($), _ = Object.keys(b);
      (z.length >= _.length || z.length === _.length - 1 && b.dayPeriod && !$.dayPeriod) && K(P);
    }
  }, j = C(() => uu(w, m, n, f, F), [
    w,
    m,
    n,
    f,
    F
  ]), W = Ie({
    ...e,
    value: w,
    builtinValidation: j
  }), H = W.displayValidation.isInvalid, $e = e.validationState || (H ? "invalid" : null);
  var ee;
  return {
    ...W,
    value: E,
    dateValue: L,
    calendar: y,
    setValue: K,
    segments: o,
    dateFormatter: h,
    validationState: $e,
    isInvalid: H,
    granularity: i,
    maxGranularity: (ee = e.maxGranularity) !== null && ee !== void 0 ? ee : "year",
    isDisabled: r,
    isReadOnly: l,
    isRequired: d,
    increment(s) {
      B(s, 1);
    },
    decrement(s) {
      B(s, -1);
    },
    incrementPage(s) {
      B(s, Ce[s] || 1);
    },
    decrementPage(s) {
      B(s, -(Ce[s] || 1));
    },
    setSegment(s, R) {
      x(s), K(xt(P, s, R, D));
    },
    confirmPlaceholder() {
      if (e.isDisabled || e.isReadOnly) return;
      let s = Object.keys($), R = Object.keys(b);
      s.length === R.length - 1 && b.dayPeriod && !$.dayPeriod && ($ = {
        ...b
      }, N($), K(P.copy()));
    },
    clearSegment(s) {
      delete $[s], X.current = s, N({
        ...$
      });
      let R = ae(e.placeholderValue, i, y, v), z = P;
      if (s === "dayPeriod" && "hour" in P && "hour" in R) {
        let _ = P.hour >= 12, he = R.hour >= 12;
        _ && !he ? z = P.set({
          hour: P.hour - 12
        }) : !_ && he && (z = P.set({
          hour: P.hour + 12
        }));
      } else s === "hour" && "hour" in P && P.hour >= 12 && $.dayPeriod ? z = P.set({
        hour: R.hour + 12
      }) : s in P && (z = P.set({
        [s]: R[s]
      }));
      S(null), K(z);
    },
    formatValue(s) {
      if (!E) return "";
      let R = q(s, F);
      return new G(a, R).format(L);
    },
    getDateFormatter(s, R) {
      let z = {
        ...F,
        ...R
      }, _ = q({}, z);
      return new G(s, _);
    }
  };
}
function bt(e, a, u, t, r, l, d, m) {
  let n = [
    "hour",
    "minute",
    "second"
  ], f = u.formatToParts(e), c = [];
  for (let i of f) {
    let v = ce[i.type];
    i.type === "era" && l.getEras().length === 1 && (v = !1);
    let p = ce[i.type] && !a[i.type], k = ce[i.type] ? Dt(i.type, i.value, d) : null, y = {
      type: $t[i.type] || i.type,
      text: p ? k : i.value,
      ...de(r, i.type, t),
      isPlaceholder: p,
      placeholder: k,
      isEditable: v
    };
    i.type === "hour" ? (c.push({
      type: "literal",
      text: "⁦",
      ...de(r, "literal", t),
      isPlaceholder: !1,
      placeholder: "",
      isEditable: !1
    }), c.push(y), i.type === m && c.push({
      type: "literal",
      text: "⁩",
      ...de(r, "literal", t),
      isPlaceholder: !1,
      placeholder: "",
      isEditable: !1
    })) : n.includes(i.type) && i.type === m ? (c.push(y), c.push({
      type: "literal",
      text: "⁩",
      ...de(r, "literal", t),
      isPlaceholder: !1,
      placeholder: "",
      isEditable: !1
    })) : c.push(y);
  }
  return c;
}
function de(e, a, u) {
  switch (a) {
    case "era": {
      let t = e.calendar.getEras();
      return {
        value: t.indexOf(e.era),
        minValue: 0,
        maxValue: t.length - 1
      };
    }
    case "year":
      return {
        value: e.year,
        minValue: 1,
        maxValue: e.calendar.getYearsInEra(e)
      };
    case "month":
      return {
        value: e.month,
        minValue: Du(e),
        maxValue: e.calendar.getMonthsInYear(e)
      };
    case "day":
      return {
        value: e.day,
        minValue: fu(e),
        maxValue: e.calendar.getDaysInMonth(e)
      };
  }
  if ("hour" in e) switch (a) {
    case "dayPeriod":
      return {
        value: e.hour >= 12 ? 12 : 0,
        minValue: 0,
        maxValue: 12
      };
    case "hour":
      if (u.hour12) {
        let t = e.hour >= 12;
        return {
          value: e.hour,
          minValue: t ? 12 : 0,
          maxValue: t ? 23 : 11
        };
      }
      return {
        value: e.hour,
        minValue: 0,
        maxValue: 23
      };
    case "minute":
      return {
        value: e.minute,
        minValue: 0,
        maxValue: 59
      };
    case "second":
      return {
        value: e.second,
        minValue: 0,
        maxValue: 59
      };
  }
  return {};
}
function vt(e, a, u, t) {
  switch (a) {
    case "era":
    case "year":
    case "month":
    case "day":
      return e.cycle(a, u, {
        round: a === "year"
      });
  }
  if ("hour" in e) switch (a) {
    case "dayPeriod": {
      let r = e.hour, l = r >= 12;
      return e.set({
        hour: l ? r - 12 : r + 12
      });
    }
    case "hour":
    case "minute":
    case "second":
      return e.cycle(a, u, {
        round: a !== "hour",
        hourCycle: t.hour12 ? 12 : 24
      });
  }
  throw new Error("Unknown segment: " + a);
}
function xt(e, a, u, t) {
  switch (a) {
    case "day":
    case "month":
    case "year":
    case "era":
      return e.set({
        [a]: u
      });
  }
  if ("hour" in e && typeof u == "number") switch (a) {
    case "dayPeriod": {
      let r = e.hour, l = r >= 12;
      return u >= 12 === l ? e : e.set({
        hour: l ? r - 12 : r + 12
      });
    }
    case "hour":
      if (t.hour12) {
        let l = e.hour >= 12;
        !l && u === 12 && (u = 0), l && u < 12 && (u += 12);
      }
    // fallthrough
    case "minute":
    case "second":
      return e.set({
        [a]: u
      });
  }
  throw new Error("Unknown segment: " + a);
}
const nu = /* @__PURE__ */ re(null), De = /* @__PURE__ */ re(null), xe = /* @__PURE__ */ re(null), er = /* @__PURE__ */ te(function(a, u) {
  let t = Q(De), r = Q(xe);
  return t || r ? /* @__PURE__ */ Z.createElement(iu, {
    ...a,
    ref: u
  }) : /* @__PURE__ */ Z.createElement(ht, {
    ...a,
    ref: u
  });
}), ht = /* @__PURE__ */ te((e, a) => {
  let [u, t] = Pe({
    slot: e.slot
  }, a, nu), { locale: r } = ne(), l = yt({
    ...u,
    locale: r,
    createCalendar: $u
  }), d = M(null), { fieldProps: m, inputProps: n } = Xu({
    ...u,
    inputRef: d
  }, l, t);
  return /* @__PURE__ */ Z.createElement(ke, {
    values: [
      [
        De,
        l
      ],
      [
        gu,
        {
          ...n,
          ref: d
        }
      ],
      [
        Ve,
        {
          ...m,
          ref: t,
          isInvalid: l.isInvalid
        }
      ]
    ]
  }, /* @__PURE__ */ Z.createElement(iu, e));
}), iu = /* @__PURE__ */ te((e, a) => {
  let { className: u, children: t } = e, r = Q(De), l = Q(xe), d = r ?? l;
  return /* @__PURE__ */ Z.createElement(Z.Fragment, null, /* @__PURE__ */ Z.createElement(Bu, {
    ...e,
    ref: a,
    slot: e.slot || void 0,
    className: u ?? "react-aria-DateInput",
    isInvalid: d.isInvalid
  }, d.segments.map((m, n) => /* @__PURE__ */ Eu(t(m), {
    key: n
  }))), /* @__PURE__ */ Z.createElement(Cu, null));
}), ar = /* @__PURE__ */ te(function({ segment: a, ...u }, t) {
  let r = Q(De), l = Q(xe), d = r ?? l, m = vu(t), { segmentProps: n } = nt(a, d, m), { focusProps: f, isFocused: c, isFocusVisible: i } = Te(), { hoverProps: v, isHovered: p } = Su({
    ...u,
    isDisabled: d.isDisabled || a.type === "literal"
  }), k = Fe({
    ...u,
    values: {
      ...a,
      isReadOnly: !a.isEditable,
      isInvalid: d.isInvalid,
      isDisabled: d.isDisabled,
      isHovered: p,
      isFocused: c,
      isFocusVisible: i
    },
    defaultChildren: a.text,
    defaultClassName: "react-aria-DateSegment"
  });
  return /* @__PURE__ */ Z.createElement("span", {
    ...J(me(u), n, f, v),
    ...k,
    style: n.style,
    ref: m,
    "data-placeholder": a.isPlaceholder || void 0,
    "data-invalid": d.isInvalid || void 0,
    "data-readonly": !a.isEditable || void 0,
    "data-disabled": d.isDisabled || void 0,
    "data-type": a.type,
    "data-hovered": p || void 0,
    "data-focused": c || void 0,
    "data-focus-visible": i || void 0
  });
}), pt = /* @__PURE__ */ re(null), Bt = /* @__PURE__ */ re(null), ur = /* @__PURE__ */ te(function(a, u) {
  [a, u] = Pe(a, u, pt);
  let { validationBehavior: t } = xu(Uu) || {};
  var r, l;
  let d = (l = (r = a.validationBehavior) !== null && r !== void 0 ? r : t) !== null && l !== void 0 ? l : "native", m = mt({
    ...a,
    validationBehavior: d
  }), n = M(null), [f, c] = hu(!a["aria-label"] && !a["aria-labelledby"]), { groupProps: i, labelProps: v, fieldProps: p, buttonProps: k, dialogProps: y, calendarProps: g, descriptionProps: w, errorMessageProps: S, ...E } = at({
    ...pu(a),
    label: c,
    validationBehavior: d
  }, m, n), [V, O] = Y(null), I = oe(() => {
    n.current && O(n.current.offsetWidth + "px");
  }, []);
  Hu({
    ref: n,
    onResize: I
  });
  let { focusProps: T, isFocused: F, isFocusVisible: A } = Te({
    within: !0
  }), h = Fe({
    ...a,
    values: {
      state: m,
      isFocusWithin: F,
      isFocusVisible: A,
      isDisabled: a.isDisabled || !1,
      isInvalid: m.isInvalid,
      isOpen: m.isOpen
    },
    defaultClassName: "react-aria-DatePicker"
  }), D = me(a);
  return delete D.id, /* @__PURE__ */ Z.createElement(ke, {
    values: [
      [
        Bt,
        m
      ],
      [
        Ve,
        {
          ...i,
          ref: n,
          isInvalid: m.isInvalid
        }
      ],
      [
        nu,
        p
      ],
      [
        du,
        {
          ...k,
          isPressed: m.isOpen
        }
      ],
      [
        Wu,
        {
          ...v,
          ref: f,
          elementType: "span"
        }
      ],
      [
        yu,
        g
      ],
      [
        Ku,
        m
      ],
      [
        _u,
        {
          trigger: "DatePicker",
          triggerRef: n,
          placement: "bottom start",
          style: {
            "--trigger-width": V
          }
        }
      ],
      [
        Lu,
        y
      ],
      [
        Gu,
        {
          slots: {
            description: w,
            errorMessage: S
          }
        }
      ],
      [
        ku,
        E
      ]
    ]
  }, /* @__PURE__ */ Z.createElement("div", {
    ...T,
    ...D,
    ...h,
    ref: u,
    slot: a.slot || void 0,
    "data-focus-within": F || void 0,
    "data-invalid": m.isInvalid || void 0,
    "data-focus-visible": A || void 0,
    "data-disabled": a.isDisabled || void 0,
    "data-open": m.isOpen || void 0
  }));
});
export {
  ur as $,
  Bt as a,
  er as b,
  ar as c
};
