import { j as R, c as me } from "../clsx-DsQc8enX.js";
import * as q from "react";
import _, { useRef as C, useState as j, useEffect as E, useCallback as U, useImperativeHandle as ve, useMemo as le } from "react";
import { $ as De } from "../Button-CXfbBbgl.js";
import { $ as $e, a as be } from "../ListBox-BxBBy7UI.js";
import { c as N, d as Z, e as B, f as ae, g as G, h as Q, i as xe, j as ee, $ as he, k as Ke, l as A, m as T, b as we, n as L, o as se, p as Pe, q as ke, r as Ie, s as J, t as Oe, u as Se, v as Ce, w as de, x as Ae, y as Te, z as Me, A as Re } from "../useDrop-BX0Pcf-E.js";
import { $ as Ee } from "../getScrollParent-mRV3mdwj.js";
import { $ as Fe } from "../isScrollable-BsTGzxij.js";
import { b as Be, p as Le, q as He, r as Ue, i as je, c as X } from "../useHover-r8IM8mvD.js";
import { n as ce, a as fe, $ as ze } from "../utils-DPfg4HqB.js";
import { $ as Xe } from "../context-DRz_xlLl.js";
import { $ as W } from "../useLocalizedStringFormatter-BXegnzqm.js";
import { $ as pe } from "../useDescription-DBX9pMU8.js";
import { flushSync as Ye } from "react-dom";
import { c as te } from "../index-h1rMlRhQ.js";
function qe(n) {
  return n && n.__esModule ? n.default : n;
}
const re = {
  keyboard: {
    start: "dragDescriptionKeyboard",
    end: "endDragKeyboard"
  },
  touch: {
    start: "dragDescriptionTouch",
    end: "endDragTouch"
  },
  virtual: {
    start: "dragDescriptionVirtual",
    end: "endDragVirtual"
  }
};
function Ne(n) {
  let { hasDragButton: t, isDisabled: g } = n, e = W(qe(Q), "@react-aria/dnd"), r = C({
    options: n,
    x: 0,
    y: 0
  }).current;
  r.options = n;
  let i = C(!1), [a, d] = j(!1), v = (o) => {
    i.current = o, d(o);
  }, { addGlobalListener: h, removeAllGlobalListeners: y } = Be(), b = C(null), p = (o) => {
    var D;
    if (o.defaultPrevented) return;
    if (o.stopPropagation(), b.current === "virtual") {
      o.preventDefault(), u(o.target), b.current = null;
      return;
    }
    typeof n.onDragStart == "function" && n.onDragStart({
      type: "dragstart",
      x: o.clientX,
      y: o.clientY
    });
    let w = n.getItems();
    he(o.dataTransfer, w);
    let P = B.all;
    if (typeof n.getAllowedDropOperations == "function") {
      let k = n.getAllowedDropOperations();
      P = B.none;
      for (let I of k) P |= B[I] || B.none;
    }
    Z(P), o.dataTransfer.effectAllowed = Ke[P] || "none", typeof ((D = n.preview) === null || D === void 0 ? void 0 : D.current) == "function" && n.preview.current(w, (k) => {
      if (!k) return;
      let I = k.getBoundingClientRect(), x = o.currentTarget.getBoundingClientRect(), O = o.clientX - x.x, S = o.clientY - x.y;
      (O > I.width || S > I.height) && (O = I.width / 2, S = I.height / 2);
      let F = 2 * Math.round(I.height / 2);
      k.style.height = `${F}px`, o.dataTransfer.setDragImage(k, O, S);
    }), h(window, "drop", (k) => {
      k.preventDefault(), k.stopPropagation(), console.warn("Drags initiated from the React Aria useDrag hook may only be dropped on a target created with useDrop. This ensures that a keyboard and screen reader accessible alternative is available.");
    }, {
      once: !0
    }), r.x = o.clientX, r.y = o.clientY, requestAnimationFrame(() => {
      v(!0);
    });
  }, $ = (o) => {
    o.stopPropagation(), !(o.clientX === r.x && o.clientY === r.y) && (typeof n.onDragMove == "function" && n.onDragMove({
      type: "dragmove",
      x: o.clientX,
      y: o.clientY
    }), r.x = o.clientX, r.y = o.clientY);
  }, m = (o) => {
    if (o.stopPropagation(), typeof n.onDragEnd == "function") {
      let D = {
        type: "dragend",
        x: o.clientX,
        y: o.clientY,
        dropOperation: N[o.dataTransfer.dropEffect]
      };
      G && (D.dropOperation = N[G]), n.onDragEnd(D);
    }
    v(!1), y(), Z(B.none), ee(void 0);
  };
  ce(() => () => {
    if (i.current) {
      if (typeof r.options.onDragEnd == "function") {
        let o = {
          type: "dragend",
          x: 0,
          y: 0,
          dropOperation: N[G || "none"]
        };
        r.options.onDragEnd(o);
      }
      v(!1), Z(B.none), ee(void 0);
    }
  }, [
    r
  ]);
  let l = (o) => {
    o.pointerType !== "keyboard" && o.pointerType !== "virtual" || u(o.target);
  }, u = (o) => {
    if (typeof r.options.onDragStart == "function") {
      let D = o.getBoundingClientRect();
      r.options.onDragStart({
        type: "dragstart",
        x: D.x + D.width / 2,
        y: D.y + D.height / 2
      });
    }
    xe({
      element: o,
      items: r.options.getItems(),
      allowedDropOperations: typeof r.options.getAllowedDropOperations == "function" ? r.options.getAllowedDropOperations() : [
        "move",
        "copy",
        "link"
      ],
      onDragEnd(D) {
        v(!1), typeof r.options.onDragEnd == "function" && r.options.onDragEnd(D);
      }
    }, e), v(!0);
  }, c = ae(), s = a ? re[c].end : re[c].start, f = pe(e.format(s)), K = {};
  return t || (K = {
    ...f,
    onPointerDown(o) {
      if (b.current = He(o.nativeEvent) ? "virtual" : o.pointerType, o.width < 1 && o.height < 1)
        b.current = "virtual";
      else {
        let D = o.currentTarget.getBoundingClientRect(), w = o.clientX - D.x, P = o.clientY - D.y, k = D.width / 2, I = D.height / 2;
        Math.abs(w - k) <= 0.5 && Math.abs(P - I) <= 0.5 ? b.current = "virtual" : b.current = o.pointerType;
      }
    },
    onKeyDownCapture(o) {
      o.target === o.currentTarget && o.key === "Enter" && (o.preventDefault(), o.stopPropagation());
    },
    onKeyUpCapture(o) {
      o.target === o.currentTarget && o.key === "Enter" && (o.preventDefault(), o.stopPropagation(), u(o.target));
    },
    onClick(o) {
      (Le(o.nativeEvent) || b.current === "virtual") && (o.preventDefault(), o.stopPropagation(), u(o.target));
    }
  }), g ? {
    dragProps: {
      draggable: "false"
    },
    dragButtonProps: {},
    isDragging: !1
  } : {
    dragProps: {
      ...K,
      draggable: "true",
      onDragStart: p,
      onDrag: $,
      onDragEnd: m
    },
    dragButtonProps: {
      ...f,
      onPress: l
    },
    isDragging: a
  };
}
const Y = 20;
function Ze(n) {
  let t = C(null), g = C(!0), e = C(!0);
  E(() => {
    if (n.current) {
      t.current = Fe(n.current) ? n.current : Ee(n.current);
      let a = window.getComputedStyle(t.current);
      g.current = /(auto|scroll)/.test(a.overflowX), e.current = /(auto|scroll)/.test(a.overflowY);
    }
  }, [
    n
  ]);
  let r = C({
    timer: void 0,
    dx: 0,
    dy: 0
  }).current;
  E(() => () => {
    r.timer && (cancelAnimationFrame(r.timer), r.timer = void 0);
  }, [
    r
  ]);
  let i = U(() => {
    g.current && t.current && (t.current.scrollLeft += r.dx), e.current && t.current && (t.current.scrollTop += r.dy), r.timer && (r.timer = requestAnimationFrame(i));
  }, [
    t,
    r
  ]);
  return {
    move(a, d) {
      if (!Ue() || je() || !t.current) return;
      let v = t.current.getBoundingClientRect(), h = Y, y = Y, b = v.height - Y, p = v.width - Y;
      a < h || a > p || d < y || d > b ? (a < h ? r.dx = a - h : a > p && (r.dx = a - p), d < y ? r.dy = d - y : d > b && (r.dy = d - b), r.timer || (r.timer = requestAnimationFrame(i))) : this.stop();
    },
    stop() {
      r.timer && (cancelAnimationFrame(r.timer), r.timer = void 0);
    }
  };
}
const oe = [
  "before",
  "on",
  "after"
], ne = [
  "after",
  "on",
  "before"
];
function Ge(n, t, g) {
  let e = C({
    props: n,
    state: t,
    nextTarget: null,
    dropOperation: null
  }).current;
  e.props = n, e.state = t;
  let r = U(async (p) => {
    let { onInsert: $, onRootDrop: m, onItemDrop: l, onReorder: u, acceptedDragTypes: c = "all", shouldAcceptItemDrop: s } = e.props, { draggingKeys: f } = A, K = T(g), { target: o, dropOperation: D, items: w } = p, P = w;
    (c !== "all" || s) && (P = w.filter((k) => {
      let I;
      return k.kind === "directory" ? I = /* @__PURE__ */ new Set([
        Ie
      ]) : I = k.kind === "file" ? /* @__PURE__ */ new Set([
        k.type
      ]) : k.types, c === "all" || c.some((x) => I.has(x)) ? o.type === "item" && o.dropPosition === "on" && s ? s(o, I) : !0 : !1;
    })), P.length > 0 && (o.type === "root" && m && await m({
      items: P,
      dropOperation: D
    }), o.type === "item" && (o.dropPosition === "on" && l && await l({
      items: P,
      dropOperation: D,
      isInternal: K,
      target: o
    }), o.dropPosition !== "on" && (!K && $ && await $({
      items: P,
      dropOperation: D,
      target: o
    }), K && u && await u({
      keys: f,
      dropOperation: D,
      target: o
    }))));
  }, [
    e,
    g
  ]), i = Ze(g), { dropProps: a } = we({
    ref: g,
    onDropEnter() {
      e.nextTarget != null && t.setTarget(e.nextTarget);
    },
    onDropMove(p) {
      e.nextTarget != null && t.setTarget(e.nextTarget), i.move(p.x, p.y);
    },
    getDropOperationForPoint(p, $, m, l) {
      let { draggingKeys: u, dropCollectionRef: c } = A, s = T(g), f = (o) => t.getDropOperation({
        target: o,
        types: p,
        allowedOperations: $,
        isInternal: s,
        draggingKeys: u
      }) !== "cancel", K = n.dropTargetDelegate.getDropTargetFromPoint(m, l, f);
      if (!K)
        return e.dropOperation = "cancel", e.nextTarget = null, "cancel";
      if (e.dropOperation = t.getDropOperation({
        target: K,
        types: p,
        allowedOperations: $,
        isInternal: s,
        draggingKeys: u
      }), e.dropOperation === "cancel") {
        let o = {
          type: "root"
        }, D = t.getDropOperation({
          target: o,
          types: p,
          allowedOperations: $,
          isInternal: s,
          draggingKeys: u
        });
        D !== "cancel" && (K = o, e.dropOperation = D);
      }
      return K && e.dropOperation !== "cancel" && (g == null ? void 0 : g.current) !== (c == null ? void 0 : c.current) && L(g), e.nextTarget = e.dropOperation === "cancel" ? null : K, e.dropOperation;
    },
    onDropExit() {
      L(void 0), t.setTarget(null), i.stop();
    },
    onDropActivate(p) {
      var $, m;
      (($ = t.target) === null || $ === void 0 ? void 0 : $.type) === "item" && ((m = t.target) === null || m === void 0 ? void 0 : m.dropPosition) === "on" && typeof n.onDropActivate == "function" && n.onDropActivate({
        type: "dropactivate",
        x: p.x,
        y: p.y,
        target: t.target
      });
    },
    onDrop(p) {
      L(g), t.target && h(p, t.target);
      let { draggingCollectionRef: $ } = A;
      $ == null && se();
    }
  }), d = C(null), v = U(() => {
    let { state: p } = e;
    if (d.current) {
      var $;
      let { target: u, collection: c, selectedKeys: s, focusedKey: f, isInternal: K, draggingKeys: o } = d.current;
      if (p.collection.size > c.size && p.selectionManager.isSelectionEqual(s)) {
        let D = /* @__PURE__ */ new Set();
        for (let w of p.collection.getKeys()) c.getItem(w) || D.add(w);
        if (p.selectionManager.setSelectedKeys(D), p.selectionManager.focusedKey === f) {
          let w = D.keys().next().value, P = p.collection.getItem(w);
          (P == null ? void 0 : P.type) === "cell" && (w = P.parentKey), p.selectionManager.setFocusedKey(w), p.selectionManager.selectionMode === "none" && X("keyboard");
        }
      } else if (f != null && p.selectionManager.focusedKey === f && K && u.type === "item" && u.dropPosition !== "on" && o.has(($ = p.collection.getItem(f)) === null || $ === void 0 ? void 0 : $.parentKey)) {
        var m, l;
        p.selectionManager.setFocusedKey((l = (m = p.collection.getItem(f)) === null || m === void 0 ? void 0 : m.parentKey) !== null && l !== void 0 ? l : null), X("keyboard");
      } else p.selectionManager.focusedKey === f && u.type === "item" && u.dropPosition === "on" && p.collection.getItem(u.key) != null ? (p.selectionManager.setFocusedKey(u.key), X("keyboard")) : p.selectionManager.focusedKey != null && !p.selectionManager.isSelected(p.selectionManager.focusedKey) && X("keyboard");
      p.selectionManager.setFocused(!0);
    }
  }, [
    e
  ]), h = U((p, $) => {
    let { state: m } = e;
    d.current = {
      timeout: void 0,
      focusedKey: m.selectionManager.focusedKey,
      collection: m.collection,
      selectedKeys: m.selectionManager.selectedKeys,
      draggingKeys: A.draggingKeys,
      isInternal: T(g),
      target: $
    }, (e.props.onDrop || r)({
      type: "drop",
      x: p.x,
      y: p.y,
      target: $,
      items: p.items,
      dropOperation: p.dropOperation
    }), d.current.timeout = setTimeout(() => {
      v(), d.current = null;
    }, 50);
  }, [
    e,
    r,
    g,
    v
  ]);
  E(() => () => {
    d.current && clearTimeout(d.current.timeout);
  }, []), ce(() => {
    d.current && t.collection !== d.current.collection && v();
  });
  let { direction: y } = Xe();
  E(() => {
    if (!g.current) return;
    let p = (l, u = !0, c = !1) => {
      var s, f, K, o;
      if (!l) return {
        type: "root"
      };
      let { keyboardDelegate: D } = e.props, w;
      (l == null ? void 0 : l.type) === "item" ? w = c ? (s = D.getKeyRightOf) === null || s === void 0 ? void 0 : s.call(D, l.key) : (f = D.getKeyBelow) === null || f === void 0 ? void 0 : f.call(D, l.key) : w = c && y === "rtl" ? (K = D.getLastKey) === null || K === void 0 ? void 0 : K.call(D) : (o = D.getFirstKey) === null || o === void 0 ? void 0 : o.call(D);
      let P = c && y === "rtl" ? ne : oe, k = P[0];
      if (l.type === "item") {
        let I = c && y === "rtl" ? e.state.collection.getKeyBefore(l.key) : e.state.collection.getKeyAfter(l.key);
        if (w == null || w === I) {
          let x = P.indexOf(l.dropPosition), O = P[x + 1];
          if (x < P.length - 1 && !(O === P[2] && w != null)) return {
            type: "item",
            key: l.key,
            dropPosition: O
          };
          l.dropPosition === P[2] && (k = "on");
        } else k = l.dropPosition;
      }
      return w == null ? u ? {
        type: "root"
      } : null : {
        type: "item",
        key: w,
        dropPosition: k
      };
    }, $ = (l, u = !0, c = !1) => {
      var s, f, K, o;
      let { keyboardDelegate: D } = e.props, w;
      (l == null ? void 0 : l.type) === "item" ? w = c ? (s = D.getKeyLeftOf) === null || s === void 0 ? void 0 : s.call(D, l.key) : (f = D.getKeyAbove) === null || f === void 0 ? void 0 : f.call(D, l.key) : w = c && y === "rtl" ? (K = D.getFirstKey) === null || K === void 0 ? void 0 : K.call(D) : (o = D.getLastKey) === null || o === void 0 ? void 0 : o.call(D);
      let P = c && y === "rtl" ? ne : oe, k = !l || l.type === "root" ? P[2] : "on";
      if ((l == null ? void 0 : l.type) === "item") {
        let I = c && y === "rtl" ? e.state.collection.getKeyAfter(l.key) : e.state.collection.getKeyBefore(l.key);
        if (w == null || w === I) {
          let x = P.indexOf(l.dropPosition), O = P[x - 1];
          if (x > 0 && O !== P[2]) return {
            type: "item",
            key: l.key,
            dropPosition: O
          };
          l.dropPosition === P[0] && (k = "on");
        } else k = l.dropPosition;
      }
      return w == null ? u ? {
        type: "root"
      } : null : {
        type: "item",
        key: w,
        dropPosition: k
      };
    }, m = (l, u, c, s, f = !0) => {
      let K = 0, o, { draggingKeys: D } = A, w = T(g);
      do {
        let P = s(l, f);
        if (!P) return null;
        l = P, o = e.state.getDropOperation({
          target: P,
          types: u,
          allowedOperations: c,
          isInternal: w,
          draggingKeys: D
        }), l.type === "root" && K++;
      } while (o === "cancel" && !e.state.isDropTarget(l) && K < 2);
      return o === "cancel" ? null : l;
    };
    return Pe({
      element: g.current,
      preventFocusOnDrop: !0,
      getDropOperation(l, u) {
        if (e.state.target) {
          let { draggingKeys: s } = A, f = T(g);
          return e.state.getDropOperation({
            target: e.state.target,
            types: l,
            allowedOperations: u,
            isInternal: f,
            draggingKeys: s
          });
        }
        return m(null, l, u, p) ? "move" : "cancel";
      },
      onDropEnter(l, u) {
        let c = J(u.items), s = e.state.selectionManager, f = null;
        L(g);
        let K = s.focusedKey, o = "after", D = K != null ? e.state.collection.getItem(K) : null;
        if ((D == null ? void 0 : D.type) === "cell" && (K = D.parentKey), K != null && s.isSelected(K) && (s.selectedKeys.size > 1 && s.firstSelectedKey === K ? o = "before" : K = s.lastSelectedKey), K != null) {
          f = {
            type: "item",
            key: K,
            dropPosition: o
          };
          let { draggingKeys: P } = A, k = T(g);
          var w;
          e.state.getDropOperation({
            target: f,
            types: c,
            allowedOperations: u.allowedDropOperations,
            isInternal: k,
            draggingKeys: P
          }) === "cancel" && (f = (w = m(f, c, u.allowedDropOperations, p, !1)) !== null && w !== void 0 ? w : m(f, c, u.allowedDropOperations, $, !1));
        }
        f || (f = m(null, c, u.allowedDropOperations, p)), e.state.setTarget(f);
      },
      onDropExit() {
        L(void 0), e.state.setTarget(null);
      },
      onDropTargetEnter(l) {
        e.state.setTarget(l);
      },
      onDropActivate(l) {
        var u, c;
        ((u = e.state.target) === null || u === void 0 ? void 0 : u.type) === "item" && ((c = e.state.target) === null || c === void 0 ? void 0 : c.dropPosition) === "on" && typeof e.props.onDropActivate == "function" && e.props.onDropActivate({
          type: "dropactivate",
          x: l.x,
          y: l.y,
          target: e.state.target
        });
      },
      onDrop(l, u) {
        L(g), e.state.target && h(l, u || e.state.target);
      },
      onKeyDown(l, u) {
        let { keyboardDelegate: c } = e.props, s = J(u.items);
        switch (l.key) {
          case "ArrowDown":
            if (c.getKeyBelow) {
              let x = m(e.state.target, s, u.allowedDropOperations, p);
              e.state.setTarget(x);
            }
            break;
          case "ArrowUp":
            if (c.getKeyAbove) {
              let x = m(e.state.target, s, u.allowedDropOperations, $);
              e.state.setTarget(x);
            }
            break;
          case "ArrowLeft":
            if (c.getKeyLeftOf) {
              let x = m(e.state.target, s, u.allowedDropOperations, (O, S) => $(O, S, !0));
              e.state.setTarget(x);
            }
            break;
          case "ArrowRight":
            if (c.getKeyRightOf) {
              let x = m(e.state.target, s, u.allowedDropOperations, (O, S) => p(O, S, !0));
              e.state.setTarget(x);
            }
            break;
          case "Home":
            if (c.getFirstKey) {
              let x = m(null, s, u.allowedDropOperations, p);
              e.state.setTarget(x);
            }
            break;
          case "End":
            if (c.getLastKey) {
              let x = m(null, s, u.allowedDropOperations, $);
              e.state.setTarget(x);
            }
            break;
          case "PageDown":
            if (c.getKeyPageBelow) {
              let x = e.state.target;
              if (!x) x = m(null, s, u.allowedDropOperations, p);
              else {
                var f, K;
                let O = (f = c.getFirstKey) === null || f === void 0 ? void 0 : f.call(c);
                x.type === "item" && (O = x.key);
                let S = null;
                O != null && (S = c.getKeyPageBelow(O));
                let F = x.type === "item" ? x.dropPosition : "after";
                if (S == null || x.type === "item" && x.key === ((K = c.getLastKey) === null || K === void 0 ? void 0 : K.call(c))) {
                  var o, D;
                  S = (D = (o = c.getLastKey) === null || o === void 0 ? void 0 : o.call(c)) !== null && D !== void 0 ? D : null, F = "after";
                }
                if (S == null) break;
                x = {
                  type: "item",
                  key: S,
                  dropPosition: F
                };
                let { draggingCollectionRef: M, draggingKeys: z } = A, ue = (M == null ? void 0 : M.current) === (g == null ? void 0 : g.current), ye = e.state.getDropOperation({
                  target: x,
                  types: s,
                  allowedOperations: u.allowedDropOperations,
                  isInternal: ue,
                  draggingKeys: z
                });
                var w;
                ye === "cancel" && (x = (w = m(x, s, u.allowedDropOperations, p, !1)) !== null && w !== void 0 ? w : m(x, s, u.allowedDropOperations, $, !1));
              }
              e.state.setTarget(x ?? e.state.target);
            }
            break;
          case "PageUp": {
            if (!c.getKeyPageAbove) break;
            let x = e.state.target;
            if (!x) x = m(null, s, u.allowedDropOperations, $);
            else if (x.type === "item") {
              var P;
              if (x.key === ((P = c.getFirstKey) === null || P === void 0 ? void 0 : P.call(c))) x = {
                type: "root"
              };
              else {
                let M = c.getKeyPageAbove(x.key), z = x.dropPosition;
                if (M == null) {
                  var k;
                  M = (k = c.getFirstKey) === null || k === void 0 ? void 0 : k.call(c), z = "before";
                }
                if (M == null) break;
                x = {
                  type: "item",
                  key: M,
                  dropPosition: z
                };
              }
              let { draggingKeys: O } = A, S = T(g), F = e.state.getDropOperation({
                target: x,
                types: s,
                allowedOperations: u.allowedDropOperations,
                isInternal: S,
                draggingKeys: O
              });
              var I;
              F === "cancel" && (x = (I = m(x, s, u.allowedDropOperations, $, !1)) !== null && I !== void 0 ? I : m(x, s, u.allowedDropOperations, p, !1));
            }
            e.state.setTarget(x ?? e.state.target);
            break;
          }
        }
      }
    });
  }, [
    e,
    g,
    h,
    y
  ]);
  let b = fe();
  return ke.set(t, {
    id: b,
    ref: g
  }), {
    collectionProps: ze(a, {
      id: b,
      // Remove description from collection element. If dropping on the entire collection,
      // there should be a drop indicator that has this description, so no need to double announce.
      "aria-describedby": null
    })
  };
}
function ge(n, t, g) {
  let { dropProps: e } = Oe(), r = Se(t);
  E(() => {
    if (g.current) return Ce({
      element: g.current,
      target: n.target,
      getDropOperation(y, b) {
        let { draggingKeys: p } = A, $ = T(r);
        return t.getDropOperation({
          target: n.target,
          types: y,
          allowedOperations: b,
          isInternal: $,
          draggingKeys: p
        });
      }
    });
  }, [
    g,
    n.target,
    t,
    r
  ]);
  let i = de(), { draggingKeys: a } = A, d = T(r), v = i && t.getDropOperation({
    target: n.target,
    types: J(i.dragTarget.items),
    allowedOperations: i.dragTarget.allowedDropOperations,
    isInternal: d,
    draggingKeys: a
  }) !== "cancel", h = t.isDropTarget(n.target);
  return E(() => {
    i && h && g.current && g.current.focus();
  }, [
    h,
    i,
    g
  ]), {
    dropProps: {
      ...e,
      "aria-hidden": !i || v ? void 0 : "true"
    },
    isDropTarget: h
  };
}
function Ve(n) {
  return n && n.__esModule ? n.default : n;
}
function Je(n, t, g) {
  let { target: e } = n, { collection: r } = t, i = W(Ve(Q), "@react-aria/dnd"), a = de(), { dropProps: d } = ge(n, t, g), v = fe(), h = (m) => {
    var l, u, c, s;
    return m == null ? "" : (s = (c = (l = r.getTextValue) === null || l === void 0 ? void 0 : l.call(r, m)) !== null && c !== void 0 ? c : (u = r.getItem(m)) === null || u === void 0 ? void 0 : u.textValue) !== null && s !== void 0 ? s : "";
  }, y = "", b;
  if (e.type === "root")
    y = i.format("dropOnRoot"), b = `${v} ${Ae(t)}`;
  else if (e.dropPosition === "on") y = i.format("dropOnItem", {
    itemText: h(e.key)
  });
  else {
    let m, l;
    r.getFirstKey() === e.key && e.dropPosition === "before" ? m = null : m = e.dropPosition === "before" ? r.getKeyBefore(e.key) : e.key, r.getLastKey() === e.key && e.dropPosition === "after" ? l = null : l = e.dropPosition === "after" ? r.getKeyAfter(e.key) : e.key, m && l ? y = i.format("insertBetween", {
      beforeItemText: h(m),
      afterItemText: h(l)
    }) : m ? y = i.format("insertAfter", {
      itemText: h(m)
    }) : l && (y = i.format("insertBefore", {
      itemText: h(l)
    }));
  }
  let p = t.isDropTarget(e), $ = a ? d["aria-hidden"] : "true";
  return {
    dropIndicatorProps: {
      ...d,
      id: v,
      "aria-roledescription": i.format("dropIndicator"),
      "aria-label": y,
      "aria-labelledby": b,
      "aria-hidden": $,
      tabIndex: -1
    },
    isDropTarget: p,
    // If aria-hidden, we are either not in a drag session or the drop target is invalid.
    // In that case, there's no need to render anything at all unless we need to show the indicator visually.
    // This can happen when dragging using the native DnD API as opposed to keyboard dragging.
    isHidden: !p && !!$
  };
}
function Qe(n) {
  return n && n.__esModule ? n.default : n;
}
const We = {
  keyboard: {
    selected: "dragSelectedKeyboard",
    notSelected: "dragDescriptionKeyboard"
  },
  touch: {
    selected: "dragSelectedLongPress",
    notSelected: "dragDescriptionLongPress"
  },
  virtual: {
    selected: "dragDescriptionVirtual",
    notSelected: "dragDescriptionVirtual"
  }
};
function _e(n, t) {
  let g = W(Qe(Q), "@react-aria/dnd"), e = t.isDisabled || t.selectionManager.isDisabled(n.key), { dragProps: r, dragButtonProps: i } = Ne({
    getItems() {
      return t.getItems(n.key);
    },
    preview: t.preview,
    getAllowedDropOperations: t.getAllowedDropOperations,
    hasDragButton: n.hasDragButton,
    onDragStart(c) {
      t.startDrag(n.key, c), Te(t.draggingKeys);
    },
    onDragMove(c) {
      t.moveDrag(c);
    },
    onDragEnd(c) {
      let { dropOperation: s } = c, f = s === "cancel" ? !1 : T();
      t.endDrag({
        ...c,
        keys: t.draggingKeys,
        isInternal: f
      }), se();
    }
  }), a = t.collection.getItem(n.key), d = t.getKeysForDrag(n.key).size, v = d > 1 && t.selectionManager.isSelected(n.key), h, y, b = ae();
  if (!n.hasDragButton && t.selectionManager.selectionMode !== "none") {
    let c = We[b][v ? "selected" : "notSelected"];
    n.hasAction && b === "keyboard" && (c += "Alt"), v ? y = g.format(c, {
      count: d
    }) : y = g.format(c), delete r.onClick;
  } else if (v) h = g.format("dragSelectedItems", {
    count: d
  });
  else {
    var p, $, m, l;
    let c = (l = (m = (p = ($ = t.collection).getTextValue) === null || p === void 0 ? void 0 : p.call($, n.key)) !== null && m !== void 0 ? m : a == null ? void 0 : a.textValue) !== null && l !== void 0 ? l : "";
    h = g.format("dragItem", {
      itemText: c
    });
  }
  let u = pe(y);
  if (y && Object.assign(r, u), !n.hasDragButton && n.hasAction) {
    let { onKeyDownCapture: c, onKeyUpCapture: s } = r;
    b === "touch" && delete r["aria-describedby"], r.onKeyDownCapture = (f) => {
      f.altKey && (c == null || c(f));
    }, r.onKeyUpCapture = (f) => {
      f.altKey && (s == null || s(f));
    };
  }
  return {
    dragProps: e ? {} : r,
    dragButtonProps: {
      ...i,
      isDisabled: e,
      "aria-label": h
    }
  };
}
function et(n, t, g) {
  let { draggingCollectionRef: e } = A;
  t.draggingKeys.size > 0 && (e == null ? void 0 : e.current) !== g.current && Me(g);
}
const tt = /* @__PURE__ */ _.forwardRef(function(t, g) {
  let e = t.children, [r, i] = j(null), a = C(null), d = C(void 0);
  return ve(g, () => (v, h) => {
    Ye(() => {
      i(e(v));
    }), h(a.current), d.current = requestAnimationFrame(() => {
      i(null);
    });
  }, [
    e
  ]), E(() => () => {
    d.current && cancelAnimationFrame(d.current);
  }, []), r ? /* @__PURE__ */ _.createElement("div", {
    style: {
      zIndex: -100,
      position: "absolute",
      top: 0,
      left: -1e5
    },
    ref: a
  }, r) : null;
});
class rt {
  getPrimaryStart(t) {
    return this.orientation === "horizontal" ? t.left : t.top;
  }
  getPrimaryEnd(t) {
    return this.orientation === "horizontal" ? t.right : t.bottom;
  }
  getSecondaryStart(t) {
    return this.orientation === "horizontal" ? t.top : t.left;
  }
  getSecondaryEnd(t) {
    return this.orientation === "horizontal" ? t.bottom : t.right;
  }
  getFlowStart(t) {
    return this.layout === "stack" ? this.getPrimaryStart(t) : this.getSecondaryStart(t);
  }
  getFlowEnd(t) {
    return this.layout === "stack" ? this.getPrimaryEnd(t) : this.getSecondaryEnd(t);
  }
  getFlowSize(t) {
    return this.getFlowEnd(t) - this.getFlowStart(t);
  }
  getDropTargetFromPoint(t, g, e) {
    var r;
    if (this.collection[Symbol.iterator]().next().done || !this.ref.current) return {
      type: "root"
    };
    let i = this.ref.current.getBoundingClientRect(), a = this.orientation === "horizontal" ? t : g, d = this.orientation === "horizontal" ? g : t;
    a += this.getPrimaryStart(i), d += this.getSecondaryStart(i);
    let v = this.layout === "stack" ? a : d, h = this.orientation === "horizontal" && this.direction === "rtl", y = this.layout === "grid" && this.orientation === "vertical" && this.direction === "rtl", b = this.layout === "stack" ? h : y, p = (r = this.ref.current) === null || r === void 0 ? void 0 : r.dataset.collection, $ = this.ref.current.querySelectorAll(p ? `[data-collection="${CSS.escape(p)}"]` : "[data-key]"), m = /* @__PURE__ */ new Map();
    for (let K of $) K instanceof HTMLElement && K.dataset.key != null && m.set(K.dataset.key, K);
    let l = [
      ...this.collection
    ].filter((K) => K.type === "item"), u = 0, c = l.length;
    for (; u < c; ) {
      let K = Math.floor((u + c) / 2), o = l[K], D = m.get(String(o.key));
      if (!D) break;
      let w = D.getBoundingClientRect(), P = (k) => {
        k ? u = K + 1 : c = K;
      };
      if (a < this.getPrimaryStart(w)) P(h);
      else if (a > this.getPrimaryEnd(w)) P(!h);
      else if (d < this.getSecondaryStart(w)) P(y);
      else if (d > this.getSecondaryEnd(w)) P(!y);
      else {
        let k = {
          type: "item",
          key: o.key,
          dropPosition: "on"
        };
        if (e(k))
          v <= this.getFlowStart(w) + 5 && e({
            ...k,
            dropPosition: "before"
          }) ? k.dropPosition = b ? "after" : "before" : v >= this.getFlowEnd(w) - 5 && e({
            ...k,
            dropPosition: "after"
          }) && (k.dropPosition = b ? "before" : "after");
        else {
          let I = this.getFlowStart(w) + this.getFlowSize(w) / 2;
          v <= I && e({
            ...k,
            dropPosition: "before"
          }) ? k.dropPosition = b ? "after" : "before" : v >= I && e({
            ...k,
            dropPosition: "after"
          }) && (k.dropPosition = b ? "before" : "after");
        }
        return k;
      }
    }
    let s = l[Math.min(u, l.length - 1)], f = m.get(String(s.key));
    return i = f == null ? void 0 : f.getBoundingClientRect(), i && (a < this.getPrimaryStart(i) || Math.abs(v - this.getFlowStart(i)) < Math.abs(v - this.getFlowEnd(i))) ? {
      type: "item",
      key: s.key,
      dropPosition: b ? "after" : "before"
    } : {
      type: "item",
      key: s.key,
      dropPosition: b ? "before" : "after"
    };
  }
  constructor(t, g, e) {
    this.collection = t, this.ref = g, this.layout = (e == null ? void 0 : e.layout) || "stack", this.orientation = (e == null ? void 0 : e.orientation) || "vertical", this.direction = (e == null ? void 0 : e.direction) || "ltr";
  }
}
function ot(n) {
  let { getItems: t, isDisabled: g, collection: e, selectionManager: r, onDragStart: i, onDragMove: a, onDragEnd: d, preview: v, getAllowedDropOperations: h } = n, [, y] = j(!1), b = C(/* @__PURE__ */ new Set()), p = C(null), $ = (m) => {
    let l = new Set(r.isSelected(m) ? new Set([
      ...r.selectedKeys
    ].filter((u) => !!e.getItem(u))) : []);
    return l.add(m), l;
  };
  return {
    collection: e,
    selectionManager: r,
    get draggedKey() {
      return p.current;
    },
    get draggingKeys() {
      return b.current;
    },
    isDragging(m) {
      return b.current.has(m);
    },
    getKeysForDrag: $,
    getItems(m) {
      return t($(m));
    },
    isDisabled: g,
    preview: v,
    getAllowedDropOperations: h,
    startDrag(m, l) {
      let u = $(m);
      b.current = u, p.current = m, r.setFocused(!1), y(!0), typeof i == "function" && i({
        ...l,
        keys: u
      });
    },
    moveDrag(m) {
      typeof a == "function" && a({
        ...m,
        keys: b.current
      });
    },
    endDrag(m) {
      let { isInternal: l } = m;
      typeof d == "function" && d({
        ...m,
        keys: b.current,
        isInternal: l
      }), b.current = /* @__PURE__ */ new Set(), p.current = null, y(!1);
    }
  };
}
function nt(n) {
  let { acceptedDragTypes: t = "all", isDisabled: g, onInsert: e, onRootDrop: r, onItemDrop: i, onReorder: a, shouldAcceptItemDrop: d, collection: v, selectionManager: h, onDropEnter: y, getDropOperation: b, onDrop: p } = n, [$, m] = j(null), l = C(null), u = (s) => {
    if (s.dropPosition === "before") {
      let f = v.getKeyBefore(s.key);
      return f != null ? {
        type: "item",
        key: f,
        dropPosition: "after"
      } : null;
    } else if (s.dropPosition === "after") {
      let f = v.getKeyAfter(s.key);
      return f != null ? {
        type: "item",
        key: f,
        dropPosition: "before"
      } : null;
    }
    return null;
  }, c = U((s) => {
    let { target: f, types: K, allowedOperations: o, isInternal: D, draggingKeys: w } = s;
    if (g || !f) return "cancel";
    if (t === "all" || t.some((P) => K.has(P))) {
      let P = e && f.type === "item" && !D && (f.dropPosition === "before" || f.dropPosition === "after"), k = a && f.type === "item" && D && (f.dropPosition === "before" || f.dropPosition === "after"), I = r && f.type === "root" && !D, x = i && f.type === "item" && f.dropPosition === "on" && !(D && f.key != null && w.has(f.key)) && (!d || d(f, K));
      if (p || P || k || I || x)
        return b ? b(f, K, o) : o[0];
    }
    return "cancel";
  }, [
    g,
    t,
    b,
    e,
    r,
    i,
    d,
    a,
    p
  ]);
  return {
    collection: v,
    selectionManager: h,
    isDisabled: g,
    target: $,
    setTarget(s) {
      if (this.isDropTarget(s)) return;
      let f = l.current;
      f && typeof n.onDropExit == "function" && n.onDropExit({
        type: "dropexit",
        x: 0,
        y: 0,
        target: f
      }), s && typeof y == "function" && y({
        type: "dropenter",
        x: 0,
        y: 0,
        target: s
      }), l.current = s ?? null, m(s ?? null);
    },
    isDropTarget(s) {
      let f = l.current;
      return !f || !s ? !1 : V(s, f) ? !0 : (s == null ? void 0 : s.type) === "item" && (f == null ? void 0 : f.type) === "item" && s.key !== f.key && s.dropPosition !== f.dropPosition && s.dropPosition !== "on" && f.dropPosition !== "on" ? V(u(s), f) || V(s, u(f)) : !1;
    },
    getDropOperation(s) {
      return c(s);
    }
  };
}
function V(n, t) {
  if (!n) return !t;
  switch (n.type) {
    case "root":
      return (t == null ? void 0 : t.type) === "root";
    case "item":
      return (t == null ? void 0 : t.type) === "item" && (t == null ? void 0 : t.key) === n.key && (t == null ? void 0 : t.dropPosition) === n.dropPosition;
  }
}
function it(n) {
  let { initialItems: t = [], initialSelectedKeys: g, getKey: e = (h) => {
    var y;
    return (y = h.id) !== null && y !== void 0 ? y : h.key;
  }, filter: r, initialFilterText: i = "" } = n, [a, d] = j({
    items: t,
    selectedKeys: g === "all" ? "all" : new Set(g || []),
    filterText: i
  }), v = le(() => r ? a.items.filter((h) => r(h, a.filterText)) : a.items, [
    a.items,
    a.filterText,
    r
  ]);
  return {
    ...a,
    items: v,
    ...lt({
      getKey: e
    }, d),
    getItem(h) {
      return a.items.find((y) => e(y) === h);
    }
  };
}
function lt(n, t) {
  let { cursor: g, getKey: e } = n;
  return {
    setSelectedKeys(r) {
      t((i) => ({
        ...i,
        selectedKeys: r
      }));
    },
    setFilterText(r) {
      t((i) => ({
        ...i,
        filterText: r
      }));
    },
    insert(r, ...i) {
      t((a) => H(a, r, ...i));
    },
    insertBefore(r, ...i) {
      t((a) => {
        let d = a.items.findIndex((v) => (e == null ? void 0 : e(v)) === r);
        if (d === -1)
          if (a.items.length === 0) d = 0;
          else return a;
        return H(a, d, ...i);
      });
    },
    insertAfter(r, ...i) {
      t((a) => {
        let d = a.items.findIndex((v) => (e == null ? void 0 : e(v)) === r);
        if (d === -1)
          if (a.items.length === 0) d = 0;
          else return a;
        return H(a, d + 1, ...i);
      });
    },
    prepend(...r) {
      t((i) => H(i, 0, ...r));
    },
    append(...r) {
      t((i) => H(i, i.items.length, ...r));
    },
    remove(...r) {
      t((i) => {
        let a = new Set(r), d = i.items.filter((h) => !a.has(e(h))), v = "all";
        if (i.selectedKeys !== "all") {
          v = new Set(i.selectedKeys);
          for (let h of r) v.delete(h);
        }
        return g == null && d.length === 0 && (v = /* @__PURE__ */ new Set()), {
          ...i,
          items: d,
          selectedKeys: v
        };
      });
    },
    removeSelectedItems() {
      t((r) => {
        if (r.selectedKeys === "all") return {
          ...r,
          items: [],
          selectedKeys: /* @__PURE__ */ new Set()
        };
        let i = r.selectedKeys, a = r.items.filter((d) => !i.has(e(d)));
        return {
          ...r,
          items: a,
          selectedKeys: /* @__PURE__ */ new Set()
        };
      });
    },
    move(r, i) {
      t((a) => {
        let d = a.items.findIndex((y) => e(y) === r);
        if (d === -1) return a;
        let v = a.items.slice(), [h] = v.splice(d, 1);
        return v.splice(i, 0, h), {
          ...a,
          items: v
        };
      });
    },
    moveBefore(r, i) {
      t((a) => {
        let d = a.items.findIndex((y) => e(y) === r);
        if (d === -1) return a;
        let h = (Array.isArray(i) ? i : [
          ...i
        ]).map((y) => a.items.findIndex((b) => e(b) === y)).sort((y, b) => y - b);
        return ie(a, h, d);
      });
    },
    moveAfter(r, i) {
      t((a) => {
        let d = a.items.findIndex((y) => e(y) === r);
        if (d === -1) return a;
        let h = (Array.isArray(i) ? i : [
          ...i
        ]).map((y) => a.items.findIndex((b) => e(b) === y)).sort((y, b) => y - b);
        return ie(a, h, d + 1);
      });
    },
    update(r, i) {
      t((a) => {
        let d = a.items.findIndex((v) => e(v) === r);
        return d === -1 ? a : {
          ...a,
          items: [
            ...a.items.slice(0, d),
            i,
            ...a.items.slice(d + 1)
          ]
        };
      });
    }
  };
}
function H(n, t, ...g) {
  return {
    ...n,
    items: [
      ...n.items.slice(0, t),
      ...g,
      ...n.items.slice(t)
    ]
  };
}
function ie(n, t, g) {
  g -= t.filter((i) => i < g).length;
  let e = t.map((i) => ({
    from: i,
    to: g++
  }));
  for (let i = 0; i < e.length; i++) {
    let a = e[i].from;
    for (let d = i; d < e.length; d++)
      e[d].from > a && e[d].from--;
  }
  for (let i = 0; i < e.length; i++) {
    let a = e[i];
    for (let d = e.length - 1; d > i; d--) {
      let v = e[d];
      v.from < a.to ? a.to++ : v.from++;
    }
  }
  let r = n.items.slice();
  for (let i of e) {
    let [a] = r.splice(i.from, 1);
    r.splice(i.to, 0, a);
  }
  return {
    ...n,
    items: r
  };
}
function at(n) {
  return {
    dragAndDropHooks: le(() => {
      let { onDrop: g, onInsert: e, onItemDrop: r, onReorder: i, onRootDrop: a, getItems: d, renderDragPreview: v, renderDropIndicator: h, dropTargetDelegate: y } = n, b = !!d, p = !!(g || e || r || i || a), $ = {};
      return b && ($.useDraggableCollectionState = function(l) {
        return ot({
          ...l,
          ...n
        });
      }, $.useDraggableCollection = et, $.useDraggableItem = _e, $.DragPreview = tt, $.renderDragPreview = v, $.isVirtualDragging = Re), p && ($.useDroppableCollectionState = function(l) {
        return nt({
          ...l,
          ...n
        });
      }, $.useDroppableItem = ge, $.useDroppableCollection = function(l, u, c) {
        return Ge({
          ...l,
          ...n
        }, u, c);
      }, $.useDropIndicator = Je, $.renderDropIndicator = h, $.dropTargetDelegate = y, $.ListDropTargetDelegate = rt), $;
    }, [
      n
    ])
  };
}
const st = (n) => /* @__PURE__ */ q.createElement("svg", { xmlns: "http://www.w3.org/2000/svg", width: 16, height: 16, viewBox: "0 0 16 16", fill: "none", ...n }, /* @__PURE__ */ q.createElement("path", { fillRule: "evenodd", clipRule: "evenodd", d: "M7.06452 8C7.06452 6.87661 6.15565 5.96774 5.03226 5.96774C3.90887 5.96774 3 6.87661 3 8C3 9.12339 3.90887 10.0323 5.03226 10.0323C6.15565 10.0323 7.06452 9.12339 7.06452 8ZM5.03226 5.06452C3.90887 5.06452 3 4.15565 3 3.03226C3 1.90887 3.90887 1 5.03226 1C6.15565 1 7.06452 1.90887 7.06452 3.03226C7.06452 4.15565 6.15565 5.06452 5.03226 5.06452ZM5.03226 15C3.90887 15 3 14.0911 3 12.9677C3 11.8444 3.90887 10.9355 5.03226 10.9355C6.15565 10.9355 7.06452 11.8444 7.06452 12.9677C7.06452 14.0911 6.15565 15 5.03226 15ZM13.0645 8C13.0645 6.87661 12.1556 5.96774 11.0323 5.96774C9.90887 5.96774 9 6.87661 9 8C9 9.12339 9.90887 10.0323 11.0323 10.0323C12.1556 10.0323 13.0645 9.12339 13.0645 8ZM11.0323 5.06452C9.90887 5.06452 9 4.15565 9 3.03226C9 1.90887 9.90887 1 11.0323 1C12.1556 1 13.0645 1.90887 13.0645 3.03226C13.0645 4.15565 12.1556 5.06452 11.0323 5.06452ZM11.0323 15C9.90887 15 9 14.0911 9 12.9677C9 11.8444 9.90887 10.9355 11.0323 10.9355C12.1556 10.9355 13.0645 11.8444 13.0645 12.9677C13.0645 14.0911 12.1556 15 11.0323 15Z", fill: "#6CC5FF" })), dt = (n) => /* @__PURE__ */ q.createElement("svg", { xmlns: "http://www.w3.org/2000/svg", width: 16, height: 16, viewBox: "0 0 16 16", fill: "none", ...n }, /* @__PURE__ */ q.createElement("path", { d: "M5.225 0.553125L5 1H2C1.44687 1 1 1.44687 1 2C1 2.55312 1.44687 3 2 3H14C14.5531 3 15 2.55312 15 2C15 1.44687 14.5531 1 14 1H11L10.775 0.553125C10.6062 0.2125 10.2594 0 9.88125 0H6.11875C5.74062 0 5.39375 0.2125 5.225 0.553125ZM14 4H2L2.6625 14.5938C2.7125 15.3844 3.36875 16 4.15937 16H11.8406C12.6312 16 13.2875 15.3844 13.3375 14.5938L14 4Z", fill: "#6CC5FF" }));
function wt({
  items: n,
  updateCallback: t,
  selectionCallback: g,
  className: e,
  renderDragPreview: r,
  dragDisabled: i = !1,
  deletionDisabled: a = !1,
  ...d
}) {
  const v = it({
    initialItems: n
  });
  E(() => {
    t && t(v.items);
  }, [v, t, n]);
  const { dragAndDropHooks: h } = at({
    getItems: (y) => [...y].map((b) => ({ "text/plain": v.getItem(b).name })),
    getAllowedDropOperations: () => ["move"],
    onReorder(y) {
      y.target.dropPosition === "before" ? v.moveBefore(y.target.key, y.keys) : y.target.dropPosition === "after" && v.moveAfter(y.target.key, y.keys);
    },
    renderDragPreview: r
  });
  return /* @__PURE__ */ R.jsx(
    $e,
    {
      ...d,
      "aria-label": d["aria-label"] ?? "Reorderable list",
      selectionMode: "single",
      items: v.items,
      dragAndDropHooks: i ? void 0 : h,
      onSelectionChange: (y) => {
        const b = Array.from(y), p = v.getItem(b[0]);
        g && p && g(p);
      },
      className: te(
        "bg-klerosUIComponentsLightBackground rounded-base border-klerosUIComponentsStroke border",
        "w-95.5 py-4",
        "[&_div]:data-drop-target:outline-klerosUIComponentsPrimaryBlue [&_div]:data-drop-target:outline",
        e
      ),
      children: (y) => /* @__PURE__ */ R.jsx(
        be,
        {
          textValue: y.name,
          className: ({ isHovered: b, isDragging: p, isSelected: $ }) => te(
            "h-11.25 w-full cursor-pointer border-l-3 border-l-transparent",
            "flex items-center gap-4 px-4",
            "focus-visible:outline-klerosUIComponentsPrimaryBlue focus-visible:outline",
            (b || $) && "bg-klerosUIComponentsMediumBlue",
            $ && "border-l-klerosUIComponentsPrimaryBlue",
            p && "cursor-grabbing opacity-60"
          ),
          children: ({ isHovered: b }) => /* @__PURE__ */ R.jsxs(R.Fragment, { children: [
            i ? null : /* @__PURE__ */ R.jsx(st, { className: "size-4 cursor-grab" }),
            /* @__PURE__ */ R.jsx("span", { className: "text-klerosUIComponentsPrimaryText flex-1 text-base", children: y.name }),
            b && !a ? /* @__PURE__ */ R.jsx(
              De,
              {
                className: "cursor-pointer hover:scale-105",
                onPress: () => {
                  v.remove(y.id);
                },
                children: ({ isHovered: p }) => /* @__PURE__ */ R.jsx(
                  dt,
                  {
                    className: me(
                      "ease-ease size-4 transition",
                      p && "[&_path]:fill-klerosUIComponentsPrimaryBlue"
                    )
                  }
                )
              }
            ) : null
          ] })
        }
      )
    }
  );
}
export {
  wt as default
};
