import { j as h, c as B } from "../clsx-DsQc8enX.js";
import * as g from "react";
import P, { useEffect as D, useRef as F, forwardRef as H, useContext as M, createContext as U } from "react";
import { $ as L } from "../RSPContexts-EOiWkKOf.js";
import { $ as R, b as N, f as z, c as T, i as W, h as k, d as Z } from "../utils-DPfg4HqB.js";
import { a as S, b as O, d as A, $ as G } from "../Form-CjZKgLHe.js";
import { $ as J } from "../filterDOMProps-D6KHYVBX.js";
import { $ as K } from "../useFormValidation-B8seeWsn.js";
import { a as Q } from "../usePress-BKP_smFB.js";
import { $ as X, a as q } from "../useToggleState-DfYwdKDC.js";
import { $ as Y } from "../useFocusRing-DTBeynF4.js";
import { a as ee } from "../useHover-r8IM8mvD.js";
import { $ as ie } from "../VisuallyHidden-5Sj7PJLN.js";
import { c as ae } from "../index-h1rMlRhQ.js";
function E(i, e, a) {
  let d = S({
    ...i,
    value: e.isSelected
  }), { isInvalid: n, validationErrors: m, validationDetails: f } = d.displayValidation, { labelProps: t, inputProps: u, isSelected: r, isPressed: c, isDisabled: b, isReadOnly: $ } = X({
    ...i,
    isInvalid: n
  }, e, a);
  K(i, d, a);
  let { isIndeterminate: v, isRequired: l, validationBehavior: o = "aria" } = i;
  D(() => {
    a.current && (a.current.indeterminate = !!v);
  });
  let { pressProps: s } = Q({
    isDisabled: b || $,
    onPress() {
      let { [O]: x } = i, { commitValidation: p } = x || d;
      p();
    }
  });
  return {
    labelProps: R(t, s),
    inputProps: {
      ...u,
      checked: r,
      "aria-required": l && o === "aria" || void 0,
      required: l && o === "native"
    },
    isSelected: r,
    isPressed: c,
    isDisabled: b,
    isReadOnly: $,
    isInvalid: n,
    validationErrors: m,
    validationDetails: f
  };
}
const de = /* @__PURE__ */ new WeakMap();
function te(i, e, a) {
  const d = q({
    isReadOnly: i.isReadOnly || e.isReadOnly,
    isSelected: e.isSelected(i.value),
    onChange(s) {
      s ? e.addValue(i.value) : e.removeValue(i.value), i.onChange && i.onChange(s);
    }
  });
  let { name: n, descriptionId: m, errorMessageId: f, validationBehavior: t } = de.get(e);
  var u;
  t = (u = i.validationBehavior) !== null && u !== void 0 ? u : t;
  let { realtimeValidation: r } = S({
    ...i,
    value: d.isSelected,
    // Server validation is handled at the group level.
    name: void 0,
    validationBehavior: "aria"
  }), c = F(A), b = () => {
    e.setInvalid(i.value, r.isInvalid ? r : c.current);
  };
  D(b);
  let $ = e.realtimeValidation.isInvalid ? e.realtimeValidation : r, v = t === "native" ? e.displayValidation : $;
  var l;
  let o = E({
    ...i,
    isReadOnly: i.isReadOnly || e.isReadOnly,
    isDisabled: i.isDisabled || e.isDisabled,
    name: i.name || n,
    isRequired: (l = i.isRequired) !== null && l !== void 0 ? l : e.isRequired,
    validationBehavior: t,
    [O]: {
      realtimeValidation: $,
      displayValidation: v,
      resetValidation: e.resetValidation,
      commitValidation: e.commitValidation,
      updateValidation(s) {
        c.current = s, b();
      }
    }
  }, d, a);
  return {
    ...o,
    inputProps: {
      ...o.inputProps,
      "aria-describedby": [
        i["aria-describedby"],
        e.isInvalid ? f : null,
        m
      ].filter(Boolean).join(" ") || void 0
    }
  };
}
const le = /* @__PURE__ */ U(null), ne = /* @__PURE__ */ H(function(e, a) {
  let { inputRef: d = null, ...n } = e;
  [e, a] = N(n, a, L);
  let { validationBehavior: m } = z(G) || {};
  var f, t;
  let u = (t = (f = e.validationBehavior) !== null && f !== void 0 ? f : m) !== null && t !== void 0 ? t : "native", r = M(le), c = T(W(d, e.inputRef !== void 0 ? e.inputRef : null)), { labelProps: b, inputProps: $, isSelected: v, isDisabled: l, isReadOnly: o, isPressed: s, isInvalid: x } = r ? te({
    ...k(e),
    // Value is optional for standalone checkboxes, but required for CheckboxGroup items;
    // it's passed explicitly here to avoid typescript error (requires ignore).
    // @ts-ignore
    value: e.value,
    // ReactNode type doesn't allow function children.
    children: typeof e.children == "function" ? !0 : e.children
  }, r, c) : E({
    ...k(e),
    children: typeof e.children == "function" ? !0 : e.children,
    validationBehavior: u
  }, q(e), c), { isFocused: p, isFocusVisible: I, focusProps: _ } = Y(), w = l || o, { hoverProps: j, isHovered: V } = ee({
    ...e,
    isDisabled: w
  }), y = Z({
    ...e,
    defaultClassName: "react-aria-Checkbox",
    values: {
      isSelected: v,
      isIndeterminate: e.isIndeterminate || !1,
      isPressed: s,
      isHovered: V,
      isFocused: p,
      isFocusVisible: I,
      isDisabled: l,
      isReadOnly: o,
      isInvalid: x,
      isRequired: e.isRequired || !1
    }
  }), C = J(e);
  return delete C.id, /* @__PURE__ */ P.createElement("label", {
    ...R(C, b, j, y),
    ref: a,
    slot: e.slot || void 0,
    "data-selected": v || void 0,
    "data-indeterminate": e.isIndeterminate || void 0,
    "data-pressed": s || void 0,
    "data-hovered": V || void 0,
    "data-focused": p || void 0,
    "data-focus-visible": I || void 0,
    "data-disabled": l || void 0,
    "data-readonly": o || void 0,
    "data-invalid": x || void 0,
    "data-required": e.isRequired || void 0
  }, /* @__PURE__ */ P.createElement(ie, {
    elementType: "span"
  }, /* @__PURE__ */ P.createElement("input", {
    ...R($, _),
    ref: c
  })), y.children);
}), re = (i) => /* @__PURE__ */ g.createElement("svg", { viewBox: "0 0 15 12", xmlns: "http://www.w3.org/2000/svg", ...i }, /* @__PURE__ */ g.createElement("path", { d: "M14.4165 0H12.6466C12.2617 0 11.8956 0.184917 11.6692 0.501919L5.7367 8.72887L3.04973 5.00033C2.8233 4.6871 2.46102 4.49841 2.07231 4.49841H0.302384C0.0570854 4.49841 -0.0863201 4.77767 0.0570854 4.97768L4.75928 11.4989C4.87036 11.6539 5.0168 11.7802 5.18645 11.8674C5.3561 11.9545 5.54409 12 5.73481 12C5.92554 12 6.11352 11.9545 6.28318 11.8674C6.45283 11.7802 6.59927 11.6539 6.71035 11.4989L14.658 0.479277C14.8052 0.279264 14.6618 0 14.4165 0Z" }));
function Re({
  small: i = !1,
  label: e,
  className: a,
  ...d
}) {
  return /* @__PURE__ */ h.jsx(
    ne,
    {
      className: ae(
        "relative box-border block cursor-pointer",
        "text-klerosUIComponentsPrimaryText",
        i ? "pl-7 text-base" : "pl-[35px] text-[22px]",
        a
      ),
      ...d,
      children: ({ isSelected: n }) => /* @__PURE__ */ h.jsxs(h.Fragment, { children: [
        e,
        /* @__PURE__ */ h.jsx(
          "div",
          {
            className: B(
              "absolute top-1 left-0",
              "rounded-base border-klerosUIComponentsStroke border",
              "overflow-hidden",
              i ? "size-4" : "size-6",
              n && "bg-klerosUIComponentsPrimaryBlue border-none after:block"
            ),
            children: /* @__PURE__ */ h.jsx(
              re,
              {
                className: B(
                  "absolute top-0.25 size-full",
                  n ? "bg-klerosUIComponentsPrimaryBlue fill-klerosUIComponentsWhiteBackground animate-bounce-in" : "fill-transparent",
                  i ? "px-0.75" : "px-1"
                )
              }
            )
          }
        )
      ] })
    }
  );
}
export {
  Re as default
};
