import { j as z, c as Q } from "./clsx-DsQc8enX.js";
import { c as Su, a as Fu, $ as Ku } from "./Button-CXfbBbgl.js";
import { $ as zu } from "./RSPContexts-EOiWkKOf.js";
import { l as Mu, $ as Tu, m as Ru, n as ju, o as Nu, b as oe, p as Vu, e as ae, f as Lu, c as Uu, d as _u, q as Hu, g as Ou } from "./Collection-CYEl0MHQ.js";
import { j as Wu, a as se, $ as R, m as Gu, k as Zu, d as j, b as qu, c as Ju, e as ie, o as Xu } from "./utils-DPfg4HqB.js";
import { $ as N } from "./filterDOMProps-D6KHYVBX.js";
import { $ as re } from "./useControlledState-Kv9K2AYu.js";
import $, { useRef as G, useMemo as Z, useCallback as Yu, useEffect as H, forwardRef as Qu, useContext as V, createContext as q } from "react";
import { d as et } from "./usePress-BKP_smFB.js";
import { $ as M } from "./getScrollParent-mRV3mdwj.js";
import { $ as T } from "./scrollIntoView-DzN8eF1C.js";
import { $ as ee, b as ut } from "./FocusScope-B-R06ewx.js";
import { D as tt, t as I, m as lt, h as nt, a as ot } from "./useHover-r8IM8mvD.js";
import { $ as at } from "./context-DRz_xlLl.js";
import { $ as st } from "./useLabels-vObMberA.js";
import { $ as L } from "./useLocalizedStringFormatter-BXegnzqm.js";
import { $ as it } from "./useDescription-DBX9pMU8.js";
import { $ as rt } from "./useUpdateEffect-CCDx8D4X.js";
import { $ as ct } from "./useHasTabbableChild-DtFu1sjk.js";
import { a as dt } from "./useSelectableList-CKfXeGoq.js";
import { $ as O } from "./useFocusRing-DTBeynF4.js";
import { c as _ } from "./index-h1rMlRhQ.js";
import { S as $t } from "./light-left-B0pH2j2A.js";
const J = /* @__PURE__ */ new WeakMap();
function W(e, u) {
  var t;
  let { id: l } = (t = J.get(e)) !== null && t !== void 0 ? t : {};
  if (!l) throw new Error("Unknown list");
  return `${l}-${pt(u)}`;
}
function pt(e) {
  return typeof e == "string" ? e.replace(/\s*/g, "") : "" + e;
}
var ce = {};
ce = {
  deselectedItem: (e) => `${e.item} غير المحدد`,
  longPressToSelect: "اضغط مطولًا للدخول إلى وضع التحديد.",
  select: "تحديد",
  selectedAll: "جميع العناصر المحددة.",
  selectedCount: (e, u) => `${u.plural(e.count, {
    "=0": "لم يتم تحديد عناصر",
    one: () => `${u.number(e.count)} عنصر محدد`,
    other: () => `${u.number(e.count)} عنصر محدد`
  })}.`,
  selectedItem: (e) => `${e.item} المحدد`
};
var de = {};
de = {
  deselectedItem: (e) => `${e.item} не е избран.`,
  longPressToSelect: "Натиснете и задръжте за да влезете в избирателен режим.",
  select: "Изберете",
  selectedAll: "Всички елементи са избрани.",
  selectedCount: (e, u) => `${u.plural(e.count, {
    "=0": "Няма избрани елементи",
    one: () => `${u.number(e.count)} избран елемент`,
    other: () => `${u.number(e.count)} избрани елементи`
  })}.`,
  selectedItem: (e) => `${e.item} избран.`
};
var $e = {};
$e = {
  deselectedItem: (e) => `Položka ${e.item} není vybrána.`,
  longPressToSelect: "Dlouhým stisknutím přejdete do režimu výběru.",
  select: "Vybrat",
  selectedAll: "Vybrány všechny položky.",
  selectedCount: (e, u) => `${u.plural(e.count, {
    "=0": "Nevybrány žádné položky",
    one: () => `Vybrána ${u.number(e.count)} položka`,
    other: () => `Vybráno ${u.number(e.count)} položek`
  })}.`,
  selectedItem: (e) => `Vybrána položka ${e.item}.`
};
var pe = {};
pe = {
  deselectedItem: (e) => `${e.item} ikke valgt.`,
  longPressToSelect: "Lav et langt tryk for at aktivere valgtilstand.",
  select: "Vælg",
  selectedAll: "Alle elementer valgt.",
  selectedCount: (e, u) => `${u.plural(e.count, {
    "=0": "Ingen elementer valgt",
    one: () => `${u.number(e.count)} element valgt`,
    other: () => `${u.number(e.count)} elementer valgt`
  })}.`,
  selectedItem: (e) => `${e.item} valgt.`
};
var be = {};
be = {
  deselectedItem: (e) => `${e.item} nicht ausgewählt.`,
  longPressToSelect: "Gedrückt halten, um Auswahlmodus zu öffnen.",
  select: "Auswählen",
  selectedAll: "Alle Elemente ausgewählt.",
  selectedCount: (e, u) => `${u.plural(e.count, {
    "=0": "Keine Elemente ausgewählt",
    one: () => `${u.number(e.count)} Element ausgewählt`,
    other: () => `${u.number(e.count)} Elemente ausgewählt`
  })}.`,
  selectedItem: (e) => `${e.item} ausgewählt.`
};
var me = {};
me = {
  deselectedItem: (e) => `Δεν επιλέχθηκε το στοιχείο ${e.item}.`,
  longPressToSelect: "Πατήστε παρατεταμένα για να μπείτε σε λειτουργία επιλογής.",
  select: "Επιλογή",
  selectedAll: "Επιλέχθηκαν όλα τα στοιχεία.",
  selectedCount: (e, u) => `${u.plural(e.count, {
    "=0": "Δεν επιλέχθηκαν στοιχεία",
    one: () => `Επιλέχθηκε ${u.number(e.count)} στοιχείο`,
    other: () => `Επιλέχθηκαν ${u.number(e.count)} στοιχεία`
  })}.`,
  selectedItem: (e) => `Επιλέχθηκε το στοιχείο ${e.item}.`
};
var fe = {};
fe = {
  deselectedItem: (e) => `${e.item} not selected.`,
  select: "Select",
  selectedCount: (e, u) => `${u.plural(e.count, {
    "=0": "No items selected",
    one: () => `${u.number(e.count)} item selected`,
    other: () => `${u.number(e.count)} items selected`
  })}.`,
  selectedAll: "All items selected.",
  selectedItem: (e) => `${e.item} selected.`,
  longPressToSelect: "Long press to enter selection mode."
};
var xe = {};
xe = {
  deselectedItem: (e) => `${e.item} no seleccionado.`,
  longPressToSelect: "Mantenga pulsado para abrir el modo de selección.",
  select: "Seleccionar",
  selectedAll: "Todos los elementos seleccionados.",
  selectedCount: (e, u) => `${u.plural(e.count, {
    "=0": "Ningún elemento seleccionado",
    one: () => `${u.number(e.count)} elemento seleccionado`,
    other: () => `${u.number(e.count)} elementos seleccionados`
  })}.`,
  selectedItem: (e) => `${e.item} seleccionado.`
};
var ve = {};
ve = {
  deselectedItem: (e) => `${e.item} pole valitud.`,
  longPressToSelect: "Valikurežiimi sisenemiseks vajutage pikalt.",
  select: "Vali",
  selectedAll: "Kõik üksused valitud.",
  selectedCount: (e, u) => `${u.plural(e.count, {
    "=0": "Üksusi pole valitud",
    one: () => `${u.number(e.count)} üksus valitud`,
    other: () => `${u.number(e.count)} üksust valitud`
  })}.`,
  selectedItem: (e) => `${e.item} valitud.`
};
var ye = {};
ye = {
  deselectedItem: (e) => `Kohdetta ${e.item} ei valittu.`,
  longPressToSelect: "Siirry valintatilaan painamalla pitkään.",
  select: "Valitse",
  selectedAll: "Kaikki kohteet valittu.",
  selectedCount: (e, u) => `${u.plural(e.count, {
    "=0": "Ei yhtään kohdetta valittu",
    one: () => `${u.number(e.count)} kohde valittu`,
    other: () => `${u.number(e.count)} kohdetta valittu`
  })}.`,
  selectedItem: (e) => `${e.item} valittu.`
};
var Be = {};
Be = {
  deselectedItem: (e) => `${e.item} non sélectionné.`,
  longPressToSelect: "Appuyez de manière prolongée pour passer en mode de sélection.",
  select: "Sélectionner",
  selectedAll: "Tous les éléments sélectionnés.",
  selectedCount: (e, u) => `${u.plural(e.count, {
    "=0": "Aucun élément sélectionné",
    one: () => `${u.number(e.count)} élément sélectionné`,
    other: () => `${u.number(e.count)} éléments sélectionnés`
  })}.`,
  selectedItem: (e) => `${e.item} sélectionné.`
};
var Ce = {};
Ce = {
  deselectedItem: (e) => `${e.item} לא נבחר.`,
  longPressToSelect: "הקשה ארוכה לכניסה למצב בחירה.",
  select: "בחר",
  selectedAll: "כל הפריטים נבחרו.",
  selectedCount: (e, u) => `${u.plural(e.count, {
    "=0": "לא נבחרו פריטים",
    one: () => `פריט ${u.number(e.count)} נבחר`,
    other: () => `${u.number(e.count)} פריטים נבחרו`
  })}.`,
  selectedItem: (e) => `${e.item} נבחר.`
};
var he = {};
he = {
  deselectedItem: (e) => `Stavka ${e.item} nije odabrana.`,
  longPressToSelect: "Dugo pritisnite za ulazak u način odabira.",
  select: "Odaberite",
  selectedAll: "Odabrane su sve stavke.",
  selectedCount: (e, u) => `${u.plural(e.count, {
    "=0": "Nije odabrana nijedna stavka",
    one: () => `Odabrana je ${u.number(e.count)} stavka`,
    other: () => `Odabrano je ${u.number(e.count)} stavki`
  })}.`,
  selectedItem: (e) => `Stavka ${e.item} je odabrana.`
};
var De = {};
De = {
  deselectedItem: (e) => `${e.item} nincs kijelölve.`,
  longPressToSelect: "Nyomja hosszan a kijelöléshez.",
  select: "Kijelölés",
  selectedAll: "Az összes elem kijelölve.",
  selectedCount: (e, u) => `${u.plural(e.count, {
    "=0": "Egy elem sincs kijelölve",
    one: () => `${u.number(e.count)} elem kijelölve`,
    other: () => `${u.number(e.count)} elem kijelölve`
  })}.`,
  selectedItem: (e) => `${e.item} kijelölve.`
};
var Ee = {};
Ee = {
  deselectedItem: (e) => `${e.item} non selezionato.`,
  longPressToSelect: "Premi a lungo per passare alla modalità di selezione.",
  select: "Seleziona",
  selectedAll: "Tutti gli elementi selezionati.",
  selectedCount: (e, u) => `${u.plural(e.count, {
    "=0": "Nessun elemento selezionato",
    one: () => `${u.number(e.count)} elemento selezionato`,
    other: () => `${u.number(e.count)} elementi selezionati`
  })}.`,
  selectedItem: (e) => `${e.item} selezionato.`
};
var ke = {};
ke = {
  deselectedItem: (e) => `${e.item} が選択されていません。`,
  longPressToSelect: "長押しして選択モードを開きます。",
  select: "選択",
  selectedAll: "すべての項目を選択しました。",
  selectedCount: (e, u) => `${u.plural(e.count, {
    "=0": "項目が選択されていません",
    one: () => `${u.number(e.count)} 項目を選択しました`,
    other: () => `${u.number(e.count)} 項目を選択しました`
  })}。`,
  selectedItem: (e) => `${e.item} を選択しました。`
};
var ge = {};
ge = {
  deselectedItem: (e) => `${e.item}이(가) 선택되지 않았습니다.`,
  longPressToSelect: "선택 모드로 들어가려면 길게 누르십시오.",
  select: "선택",
  selectedAll: "모든 항목이 선택되었습니다.",
  selectedCount: (e, u) => `${u.plural(e.count, {
    "=0": "선택된 항목이 없습니다",
    one: () => `${u.number(e.count)}개 항목이 선택되었습니다`,
    other: () => `${u.number(e.count)}개 항목이 선택되었습니다`
  })}.`,
  selectedItem: (e) => `${e.item}이(가) 선택되었습니다.`
};
var Ae = {};
Ae = {
  deselectedItem: (e) => `${e.item} nepasirinkta.`,
  longPressToSelect: "Norėdami įjungti pasirinkimo režimą, paspauskite ir palaikykite.",
  select: "Pasirinkti",
  selectedAll: "Pasirinkti visi elementai.",
  selectedCount: (e, u) => `${u.plural(e.count, {
    "=0": "Nepasirinktas nė vienas elementas",
    one: () => `Pasirinktas ${u.number(e.count)} elementas`,
    other: () => `Pasirinkta elementų: ${u.number(e.count)}`
  })}.`,
  selectedItem: (e) => `Pasirinkta: ${e.item}.`
};
var Pe = {};
Pe = {
  deselectedItem: (e) => `Vienums ${e.item} nav atlasīts.`,
  longPressToSelect: "Ilgi turiet nospiestu. lai ieslēgtu atlases režīmu.",
  select: "Atlasīt",
  selectedAll: "Atlasīti visi vienumi.",
  selectedCount: (e, u) => `${u.plural(e.count, {
    "=0": "Nav atlasīts neviens vienums",
    one: () => `Atlasīto vienumu skaits: ${u.number(e.count)}`,
    other: () => `Atlasīto vienumu skaits: ${u.number(e.count)}`
  })}.`,
  selectedItem: (e) => `Atlasīts vienums ${e.item}.`
};
var Ie = {};
Ie = {
  deselectedItem: (e) => `${e.item} er ikke valgt.`,
  longPressToSelect: "Bruk et langt trykk for å gå inn i valgmodus.",
  select: "Velg",
  selectedAll: "Alle elementer er valgt.",
  selectedCount: (e, u) => `${u.plural(e.count, {
    "=0": "Ingen elementer er valgt",
    one: () => `${u.number(e.count)} element er valgt`,
    other: () => `${u.number(e.count)} elementer er valgt`
  })}.`,
  selectedItem: (e) => `${e.item} er valgt.`
};
var we = {};
we = {
  deselectedItem: (e) => `${e.item} niet geselecteerd.`,
  longPressToSelect: "Druk lang om de selectiemodus te openen.",
  select: "Selecteren",
  selectedAll: "Alle items geselecteerd.",
  selectedCount: (e, u) => `${u.plural(e.count, {
    "=0": "Geen items geselecteerd",
    one: () => `${u.number(e.count)} item geselecteerd`,
    other: () => `${u.number(e.count)} items geselecteerd`
  })}.`,
  selectedItem: (e) => `${e.item} geselecteerd.`
};
var Se = {};
Se = {
  deselectedItem: (e) => `Nie zaznaczono ${e.item}.`,
  longPressToSelect: "Naciśnij i przytrzymaj, aby wejść do trybu wyboru.",
  select: "Zaznacz",
  selectedAll: "Wszystkie zaznaczone elementy.",
  selectedCount: (e, u) => `${u.plural(e.count, {
    "=0": "Nie zaznaczono żadnych elementów",
    one: () => `${u.number(e.count)} zaznaczony element`,
    other: () => `${u.number(e.count)} zaznaczonych elementów`
  })}.`,
  selectedItem: (e) => `Zaznaczono ${e.item}.`
};
var Fe = {};
Fe = {
  deselectedItem: (e) => `${e.item} não selecionado.`,
  longPressToSelect: "Mantenha pressionado para entrar no modo de seleção.",
  select: "Selecionar",
  selectedAll: "Todos os itens selecionados.",
  selectedCount: (e, u) => `${u.plural(e.count, {
    "=0": "Nenhum item selecionado",
    one: () => `${u.number(e.count)} item selecionado`,
    other: () => `${u.number(e.count)} itens selecionados`
  })}.`,
  selectedItem: (e) => `${e.item} selecionado.`
};
var Ke = {};
Ke = {
  deselectedItem: (e) => `${e.item} não selecionado.`,
  longPressToSelect: "Prima continuamente para entrar no modo de seleção.",
  select: "Selecionar",
  selectedAll: "Todos os itens selecionados.",
  selectedCount: (e, u) => `${u.plural(e.count, {
    "=0": "Nenhum item selecionado",
    one: () => `${u.number(e.count)} item selecionado`,
    other: () => `${u.number(e.count)} itens selecionados`
  })}.`,
  selectedItem: (e) => `${e.item} selecionado.`
};
var ze = {};
ze = {
  deselectedItem: (e) => `${e.item} neselectat.`,
  longPressToSelect: "Apăsați lung pentru a intra în modul de selectare.",
  select: "Selectare",
  selectedAll: "Toate elementele selectate.",
  selectedCount: (e, u) => `${u.plural(e.count, {
    "=0": "Niciun element selectat",
    one: () => `${u.number(e.count)} element selectat`,
    other: () => `${u.number(e.count)} elemente selectate`
  })}.`,
  selectedItem: (e) => `${e.item} selectat.`
};
var Me = {};
Me = {
  deselectedItem: (e) => `${e.item} не выбрано.`,
  longPressToSelect: "Нажмите и удерживайте для входа в режим выбора.",
  select: "Выбрать",
  selectedAll: "Выбраны все элементы.",
  selectedCount: (e, u) => `${u.plural(e.count, {
    "=0": "Нет выбранных элементов",
    one: () => `${u.number(e.count)} элемент выбран`,
    other: () => `${u.number(e.count)} элементов выбрано`
  })}.`,
  selectedItem: (e) => `${e.item} выбрано.`
};
var Te = {};
Te = {
  deselectedItem: (e) => `Nevybraté položky: ${e.item}.`,
  longPressToSelect: "Dlhším stlačením prejdite do režimu výberu.",
  select: "Vybrať",
  selectedAll: "Všetky vybraté položky.",
  selectedCount: (e, u) => `${u.plural(e.count, {
    "=0": "Žiadne vybraté položky",
    one: () => `${u.number(e.count)} vybratá položka`,
    other: () => `Počet vybratých položiek:${u.number(e.count)}`
  })}.`,
  selectedItem: (e) => `Vybraté položky: ${e.item}.`
};
var Re = {};
Re = {
  deselectedItem: (e) => `Element ${e.item} ni izbran.`,
  longPressToSelect: "Za izbirni način pritisnite in dlje časa držite.",
  select: "Izberite",
  selectedAll: "Vsi elementi so izbrani.",
  selectedCount: (e, u) => `${u.plural(e.count, {
    "=0": "Noben element ni izbran",
    one: () => `${u.number(e.count)} element je izbran`,
    other: () => `${u.number(e.count)} elementov je izbranih`
  })}.`,
  selectedItem: (e) => `Element ${e.item} je izbran.`
};
var je = {};
je = {
  deselectedItem: (e) => `${e.item} nije izabrano.`,
  longPressToSelect: "Dugo pritisnite za ulazak u režim biranja.",
  select: "Izaberite",
  selectedAll: "Izabrane su sve stavke.",
  selectedCount: (e, u) => `${u.plural(e.count, {
    "=0": "Nije izabrana nijedna stavka",
    one: () => `Izabrana je ${u.number(e.count)} stavka`,
    other: () => `Izabrano je ${u.number(e.count)} stavki`
  })}.`,
  selectedItem: (e) => `${e.item} je izabrano.`
};
var Ne = {};
Ne = {
  deselectedItem: (e) => `${e.item} ej markerat.`,
  longPressToSelect: "Tryck länge när du vill öppna väljarläge.",
  select: "Markera",
  selectedAll: "Alla markerade objekt.",
  selectedCount: (e, u) => `${u.plural(e.count, {
    "=0": "Inga markerade objekt",
    one: () => `${u.number(e.count)} markerat objekt`,
    other: () => `${u.number(e.count)} markerade objekt`
  })}.`,
  selectedItem: (e) => `${e.item} markerat.`
};
var Ve = {};
Ve = {
  deselectedItem: (e) => `${e.item} seçilmedi.`,
  longPressToSelect: "Seçim moduna girmek için uzun basın.",
  select: "Seç",
  selectedAll: "Tüm ögeler seçildi.",
  selectedCount: (e, u) => `${u.plural(e.count, {
    "=0": "Hiçbir öge seçilmedi",
    one: () => `${u.number(e.count)} öge seçildi`,
    other: () => `${u.number(e.count)} öge seçildi`
  })}.`,
  selectedItem: (e) => `${e.item} seçildi.`
};
var Le = {};
Le = {
  deselectedItem: (e) => `${e.item} не вибрано.`,
  longPressToSelect: "Виконайте довге натиснення, щоб перейти в режим вибору.",
  select: "Вибрати",
  selectedAll: "Усі елементи вибрано.",
  selectedCount: (e, u) => `${u.plural(e.count, {
    "=0": "Жодних елементів не вибрано",
    one: () => `${u.number(e.count)} елемент вибрано`,
    other: () => `Вибрано елементів: ${u.number(e.count)}`
  })}.`,
  selectedItem: (e) => `${e.item} вибрано.`
};
var Ue = {};
Ue = {
  deselectedItem: (e) => `未选择 ${e.item}。`,
  longPressToSelect: "长按以进入选择模式。",
  select: "选择",
  selectedAll: "已选择所有项目。",
  selectedCount: (e, u) => `${u.plural(e.count, {
    "=0": "未选择项目",
    one: () => `已选择 ${u.number(e.count)} 个项目`,
    other: () => `已选择 ${u.number(e.count)} 个项目`
  })}。`,
  selectedItem: (e) => `已选择 ${e.item}。`
};
var _e = {};
_e = {
  deselectedItem: (e) => `未選取「${e.item}」。`,
  longPressToSelect: "長按以進入選擇模式。",
  select: "選取",
  selectedAll: "已選取所有項目。",
  selectedCount: (e, u) => `${u.plural(e.count, {
    "=0": "未選取任何項目",
    one: () => `已選取 ${u.number(e.count)} 個項目`,
    other: () => `已選取 ${u.number(e.count)} 個項目`
  })}。`,
  selectedItem: (e) => `已選取「${e.item}」。`
};
var U = {};
U = {
  "ar-AE": ce,
  "bg-BG": de,
  "cs-CZ": $e,
  "da-DK": pe,
  "de-DE": be,
  "el-GR": me,
  "en-US": fe,
  "es-ES": xe,
  "et-EE": ve,
  "fi-FI": ye,
  "fr-FR": Be,
  "he-IL": Ce,
  "hr-HR": he,
  "hu-HU": De,
  "it-IT": Ee,
  "ja-JP": ke,
  "ko-KR": ge,
  "lt-LT": Ae,
  "lv-LV": Pe,
  "nb-NO": Ie,
  "nl-NL": we,
  "pl-PL": Se,
  "pt-BR": Fe,
  "pt-PT": Ke,
  "ro-RO": ze,
  "ru-RU": Me,
  "sk-SK": Te,
  "sl-SI": Re,
  "sr-SP": je,
  "sv-SE": Ne,
  "tr-TR": Ve,
  "uk-UA": Le,
  "zh-CN": Ue,
  "zh-TW": _e
};
function bt(e) {
  return e && e.__esModule ? e.default : e;
}
function mt(e, u) {
  let { getRowText: t = (i) => {
    var s, c, f, d;
    return (d = (s = (c = u.collection).getTextValue) === null || s === void 0 ? void 0 : s.call(c, i)) !== null && d !== void 0 ? d : (f = u.collection.getItem(i)) === null || f === void 0 ? void 0 : f.textValue;
  } } = e, l = L(bt(U), "@react-aria/grid"), n = u.selectionManager.rawSelection, o = G(n), a = Wu(() => {
    var i;
    if (!u.selectionManager.isFocused || n === o.current) {
      o.current = n;
      return;
    }
    let s = ue(n, o.current), c = ue(o.current, n), f = u.selectionManager.selectionBehavior === "replace", d = [];
    if (u.selectionManager.selectedKeys.size === 1 && f) {
      if (u.collection.getItem(u.selectionManager.selectedKeys.keys().next().value)) {
        let p = t(u.selectionManager.selectedKeys.keys().next().value);
        p && d.push(l.format("selectedItem", {
          item: p
        }));
      }
    } else if (s.size === 1 && c.size === 0) {
      let p = t(s.keys().next().value);
      p && d.push(l.format("selectedItem", {
        item: p
      }));
    } else if (c.size === 1 && s.size === 0 && u.collection.getItem(c.keys().next().value)) {
      let p = t(c.keys().next().value);
      p && d.push(l.format("deselectedItem", {
        item: p
      }));
    }
    u.selectionManager.selectionMode === "multiple" && (d.length === 0 || n === "all" || n.size > 1 || o.current === "all" || ((i = o.current) === null || i === void 0 ? void 0 : i.size) > 1) && d.push(n === "all" ? l.format("selectedAll") : l.format("selectedCount", {
      count: n.size
    })), d.length > 0 && Su(d.join(" ")), o.current = n;
  });
  rt(() => {
    if (u.selectionManager.isFocused) a();
    else {
      let i = requestAnimationFrame(a);
      return () => cancelAnimationFrame(i);
    }
  }, [
    n,
    u.selectionManager.isFocused
  ]);
}
function ue(e, u) {
  let t = /* @__PURE__ */ new Set();
  if (e === "all" || u === "all") return t;
  for (let l of e.keys()) u.has(l) || t.add(l);
  return t;
}
function ft(e) {
  return e && e.__esModule ? e.default : e;
}
function xt(e) {
  let u = L(ft(U), "@react-aria/grid"), t = tt(), l = (t === "pointer" || t === "virtual" || t == null) && typeof window < "u" && "ontouchstart" in window, n = Z(() => {
    let a = e.selectionManager.selectionMode, i = e.selectionManager.selectionBehavior, s;
    return l && (s = u.format("longPressToSelect")), i === "replace" && a !== "none" && e.hasItemActions ? s : void 0;
  }, [
    e.selectionManager.selectionMode,
    e.selectionManager.selectionBehavior,
    e.hasItemActions,
    u,
    l
  ]);
  return it(n);
}
function vt(e) {
  return e && e.__esModule ? e.default : e;
}
function yt(e, u) {
  let { key: t } = e, l = u.selectionManager, n = se(), o = !u.selectionManager.canSelectItem(t), a = u.selectionManager.isSelected(t), i = () => l.toggleSelection(t);
  const s = L(vt(U), "@react-aria/grid");
  return {
    checkboxProps: {
      id: n,
      "aria-label": s.format("select"),
      isSelected: a,
      isDisabled: o,
      onChange: i
    }
  };
}
function Bt(e, u, t) {
  let { isVirtualized: l, keyboardDelegate: n, layoutDelegate: o, onAction: a, disallowTypeAhead: i, linkBehavior: s = "action", keyboardNavigationBehavior: c = "arrow" } = e;
  !e["aria-label"] && !e["aria-labelledby"] && console.warn("An aria-label or aria-labelledby prop is required for accessibility.");
  let { listProps: f } = dt({
    selectionManager: u.selectionManager,
    collection: u.collection,
    disabledKeys: u.disabledKeys,
    ref: t,
    keyboardDelegate: n,
    layoutDelegate: o,
    isVirtualized: l,
    selectOnFocus: u.selectionManager.selectionBehavior === "replace",
    shouldFocusWrap: e.shouldFocusWrap,
    linkBehavior: s,
    disallowTypeAhead: i,
    autoFocus: e.autoFocus
  }), d = se(e.id);
  J.set(u, {
    id: d,
    onAction: a,
    linkBehavior: s,
    keyboardNavigationBehavior: c
  });
  let p = xt({
    selectionManager: u.selectionManager,
    hasItemActions: !!a
  }), C = ct(t, {
    isDisabled: u.collection.size !== 0
  }), b = N(e, {
    labelable: !0
  }), x = R(
    b,
    {
      role: "grid",
      id: d,
      "aria-multiselectable": u.selectionManager.selectionMode === "multiple" ? "true" : void 0
    },
    // If collection is empty, make sure the grid is tabbable unless there is a child tabbable element.
    u.collection.size === 0 ? {
      tabIndex: C ? -1 : 0
    } : f,
    p
  );
  return l && (x["aria-rowcount"] = u.collection.size, x["aria-colcount"] = 1), mt({}, u), {
    gridProps: x
  };
}
const te = {
  expand: {
    ltr: "ArrowRight",
    rtl: "ArrowLeft"
  },
  collapse: {
    ltr: "ArrowLeft",
    rtl: "ArrowRight"
  }
};
function Ct(e, u, t) {
  var l, n;
  let { node: o, isVirtualized: a, shouldSelectOnPressUp: i } = e, { direction: s } = at(), { onAction: c, linkBehavior: f, keyboardNavigationBehavior: d } = J.get(u), p = Gu(), C = G(null), b = () => {
    var r;
    t.current !== null && (C.current != null && o.key !== C.current || !(!((r = t.current) === null || r === void 0) && r.contains(document.activeElement))) && I(t.current);
  }, x = {}, y = e.hasChildItems, k = u.selectionManager.isLink(o.key);
  if (o != null && "expandedKeys" in u) {
    var D, g, E;
    let r = (D = (g = u.collection).getChildren) === null || D === void 0 ? void 0 : D.call(g, o.key);
    y = y || [
      ...r ?? []
    ].length > 1, c == null && !k && u.selectionManager.selectionMode === "none" && y && (c = () => u.toggleKey(o.key));
    let v = y ? u.expandedKeys.has(o.key) : void 0, P = 1;
    var h;
    if (o.level > 0 && (o == null ? void 0 : o.parentKey) != null) {
      let m = u.collection.getItem(o.parentKey);
      if (m) {
        var A, w;
        let B = (A = (w = u.collection).getChildren) === null || A === void 0 ? void 0 : A.call(w, m.key);
        P = Mu(B).index + 1;
      }
    } else P = ((h = (E = [
      ...u.collection
    ].filter((m) => m.level === 0).at(-1)) === null || E === void 0 ? void 0 : E.index) !== null && h !== void 0 ? h : 0) + 1;
    x = {
      "aria-expanded": v,
      "aria-level": o.level + 1,
      "aria-posinset": (o == null ? void 0 : o.index) + 1,
      "aria-setsize": P
    };
  }
  let { itemProps: S, ...F } = Tu({
    selectionManager: u.selectionManager,
    key: o.key,
    ref: t,
    isVirtualized: a,
    shouldSelectOnPressUp: i,
    onAction: c || !((l = o.props) === null || l === void 0) && l.onAction ? Zu((n = o.props) === null || n === void 0 ? void 0 : n.onAction, c ? () => c(o.key) : void 0) : void 0,
    focus: b,
    linkBehavior: f
  }), K = (r) => {
    if (!r.currentTarget.contains(r.target) || !t.current || !document.activeElement) return;
    let v = ee(t.current);
    if (v.currentNode = document.activeElement, "expandedKeys" in u && document.activeElement === t.current) {
      if (r.key === te.expand[s] && u.selectionManager.focusedKey === o.key && y && !u.expandedKeys.has(o.key)) {
        u.toggleKey(o.key), r.stopPropagation();
        return;
      } else if (r.key === te.collapse[s] && u.selectionManager.focusedKey === o.key && y && u.expandedKeys.has(o.key)) {
        u.toggleKey(o.key), r.stopPropagation();
        return;
      }
    }
    switch (r.key) {
      case "ArrowLeft":
        if (d === "arrow") {
          let m = s === "rtl" ? v.nextNode() : v.previousNode();
          if (m)
            r.preventDefault(), r.stopPropagation(), I(m), T(m, {
              containingElement: M(t.current)
            });
          else if (r.preventDefault(), r.stopPropagation(), s === "rtl")
            I(t.current), T(t.current, {
              containingElement: M(t.current)
            });
          else {
            v.currentNode = t.current;
            let B = le(v);
            B && (I(B), T(B, {
              containingElement: M(t.current)
            }));
          }
        }
        break;
      case "ArrowRight":
        if (d === "arrow") {
          let m = s === "rtl" ? v.previousNode() : v.nextNode();
          if (m)
            r.preventDefault(), r.stopPropagation(), I(m), T(m, {
              containingElement: M(t.current)
            });
          else if (r.preventDefault(), r.stopPropagation(), s === "ltr")
            I(t.current), T(t.current, {
              containingElement: M(t.current)
            });
          else {
            v.currentNode = t.current;
            let B = le(v);
            B && (I(B), T(B, {
              containingElement: M(t.current)
            }));
          }
        }
        break;
      case "ArrowUp":
      case "ArrowDown":
        if (!r.altKey && t.current.contains(r.target)) {
          var P;
          r.stopPropagation(), r.preventDefault(), (P = t.current.parentElement) === null || P === void 0 || P.dispatchEvent(new KeyboardEvent(r.nativeEvent.type, r.nativeEvent));
        }
        break;
      case "Tab":
        if (d === "tab") {
          let m = ee(t.current, {
            tabbable: !0
          });
          m.currentNode = document.activeElement, (r.shiftKey ? m.previousNode() : m.nextNode()) && r.stopPropagation();
        }
    }
  }, Au = (r) => {
    if (C.current = o.key, r.target !== t.current) {
      lt() || u.selectionManager.setFocusedKey(o.key);
      return;
    }
  }, Pu = et(o.props), Iu = F.hasAction ? Pu : {}, Y = R(S, Iu, {
    role: "row",
    onKeyDownCapture: K,
    onFocus: Au,
    // 'aria-label': [(node.textValue || undefined), rowAnnouncement].filter(Boolean).join(', '),
    "aria-label": o.textValue || void 0,
    "aria-selected": u.selectionManager.canSelectItem(o.key) ? u.selectionManager.isSelected(o.key) : void 0,
    "aria-disabled": u.selectionManager.isDisabled(o.key) || void 0,
    "aria-labelledby": p && o.textValue ? `${W(u, o.key)} ${p}` : void 0,
    id: W(u, o.key)
  });
  a && (Y["aria-rowindex"] = o.index + 1);
  let wu = {
    role: "gridcell",
    "aria-colindex": 1
  };
  return {
    rowProps: {
      ...R(Y, x)
    },
    gridCellProps: wu,
    descriptionProps: {
      id: p
    },
    ...F
  };
}
function le(e) {
  let u = null, t = null;
  do
    t = e.lastChild(), t && (u = t);
  while (t);
  return u;
}
function ht(e, u) {
  let { key: t } = e;
  const { checkboxProps: l } = yt(e, u);
  return {
    checkboxProps: {
      ...l,
      "aria-labelledby": `${l.id} ${W(u, t)}`
    }
  };
}
function Dt(e, u, t) {
  let { gridProps: l } = Bt(e, u, t);
  return l.role = "treegrid", {
    gridProps: l
  };
}
var He = {};
He = {
  collapse: "طي",
  expand: "تمديد"
};
var Oe = {};
Oe = {
  collapse: "Свиване",
  expand: "Разширяване"
};
var We = {};
We = {
  collapse: "Sbalit",
  expand: "Roztáhnout"
};
var Ge = {};
Ge = {
  collapse: "Skjul",
  expand: "Udvid"
};
var Ze = {};
Ze = {
  collapse: "Reduzieren",
  expand: "Erweitern"
};
var qe = {};
qe = {
  collapse: "Σύμπτυξη",
  expand: "Ανάπτυξη"
};
var Je = {};
Je = {
  expand: "Expand",
  collapse: "Collapse"
};
var Xe = {};
Xe = {
  collapse: "Contraer",
  expand: "Ampliar"
};
var Ye = {};
Ye = {
  collapse: "Ahenda",
  expand: "Laienda"
};
var Qe = {};
Qe = {
  collapse: "Pienennä",
  expand: "Laajenna"
};
var eu = {};
eu = {
  collapse: "Réduire",
  expand: "Développer"
};
var uu = {};
uu = {
  collapse: "כווץ",
  expand: "הרחב"
};
var tu = {};
tu = {
  collapse: "Sažmi",
  expand: "Proširi"
};
var lu = {};
lu = {
  collapse: "Összecsukás",
  expand: "Kibontás"
};
var nu = {};
nu = {
  collapse: "Comprimi",
  expand: "Espandi"
};
var ou = {};
ou = {
  collapse: "折りたたむ",
  expand: "展開"
};
var au = {};
au = {
  collapse: "접기",
  expand: "펼치기"
};
var su = {};
su = {
  collapse: "Sutraukti",
  expand: "Išskleisti"
};
var iu = {};
iu = {
  collapse: "Sakļaut",
  expand: "Izvērst"
};
var ru = {};
ru = {
  collapse: "Skjul",
  expand: "Utvid"
};
var cu = {};
cu = {
  collapse: "Samenvouwen",
  expand: "Uitvouwen"
};
var du = {};
du = {
  collapse: "Zwiń",
  expand: "Rozwiń"
};
var $u = {};
$u = {
  collapse: "Recolher",
  expand: "Expandir"
};
var pu = {};
pu = {
  collapse: "Colapsar",
  expand: "Expandir"
};
var bu = {};
bu = {
  collapse: "Restrângeți",
  expand: "Extindeți"
};
var mu = {};
mu = {
  collapse: "Свернуть",
  expand: "Развернуть"
};
var fu = {};
fu = {
  collapse: "Zbaliť",
  expand: "Rozbaliť"
};
var xu = {};
xu = {
  collapse: "Strni",
  expand: "Razširi"
};
var vu = {};
vu = {
  collapse: " Skupi",
  expand: "Proširi"
};
var yu = {};
yu = {
  collapse: "Dölj",
  expand: "Expandera"
};
var Bu = {};
Bu = {
  collapse: "Daralt",
  expand: "Genişlet"
};
var Cu = {};
Cu = {
  collapse: "Згорнути",
  expand: "Розгорнути"
};
var hu = {};
hu = {
  collapse: "折叠",
  expand: "扩展"
};
var Du = {};
Du = {
  collapse: "收合",
  expand: "展開"
};
var Eu = {};
Eu = {
  "ar-AE": He,
  "bg-BG": Oe,
  "cs-CZ": We,
  "da-DK": Ge,
  "de-DE": Ze,
  "el-GR": qe,
  "en-US": Je,
  "es-ES": Xe,
  "et-EE": Ye,
  "fi-FI": Qe,
  "fr-FR": eu,
  "he-IL": uu,
  "hr-HR": tu,
  "hu-HU": lu,
  "it-IT": nu,
  "ja-JP": ou,
  "ko-KR": au,
  "lt-LT": su,
  "lv-LV": iu,
  "nb-NO": ru,
  "nl-NL": cu,
  "pl-PL": du,
  "pt-BR": $u,
  "pt-PT": pu,
  "ro-RO": bu,
  "ru-RU": mu,
  "sk-SK": fu,
  "sl-SI": xu,
  "sr-SP": vu,
  "sv-SE": yu,
  "tr-TR": Bu,
  "uk-UA": Cu,
  "zh-CN": hu,
  "zh-TW": Du
};
function Et(e) {
  return e && e.__esModule ? e.default : e;
}
function ku(e, u, t) {
  let { node: l } = e, n = Ct(e, u, t), o = n.rowProps["aria-expanded"] === !0, a = L(Et(Eu), "@react-aria/tree"), i = st({
    "aria-label": o ? a.format("collapse") : a.format("expand"),
    "aria-labelledby": n.rowProps.id
  }), s = {
    onPress: () => {
      n.isDisabled || (u.toggleKey(l.key), u.selectionManager.setFocused(!0), u.selectionManager.setFocusedKey(l.key));
    },
    tabIndex: nt() ? -1 : null,
    "data-react-aria-prevent-focus": !0,
    ...i
  };
  return {
    ...n,
    expandButtonProps: s
  };
}
class kt {
  *[Symbol.iterator]() {
    yield* this.iterable;
  }
  get size() {
    return this.keyMap.size;
  }
  getKeys() {
    return this.keyMap.keys();
  }
  getKeyBefore(u) {
    let t = this.keyMap.get(u);
    var l;
    return t && (l = t.prevKey) !== null && l !== void 0 ? l : null;
  }
  getKeyAfter(u) {
    let t = this.keyMap.get(u);
    var l;
    return t && (l = t.nextKey) !== null && l !== void 0 ? l : null;
  }
  getFirstKey() {
    return this.firstKey;
  }
  getLastKey() {
    return this.lastKey;
  }
  getItem(u) {
    var t;
    return (t = this.keyMap.get(u)) !== null && t !== void 0 ? t : null;
  }
  at(u) {
    const t = [
      ...this.getKeys()
    ];
    return this.getItem(t[u]);
  }
  constructor(u, { expandedKeys: t } = {}) {
    this.keyMap = /* @__PURE__ */ new Map(), this.firstKey = null, this.lastKey = null, this.iterable = u, t = t || /* @__PURE__ */ new Set();
    let l = (i) => {
      if (this.keyMap.set(i.key, i), i.childNodes && (i.type === "section" || t.has(i.key))) for (let s of i.childNodes) l(s);
    };
    for (let i of u) l(i);
    let n = null, o = 0;
    for (let [i, s] of this.keyMap)
      n ? (n.nextKey = i, s.prevKey = n.key) : (this.firstKey = i, s.prevKey = void 0), s.type === "item" && (s.index = o++), n = s, n.nextKey = void 0;
    var a;
    this.lastKey = (a = n == null ? void 0 : n.key) !== null && a !== void 0 ? a : null;
  }
}
function gt(e) {
  let { onExpandedChange: u } = e, [t, l] = re(e.expandedKeys ? new Set(e.expandedKeys) : void 0, e.defaultExpandedKeys ? new Set(e.defaultExpandedKeys) : /* @__PURE__ */ new Set(), u), n = Ru(e), o = Z(() => e.disabledKeys ? new Set(e.disabledKeys) : /* @__PURE__ */ new Set(), [
    e.disabledKeys
  ]), a = ju(e, Yu((s) => new kt(s, {
    expandedKeys: t
  }), [
    t
  ]), null);
  return H(() => {
    n.focusedKey != null && !a.getItem(n.focusedKey) && n.setFocusedKey(null);
  }, [
    a,
    n.focusedKey
  ]), {
    collection: a,
    expandedKeys: t,
    disabledKeys: o,
    toggleKey: (s) => {
      l(At(t, s));
    },
    setExpandedKeys: l,
    selectionManager: new Nu(a, n)
  };
}
function At(e, u) {
  let t = new Set(e);
  return t.has(u) ? t.delete(u) : t.add(u), t;
}
class Pt {
  // TODO: should this collection's getters reflect the flattened structure or the original structure
  // If we respresent the flattened structure, it is easier for the keyboard nav but harder to find all the nodes
  *[Symbol.iterator]() {
    yield* this.flattenedRows;
  }
  get size() {
    return this.flattenedRows.length;
  }
  getKeys() {
    return this.keyMap.keys();
  }
  getItem(u) {
    return this.keyMap.get(u) || null;
  }
  at(u) {
    return this.flattenedRows[u];
  }
  getFirstKey() {
    var u;
    return (u = this.flattenedRows[0]) === null || u === void 0 ? void 0 : u.key;
  }
  getLastKey() {
    var u;
    return (u = this.flattenedRows[this.size - 1]) === null || u === void 0 ? void 0 : u.key;
  }
  getKeyAfter(u) {
    var t;
    let l = this.flattenedRows.findIndex((n) => n.key === u);
    return (t = this.flattenedRows[l + 1]) === null || t === void 0 ? void 0 : t.key;
  }
  getKeyBefore(u) {
    var t;
    let l = this.flattenedRows.findIndex((n) => n.key === u);
    return (t = this.flattenedRows[l - 1]) === null || t === void 0 ? void 0 : t.key;
  }
  // Note that this will return Content nodes in addition to nested TreeItems
  getChildren(u) {
    let t = this.keyMap;
    return {
      *[Symbol.iterator]() {
        let l = t.get(u), n = (l == null ? void 0 : l.firstChildKey) != null ? t.get(l.firstChildKey) : null;
        for (; n; )
          yield n, n = n.nextKey != null ? t.get(n.nextKey) : void 0;
      }
    };
  }
  getTextValue(u) {
    let t = this.getItem(u);
    return t ? t.textValue : "";
  }
  constructor(u) {
    this.keyMap = /* @__PURE__ */ new Map();
    let { collection: t, expandedKeys: l } = u, { flattenedRows: n, keyMap: o } = Ft(t, {
      expandedKeys: l
    });
    this.flattenedRows = n, this.keyMap = o;
  }
}
const It = /* @__PURE__ */ q(null), X = /* @__PURE__ */ q(null), tl = /* @__PURE__ */ Qu(function(u, t) {
  return [u, t] = qu(u, t, It), /* @__PURE__ */ $.createElement(Uu, {
    content: /* @__PURE__ */ $.createElement(_u, u)
  }, (l) => /* @__PURE__ */ $.createElement(wt, {
    props: u,
    collection: l,
    treeRef: t
  }));
});
function wt({ props: e, collection: u, treeRef: t }) {
  let { selectionMode: l = "none", expandedKeys: n, defaultExpandedKeys: o, onExpandedChange: a, disabledBehavior: i = "all" } = e, { CollectionRoot: s, isVirtualized: c, layoutDelegate: f } = V(ae), [d, p] = re(n ? ne(n) : void 0, o ? ne(o) : /* @__PURE__ */ new Set(), a), C = Z(() => new Pt({
    collection: u,
    expandedKeys: d
  }), [
    u,
    d
  ]), b = gt({
    ...e,
    selectionMode: l,
    expandedKeys: d,
    onExpandedChange: p,
    collection: C,
    children: void 0,
    disabledBehavior: i
  }), { gridProps: x } = Dt({
    ...e,
    isVirtualized: c,
    layoutDelegate: f
  }, b, t), { focusProps: y, isFocused: k, isFocusVisible: D } = O(), g = {
    isEmpty: b.collection.size === 0,
    isFocused: k,
    isFocusVisible: D,
    state: b
  }, E = j({
    className: e.className,
    style: e.style,
    defaultClassName: "react-aria-Tree",
    values: g
  }), h = null;
  if (b.collection.size === 0 && e.renderEmptyState) {
    let { isEmpty: A, ...w } = g, S = e.renderEmptyState({
      ...w
    }), F = {
      "aria-level": 1,
      "aria-posinset": 1,
      "aria-setsize": 1
    };
    h = /* @__PURE__ */ $.createElement("div", {
      role: "row",
      style: {
        display: "contents"
      },
      ...F
    }, /* @__PURE__ */ $.createElement("div", {
      role: "gridcell",
      style: {
        display: "contents"
      }
    }, S));
  }
  return /* @__PURE__ */ $.createElement(ut, null, /* @__PURE__ */ $.createElement("div", {
    ...N(e),
    ...E,
    ...R(x, y),
    ref: t,
    slot: e.slot || void 0,
    onScroll: e.onScroll,
    "data-empty": b.collection.size === 0 || void 0,
    "data-focused": k || void 0,
    "data-focus-visible": D || void 0
  }, /* @__PURE__ */ $.createElement(ie, {
    values: [
      [
        X,
        b
      ]
    ]
  }, /* @__PURE__ */ $.createElement(s, {
    collection: b.collection,
    persistedKeys: Ou(b.selectionManager.focusedKey),
    scrollRef: t
  })), h));
}
const St = /* @__PURE__ */ oe("content", function(u) {
  let t = V(gu), l = j({
    children: u.children,
    values: t
  });
  return /* @__PURE__ */ $.createElement(ae.Provider, {
    value: Lu
  }, l.children);
}), gu = /* @__PURE__ */ q(null), ll = /* @__PURE__ */ Vu("item", (e, u, t) => {
  var l;
  let n = V(X);
  u = Ju(u);
  let { rowProps: o, gridCellProps: a, expandButtonProps: i, descriptionProps: s, ...c } = ku({
    node: t
  }, n, u), f = o["aria-expanded"] === !0, d = e.hasChildItems || ((l = [
    ...n.collection.getChildren(t.key)
  ]) === null || l === void 0 ? void 0 : l.length) > 1, p = o["aria-level"] || 1, { hoverProps: C, isHovered: b } = ot({
    isDisabled: !c.allowsSelection && !c.hasAction,
    onHoverStart: e.onHoverStart,
    onHoverChange: e.onHoverChange,
    onHoverEnd: e.onHoverEnd
  }), { isFocusVisible: x, focusProps: y } = O(), { isFocusVisible: k, focusProps: D } = O({
    within: !0
  }), { checkboxProps: g } = ht({
    key: t.key
  }, n), E = n.selectionManager.selectionMode, h = n.selectionManager.selectionBehavior, A = $.useMemo(() => ({
    ...c,
    isHovered: b,
    isFocusVisible: x,
    isExpanded: f,
    hasChildItems: d,
    level: p,
    selectionMode: E,
    selectionBehavior: h,
    isFocusVisibleWithin: k,
    state: n,
    id: t.key
  }), [
    c,
    b,
    x,
    E,
    h,
    f,
    d,
    p,
    k,
    n,
    t.key
  ]), w = j({
    ...e,
    id: void 0,
    children: t.rendered,
    defaultClassName: "react-aria-TreeItem",
    defaultStyle: {
      // @ts-ignore
      "--tree-item-level": p
    },
    values: A
  });
  H(() => {
    t.textValue || console.warn("A `textValue` prop is required for <TreeItem> elements in order to support accessibility features such as type to select.");
  }, [
    t.textValue
  ]);
  let S = G(null);
  H(() => {
    d && !S.current && console.warn("Expandable tree items must contain a expand button so screen reader users can expand/collapse the item.");
  }, []);
  let F = Hu({
    items: n.collection.getChildren(t.key),
    children: (K) => {
      switch (K.type) {
        case "content":
          return K.render(K);
        // Skip item since we don't render the nested rows as children of the parent row, the flattened collection
        // will render them each as siblings instead
        case "loader":
        case "item":
          return /* @__PURE__ */ $.createElement($.Fragment, null);
        default:
          throw new Error("Unsupported element type in TreeRow: " + K.type);
      }
    }
  });
  return /* @__PURE__ */ $.createElement($.Fragment, null, /* @__PURE__ */ $.createElement("div", {
    ...R(N(e), o, y, C, D),
    ...w,
    ref: u,
    // TODO: missing selectionBehavior, hasAction and allowsSelection data attribute equivalents (available in renderProps). Do we want those?
    "data-expanded": d && f || void 0,
    "data-has-child-items": d || void 0,
    "data-level": p,
    "data-selected": c.isSelected || void 0,
    "data-disabled": c.isDisabled || void 0,
    "data-hovered": b || void 0,
    "data-focused": c.isFocused || void 0,
    "data-focus-visible": x || void 0,
    "data-pressed": c.isPressed || void 0,
    "data-selection-mode": n.selectionManager.selectionMode === "none" ? void 0 : n.selectionManager.selectionMode
  }, /* @__PURE__ */ $.createElement("div", {
    ...a,
    style: {
      display: "contents"
    }
  }, /* @__PURE__ */ $.createElement(ie, {
    values: [
      [
        zu,
        {
          slots: {
            selection: g
          }
        }
      ],
      // TODO: support description in the tree row
      // TODO: don't think I need to pass isExpanded to the button here since it can be sourced from the renderProps? Might be worthwhile passing it down?
      [
        Fu,
        {
          slots: {
            [Xu]: {},
            chevron: {
              ...i,
              ref: S
            }
          }
        }
      ],
      [
        gu,
        {
          ...A
        }
      ]
    ]
  }, F))));
});
oe("loader", function(u, t, l) {
  let n = V(X), { rowProps: o } = ku({
    node: l
  }, n, t), a = o["aria-level"] || 1, i = {
    "aria-level": o["aria-level"],
    "aria-posinset": o["aria-posinset"],
    "aria-setsize": o["aria-setsize"]
  }, s = j({
    ...u,
    id: void 0,
    children: l.rendered,
    defaultClassName: "react-aria-TreeLoader",
    values: {
      level: a
    }
  });
  return /* @__PURE__ */ $.createElement($.Fragment, null, /* @__PURE__ */ $.createElement("div", {
    role: "row",
    ref: t,
    ...R(N(u), i),
    ...s,
    "data-level": a
  }, /* @__PURE__ */ $.createElement("div", {
    role: "gridcell",
    "aria-colindex": 1
  }, s.children)));
});
function ne(e) {
  return e ? e === "all" ? "all" : new Set(e) : /* @__PURE__ */ new Set();
}
function Ft(e, u) {
  let { expandedKeys: t = /* @__PURE__ */ new Set() } = u, l = /* @__PURE__ */ new Map(), n = [], o = (a) => {
    if (a.type === "item" || a.type === "loader") {
      let i = a == null ? void 0 : a.parentKey, s = {
        ...a
      };
      i != null ? ([
        ...e.getChildren(i)
      ][0].type !== "item" && (s.index = (a == null ? void 0 : a.index) != null ? (a == null ? void 0 : a.index) - 1 : 0), a.type === "loader" && (s.level = a.level + 1), l.set(s.key, s)) : l.set(a.key, a), (a.level === 0 || i != null && t.has(i) && n.find((c) => c.key === i)) && n.push(l.get(a.key) || a);
    } else a.type !== null && l.set(a.key, a);
    for (let i of e.getChildren(a.key)) o(i);
  };
  for (let a of e) o(a);
  return {
    flattenedRows: n,
    keyMap: l
  };
}
const nl = ({ label: e, children: u, id: t }) => /* @__PURE__ */ z.jsx(St, { children: ({ isDisabled: l, isSelected: n, isHovered: o, isExpanded: a, state: i }) => /* @__PURE__ */ z.jsxs(
  "div",
  {
    id: t.toString(),
    className: _(
      "relative box-border size-full cursor-pointer outline-none",
      "flex items-center py-[10.5px] pl-3.25",
      l && "cursor-not-allowed",
      u ? "pr-14" : "pr-8"
    ),
    children: [
      /* @__PURE__ */ z.jsx(
        "p",
        {
          className: Q(
            "w-fit text-base break-words",
            u ? "max-w-42" : "max-w-49.5",
            l ? "text-klerosUIComponentsSecondaryText" : "text-klerosUIComponentsPrimaryText"
          ),
          children: e
        }
      ),
      /* @__PURE__ */ z.jsxs(
        Ku,
        {
          slot: "chevron",
          className: Q(
            "absolute right-4 cursor-pointer disabled:cursor-not-allowed",
            "flex items-center gap-1"
          ),
          isDisabled: l,
          onPress: (s) => {
            i.selectionManager.setSelectedKeys([t]), s.continuePropagation();
          },
          children: [
            u && (u == null ? void 0 : u.length) > 0 && /* @__PURE__ */ z.jsx(
              "label",
              {
                className: _(
                  "border-klerosUIComponentsStroke ease-ease size-6 rounded-full border transition",
                  "flex items-center justify-center",
                  "text-klerosUIComponentsStroke text-sm",
                  o && "border-klerosUIComponentsPrimaryBlue text-klerosUIComponentsPrimaryBlue cursor-pointer",
                  n && "border-klerosUIComponentsPrimaryBlue text-klerosUIComponentsPrimaryBlue",
                  l && "cursor-not-allowed"
                ),
                children: u.length
              }
            ),
            u && /* @__PURE__ */ z.jsx(
              $t,
              {
                className: _(
                  "ease-ease max-h-4 min-h-3 max-w-4 min-w-3 rotate-180 transition",
                  a && "rotate-0",
                  n ? "fill-klerosUIComponentsPrimaryBlue" : "fill-klerosUIComponentsStroke",
                  o && "fill-klerosUIComponentsPrimaryBlue"
                )
              }
            )
          ]
        }
      )
    ]
  }
) });
export {
  tl as $,
  nl as I,
  ll as a
};
