import { default as React } from 'react';
import { DialogProps, ModalOverlayProps } from 'react-aria-components';
interface ModalProps extends Omit<ModalOverlayProps, "children">, React.RefAttributes<HTMLDivElement> {
    modalOverlayClassname?: ModalOverlayProps["className"];
    children?: DialogProps["children"];
}
declare function Modal({ className, modalOverlayClassname, children, ...props }: Readonly<ModalProps>): React.JSX.Element;
export default Modal;
