import { m as x, n as M, o as m } from "./Collection-CYEl0MHQ.js";
import { useMemo as K, useCallback as w, useRef as S, useEffect as C } from "react";
class $ {
  *[Symbol.iterator]() {
    yield* this.iterable;
  }
  get size() {
    return this.keyMap.size;
  }
  getKeys() {
    return this.keyMap.keys();
  }
  getKeyBefore(l) {
    let e = this.keyMap.get(l);
    var t;
    return e && (t = e.prevKey) !== null && t !== void 0 ? t : null;
  }
  getKeyAfter(l) {
    let e = this.keyMap.get(l);
    var t;
    return e && (t = e.nextKey) !== null && t !== void 0 ? t : null;
  }
  getFirstKey() {
    return this.firstKey;
  }
  getLastKey() {
    return this.lastKey;
  }
  getItem(l) {
    var e;
    return (e = this.keyMap.get(l)) !== null && e !== void 0 ? e : null;
  }
  at(l) {
    const e = [
      ...this.getKeys()
    ];
    return this.getItem(e[l]);
  }
  getChildren(l) {
    let e = this.keyMap.get(l);
    return (e == null ? void 0 : e.childNodes) || [];
  }
  constructor(l) {
    this.keyMap = /* @__PURE__ */ new Map(), this.firstKey = null, this.lastKey = null, this.iterable = l;
    let e = (n) => {
      if (this.keyMap.set(n.key, n), n.childNodes && n.type === "section") for (let o of n.childNodes) e(o);
    };
    for (let n of l) e(n);
    let t = null, y = 0;
    for (let [n, o] of this.keyMap)
      t ? (t.nextKey = n, o.prevKey = t.key) : (this.firstKey = n, o.prevKey = void 0), o.type === "item" && (o.index = y++), t = o, t.nextKey = void 0;
    var d;
    this.lastKey = (d = t == null ? void 0 : t.key) !== null && d !== void 0 ? d : null;
  }
}
function F(i) {
  let { filter: l, layoutDelegate: e } = i, t = x(i), y = K(() => i.disabledKeys ? new Set(i.disabledKeys) : /* @__PURE__ */ new Set(), [
    i.disabledKeys
  ]), d = w((v) => l ? new $(l(v)) : new $(v), [
    l
  ]), n = K(() => ({
    suppressTextValueWarning: i.suppressTextValueWarning
  }), [
    i.suppressTextValueWarning
  ]), o = M(i, d, n), f = K(() => new m(o, t, {
    layoutDelegate: e
  }), [
    o,
    t,
    e
  ]);
  return k(o, f), {
    collection: o,
    disabledKeys: y,
    selectionManager: f
  };
}
function N(i, l) {
  let e = K(() => l ? i.collection.UNSTABLE_filter(l) : i.collection, [
    i.collection,
    l
  ]), t = i.selectionManager.withCollection(e);
  return k(e, t), {
    collection: e,
    selectionManager: t,
    disabledKeys: i.disabledKeys
  };
}
function k(i, l) {
  const e = S(null);
  C(() => {
    if (l.focusedKey != null && !i.getItem(l.focusedKey) && e.current) {
      const u = e.current.getItem(l.focusedKey), h = [
        ...e.current.getKeys()
      ].map((c) => {
        const r = e.current.getItem(c);
        return (r == null ? void 0 : r.type) === "item" ? r : null;
      }).filter((c) => c !== null), s = [
        ...i.getKeys()
      ].map((c) => {
        const r = i.getItem(c);
        return (r == null ? void 0 : r.type) === "item" ? r : null;
      }).filter((c) => c !== null);
      var t, y;
      const b = ((t = h == null ? void 0 : h.length) !== null && t !== void 0 ? t : 0) - ((y = s == null ? void 0 : s.length) !== null && y !== void 0 ? y : 0);
      var d, n, o;
      let a = Math.min(b > 1 ? Math.max(((d = u == null ? void 0 : u.index) !== null && d !== void 0 ? d : 0) - b + 1, 0) : (n = u == null ? void 0 : u.index) !== null && n !== void 0 ? n : 0, ((o = s == null ? void 0 : s.length) !== null && o !== void 0 ? o : 0) - 1), g = null, p = !1;
      for (; a >= 0; ) {
        if (!l.isDisabled(s[a].key)) {
          g = s[a];
          break;
        }
        if (a < s.length - 1 && !p) a++;
        else {
          p = !0;
          var f, v;
          a > ((f = u == null ? void 0 : u.index) !== null && f !== void 0 ? f : 0) && (a = (v = u == null ? void 0 : u.index) !== null && v !== void 0 ? v : 0), a--;
        }
      }
      l.setFocusedKey(g ? g.key : null);
    }
    e.current = i;
  }, [
    i,
    l
  ]);
}
export {
  N as $,
  F as a
};
