import { $ as Y, a as G } from "./textSelection-C7IEcoO2.js";
import le, { useContext as Q, createContext as ue, useState as fe, useRef as ce, useMemo as de, useEffect as pe } from "react";
import { J as ge, r as ve, u as U, E as ye, d as Z, b as Te, A as p, z as c, q as $e, s as L, K as N, p as z, j as F, F as he } from "./useHover-r8IM8mvD.js";
import { j as M, $ as ee, k as Pe } from "./utils-DPfg4HqB.js";
import { flushSync as be } from "react-dom";
const Ee = /* @__PURE__ */ ue({
  isNative: !0,
  open: Ke,
  useHref: (r) => r
});
function te() {
  return Q(Ee);
}
function O(r, n, a = !0) {
  var o, d;
  let { metaKey: v, ctrlKey: y, altKey: h, shiftKey: P } = n;
  ge() && (!((d = window.event) === null || d === void 0 || (o = d.type) === null || o === void 0) && o.startsWith("key")) && r.target === "_blank" && (U() ? v = !0 : y = !0);
  let K = ve() && U() && !ye() ? new KeyboardEvent("keydown", {
    keyIdentifier: "Enter",
    metaKey: v,
    ctrlKey: y,
    altKey: h,
    shiftKey: P
  }) : new MouseEvent("click", {
    metaKey: v,
    ctrlKey: y,
    altKey: h,
    shiftKey: P,
    bubbles: !0,
    cancelable: !0
  });
  O.isOpening = a, Z(r), r.dispatchEvent(K), O.isOpening = !1;
}
O.isOpening = !1;
function me(r, n) {
  if (r instanceof HTMLAnchorElement) n(r);
  else if (r.hasAttribute("data-href")) {
    let a = document.createElement("a");
    a.href = r.getAttribute("data-href"), r.hasAttribute("data-target") && (a.target = r.getAttribute("data-target")), r.hasAttribute("data-rel") && (a.rel = r.getAttribute("data-rel")), r.hasAttribute("data-download") && (a.download = r.getAttribute("data-download")), r.hasAttribute("data-ping") && (a.ping = r.getAttribute("data-ping")), r.hasAttribute("data-referrer-policy") && (a.referrerPolicy = r.getAttribute("data-referrer-policy")), r.appendChild(a), n(a), r.removeChild(a);
  }
}
function Ke(r, n) {
  me(r, (a) => O(a, n));
}
function Fe(r) {
  let n = te();
  var a;
  const o = n.useHref((a = r.href) !== null && a !== void 0 ? a : "");
  return {
    "data-href": r.href ? o : void 0,
    "data-target": r.target,
    "data-rel": r.rel,
    "data-download": r.download,
    "data-ping": r.ping,
    "data-referrer-policy": r.referrerPolicy
  };
}
function Re(r) {
  let n = te();
  var a;
  const o = n.useHref((a = r == null ? void 0 : r.href) !== null && a !== void 0 ? a : "");
  return {
    href: r != null && r.href ? o : void 0,
    target: r == null ? void 0 : r.target,
    rel: r == null ? void 0 : r.rel,
    download: r == null ? void 0 : r.download,
    ping: r == null ? void 0 : r.ping,
    referrerPolicy: r == null ? void 0 : r.referrerPolicy
  };
}
const re = le.createContext({
  register: () => {
  }
});
re.displayName = "PressResponderContext";
function xe(r, n) {
  return n.get ? n.get.call(r) : n.value;
}
function ne(r, n, a) {
  if (!n.has(r)) throw new TypeError("attempted to " + a + " private field on non-instance");
  return n.get(r);
}
function Se(r, n) {
  var a = ne(r, n, "get");
  return xe(r, a);
}
function we(r, n) {
  if (n.has(r))
    throw new TypeError("Cannot initialize the same private elements twice on an object");
}
function ke(r, n, a) {
  we(r, n), n.set(r, a);
}
function _e(r, n, a) {
  if (n.set) n.set.call(r, a);
  else {
    if (!n.writable)
      throw new TypeError("attempted to set read only private field");
    n.value = a;
  }
}
function j(r, n, a) {
  var o = ne(r, n, "set");
  return _e(r, o, a), a;
}
function Oe(r) {
  let n = Q(re);
  if (n) {
    let { register: a, ...o } = n;
    r = ee(o, r), a();
  }
  return he(n, r.ref), r;
}
var D = /* @__PURE__ */ new WeakMap();
class X {
  continuePropagation() {
    j(this, D, !1);
  }
  get shouldStopPropagation() {
    return Se(this, D);
  }
  constructor(n, a, o, d) {
    ke(this, D, {
      writable: !0,
      value: void 0
    }), j(this, D, !0);
    var v;
    let y = (v = d == null ? void 0 : d.target) !== null && v !== void 0 ? v : o.currentTarget;
    const h = y == null ? void 0 : y.getBoundingClientRect();
    let P, K = 0, T, C = null;
    o.clientX != null && o.clientY != null && (T = o.clientX, C = o.clientY), h && (T != null && C != null ? (P = T - h.left, K = C - h.top) : (P = h.width / 2, K = h.height / 2)), this.type = n, this.pointerType = a, this.target = o.currentTarget, this.shiftKey = o.shiftKey, this.metaKey = o.metaKey, this.ctrlKey = o.ctrlKey, this.altKey = o.altKey, this.x = P, this.y = K;
  }
}
const V = Symbol("linkClicked");
function Be(r) {
  let {
    onPress: n,
    onPressChange: a,
    onPressStart: o,
    onPressEnd: d,
    onPressUp: v,
    isDisabled: y,
    isPressed: h,
    preventFocusOnPress: P,
    shouldCancelOnPointerExit: K,
    allowTextSelectionOnPress: T,
    // eslint-disable-next-line @typescript-eslint/no-unused-vars
    ref: C,
    ...ie
  } = Oe(r), [se, B] = fe(!1), S = ce({
    isPressed: !1,
    ignoreEmulatedMouseEvents: !1,
    didFirePressStart: !1,
    isTriggeringEvent: !1,
    activePointerId: null,
    target: null,
    isOverTarget: !1,
    pointerType: null,
    disposables: []
  }), { addGlobalListener: x, removeAllGlobalListeners: I } = Te(), E = M((e, s) => {
    let g = S.current;
    if (y || g.didFirePressStart) return !1;
    let i = !0;
    if (g.isTriggeringEvent = !0, o) {
      let f = new X("pressstart", s, e);
      o(f), i = f.shouldStopPropagation;
    }
    return a && a(!0), g.isTriggeringEvent = !1, g.didFirePressStart = !0, B(!0), i;
  }), b = M((e, s, g = !0) => {
    let i = S.current;
    if (!i.didFirePressStart) return !1;
    i.didFirePressStart = !1, i.isTriggeringEvent = !0;
    let f = !0;
    if (d) {
      let t = new X("pressend", s, e);
      d(t), f = t.shouldStopPropagation;
    }
    if (a && a(!1), B(!1), n && g && !y) {
      let t = new X("press", s, e);
      n(t), f && (f = t.shouldStopPropagation);
    }
    return i.isTriggeringEvent = !1, f;
  }), w = M((e, s) => {
    let g = S.current;
    if (y) return !1;
    if (v) {
      g.isTriggeringEvent = !0;
      let i = new X("pressup", s, e);
      return v(i), g.isTriggeringEvent = !1, i.shouldStopPropagation;
    }
    return !0;
  }), $ = M((e) => {
    let s = S.current;
    if (s.isPressed && s.target) {
      s.didFirePressStart && s.pointerType != null && b(_(s.target, e), s.pointerType, !1), s.isPressed = !1, s.isOverTarget = !1, s.activePointerId = null, s.pointerType = null, I(), T || Y(s.target);
      for (let g of s.disposables) g();
      s.disposables = [];
    }
  }), A = M((e) => {
    K && $(e);
  }), oe = de(() => {
    let e = S.current, s = {
      onKeyDown(i) {
        if (H(i.nativeEvent, i.currentTarget) && p(i.currentTarget, c(i.nativeEvent))) {
          var f;
          J(c(i.nativeEvent), i.key) && i.preventDefault();
          let t = !0;
          if (!e.isPressed && !i.repeat) {
            e.target = i.currentTarget, e.isPressed = !0, e.pointerType = "keyboard", t = E(i, "keyboard");
            let l = i.currentTarget, u = (k) => {
              H(k, l) && !k.repeat && p(l, c(k)) && e.target && w(_(e.target, k), "keyboard");
            };
            x(L(i.currentTarget), "keyup", Pe(u, g), !0);
          }
          t && i.stopPropagation(), i.metaKey && U() && ((f = e.metaKeyEvents) === null || f === void 0 || f.set(i.key, i.nativeEvent));
        } else i.key === "Meta" && (e.metaKeyEvents = /* @__PURE__ */ new Map());
      },
      onClick(i) {
        if (!(i && !p(i.currentTarget, c(i.nativeEvent))) && i && i.button === 0 && !e.isTriggeringEvent && !O.isOpening) {
          let f = !0;
          if (y && i.preventDefault(), !e.ignoreEmulatedMouseEvents && !e.isPressed && (e.pointerType === "virtual" || z(i.nativeEvent))) {
            let t = E(i, "virtual"), l = w(i, "virtual"), u = b(i, "virtual");
            f = t && l && u;
          } else if (e.isPressed && e.pointerType !== "keyboard") {
            let t = e.pointerType || i.nativeEvent.pointerType || "virtual";
            f = b(_(i.currentTarget, i), t, !0), e.isOverTarget = !1, $(i);
          }
          e.ignoreEmulatedMouseEvents = !1, f && i.stopPropagation();
        }
      }
    }, g = (i) => {
      var f;
      if (e.isPressed && e.target && H(i, e.target)) {
        var t;
        J(c(i), i.key) && i.preventDefault();
        let u = c(i);
        b(_(e.target, i), "keyboard", p(e.target, c(i))), I(), i.key !== "Enter" && R(e.target) && p(e.target, u) && !i[V] && (i[V] = !0, O(e.target, i, !1)), e.isPressed = !1, (t = e.metaKeyEvents) === null || t === void 0 || t.delete(i.key);
      } else if (i.key === "Meta" && (!((f = e.metaKeyEvents) === null || f === void 0) && f.size)) {
        var l;
        let u = e.metaKeyEvents;
        e.metaKeyEvents = void 0;
        for (let k of u.values()) (l = e.target) === null || l === void 0 || l.dispatchEvent(new KeyboardEvent("keyup", k));
      }
    };
    if (typeof PointerEvent < "u") {
      s.onPointerDown = (t) => {
        if (t.button !== 0 || !p(t.currentTarget, c(t.nativeEvent))) return;
        if ($e(t.nativeEvent)) {
          e.pointerType = "virtual";
          return;
        }
        e.pointerType = t.pointerType;
        let l = !0;
        if (!e.isPressed) {
          e.isPressed = !0, e.isOverTarget = !0, e.activePointerId = t.pointerId, e.target = t.currentTarget, T || G(e.target), l = E(t, e.pointerType);
          let u = c(t.nativeEvent);
          "releasePointerCapture" in u && u.releasePointerCapture(t.pointerId), x(L(t.currentTarget), "pointerup", i, !1), x(L(t.currentTarget), "pointercancel", f, !1);
        }
        l && t.stopPropagation();
      }, s.onMouseDown = (t) => {
        if (p(t.currentTarget, c(t.nativeEvent)) && t.button === 0) {
          if (P) {
            let l = N(t.target);
            l && e.disposables.push(l);
          }
          t.stopPropagation();
        }
      }, s.onPointerUp = (t) => {
        !p(t.currentTarget, c(t.nativeEvent)) || e.pointerType === "virtual" || t.button === 0 && w(t, e.pointerType || t.pointerType);
      }, s.onPointerEnter = (t) => {
        t.pointerId === e.activePointerId && e.target && !e.isOverTarget && e.pointerType != null && (e.isOverTarget = !0, E(_(e.target, t), e.pointerType));
      }, s.onPointerLeave = (t) => {
        t.pointerId === e.activePointerId && e.target && e.isOverTarget && e.pointerType != null && (e.isOverTarget = !1, b(_(e.target, t), e.pointerType, !1), A(t));
      };
      let i = (t) => {
        if (t.pointerId === e.activePointerId && e.isPressed && t.button === 0 && e.target) {
          if (p(e.target, c(t)) && e.pointerType != null) {
            let l = !1, u = setTimeout(() => {
              e.isPressed && e.target instanceof HTMLElement && (l ? $(t) : (Z(e.target), e.target.click()));
            }, 80);
            x(t.currentTarget, "click", () => l = !0, !0), e.disposables.push(() => clearTimeout(u));
          } else $(t);
          e.isOverTarget = !1;
        }
      }, f = (t) => {
        $(t);
      };
      s.onDragStart = (t) => {
        p(t.currentTarget, c(t.nativeEvent)) && $(t);
      };
    } else {
      s.onMouseDown = (t) => {
        if (t.button !== 0 || !p(t.currentTarget, c(t.nativeEvent))) return;
        if (e.ignoreEmulatedMouseEvents) {
          t.stopPropagation();
          return;
        }
        if (e.isPressed = !0, e.isOverTarget = !0, e.target = t.currentTarget, e.pointerType = z(t.nativeEvent) ? "virtual" : "mouse", be(() => E(t, e.pointerType)) && t.stopPropagation(), P) {
          let u = N(t.target);
          u && e.disposables.push(u);
        }
        x(L(t.currentTarget), "mouseup", i, !1);
      }, s.onMouseEnter = (t) => {
        if (!p(t.currentTarget, c(t.nativeEvent))) return;
        let l = !0;
        e.isPressed && !e.ignoreEmulatedMouseEvents && e.pointerType != null && (e.isOverTarget = !0, l = E(t, e.pointerType)), l && t.stopPropagation();
      }, s.onMouseLeave = (t) => {
        if (!p(t.currentTarget, c(t.nativeEvent))) return;
        let l = !0;
        e.isPressed && !e.ignoreEmulatedMouseEvents && e.pointerType != null && (e.isOverTarget = !1, l = b(t, e.pointerType, !1), A(t)), l && t.stopPropagation();
      }, s.onMouseUp = (t) => {
        p(t.currentTarget, c(t.nativeEvent)) && !e.ignoreEmulatedMouseEvents && t.button === 0 && w(t, e.pointerType || "mouse");
      };
      let i = (t) => {
        if (t.button === 0) {
          if (e.ignoreEmulatedMouseEvents) {
            e.ignoreEmulatedMouseEvents = !1;
            return;
          }
          e.target && e.target.contains(t.target) && e.pointerType != null || $(t), e.isOverTarget = !1;
        }
      };
      s.onTouchStart = (t) => {
        if (!p(t.currentTarget, c(t.nativeEvent))) return;
        let l = Me(t.nativeEvent);
        if (!l) return;
        e.activePointerId = l.identifier, e.ignoreEmulatedMouseEvents = !0, e.isOverTarget = !0, e.isPressed = !0, e.target = t.currentTarget, e.pointerType = "touch", T || G(e.target), E(m(e.target, t), e.pointerType) && t.stopPropagation(), x(F(t.currentTarget), "scroll", f, !0);
      }, s.onTouchMove = (t) => {
        if (!p(t.currentTarget, c(t.nativeEvent))) return;
        if (!e.isPressed) {
          t.stopPropagation();
          return;
        }
        let l = W(t.nativeEvent, e.activePointerId), u = !0;
        l && q(l, t.currentTarget) ? !e.isOverTarget && e.pointerType != null && (e.isOverTarget = !0, u = E(m(e.target, t), e.pointerType)) : e.isOverTarget && e.pointerType != null && (e.isOverTarget = !1, u = b(m(e.target, t), e.pointerType, !1), A(m(e.target, t))), u && t.stopPropagation();
      }, s.onTouchEnd = (t) => {
        if (!p(t.currentTarget, c(t.nativeEvent))) return;
        if (!e.isPressed) {
          t.stopPropagation();
          return;
        }
        let l = W(t.nativeEvent, e.activePointerId), u = !0;
        l && q(l, t.currentTarget) && e.pointerType != null ? (w(m(e.target, t), e.pointerType), u = b(m(e.target, t), e.pointerType)) : e.isOverTarget && e.pointerType != null && (u = b(m(e.target, t), e.pointerType, !1)), u && t.stopPropagation(), e.isPressed = !1, e.activePointerId = null, e.isOverTarget = !1, e.ignoreEmulatedMouseEvents = !0, e.target && !T && Y(e.target), I();
      }, s.onTouchCancel = (t) => {
        p(t.currentTarget, c(t.nativeEvent)) && (t.stopPropagation(), e.isPressed && $(m(e.target, t)));
      };
      let f = (t) => {
        e.isPressed && p(c(t), e.target) && $({
          currentTarget: e.target,
          shiftKey: !1,
          ctrlKey: !1,
          metaKey: !1,
          altKey: !1
        });
      };
      s.onDragStart = (t) => {
        p(t.currentTarget, c(t.nativeEvent)) && $(t);
      };
    }
    return s;
  }, [
    x,
    y,
    P,
    I,
    T,
    $,
    A,
    b,
    E,
    w
  ]);
  return pe(() => {
    let e = S.current;
    return () => {
      var s;
      T || Y((s = e.target) !== null && s !== void 0 ? s : void 0);
      for (let g of e.disposables) g();
      e.disposables = [];
    };
  }, [
    T
  ]), {
    isPressed: h || se,
    pressProps: ee(ie, oe)
  };
}
function R(r) {
  return r.tagName === "A" && r.hasAttribute("href");
}
function H(r, n) {
  const { key: a, code: o } = r, d = n, v = d.getAttribute("role");
  return (a === "Enter" || a === " " || a === "Spacebar" || o === "Space") && !(d instanceof F(d).HTMLInputElement && !ae(d, a) || d instanceof F(d).HTMLTextAreaElement || d.isContentEditable) && // Links should only trigger with Enter key
  !((v === "link" || !v && R(d)) && a !== "Enter");
}
function Me(r) {
  const { targetTouches: n } = r;
  return n.length > 0 ? n[0] : null;
}
function W(r, n) {
  const a = r.changedTouches;
  for (let o = 0; o < a.length; o++) {
    const d = a[o];
    if (d.identifier === n) return d;
  }
  return null;
}
function m(r, n) {
  let a = 0, o = 0;
  return n.targetTouches && n.targetTouches.length === 1 && (a = n.targetTouches[0].clientX, o = n.targetTouches[0].clientY), {
    currentTarget: r,
    shiftKey: n.shiftKey,
    ctrlKey: n.ctrlKey,
    metaKey: n.metaKey,
    altKey: n.altKey,
    clientX: a,
    clientY: o
  };
}
function _(r, n) {
  let a = n.clientX, o = n.clientY;
  return {
    currentTarget: r,
    shiftKey: n.shiftKey,
    ctrlKey: n.ctrlKey,
    metaKey: n.metaKey,
    altKey: n.altKey,
    clientX: a,
    clientY: o
  };
}
function Ce(r) {
  let n = 0, a = 0;
  return r.width !== void 0 ? n = r.width / 2 : r.radiusX !== void 0 && (n = r.radiusX), r.height !== void 0 ? a = r.height / 2 : r.radiusY !== void 0 && (a = r.radiusY), {
    top: r.clientY - a,
    right: r.clientX + n,
    bottom: r.clientY + a,
    left: r.clientX - n
  };
}
function Ie(r, n) {
  return !(r.left > n.right || n.left > r.right || r.top > n.bottom || n.top > r.bottom);
}
function q(r, n) {
  let a = n.getBoundingClientRect(), o = Ce(r);
  return Ie(a, o);
}
function Ae(r) {
  return r instanceof HTMLInputElement ? !1 : r instanceof HTMLButtonElement ? r.type !== "submit" && r.type !== "reset" : !R(r);
}
function J(r, n) {
  return r instanceof HTMLInputElement ? !ae(r, n) : Ae(r);
}
const Le = /* @__PURE__ */ new Set([
  "checkbox",
  "radio",
  "range",
  "color",
  "file",
  "image",
  "button",
  "submit",
  "reset"
]);
function ae(r, n) {
  return r.type === "checkbox" || r.type === "radio" ? n === " " : Le.has(r.type);
}
export {
  Re as $,
  ke as _,
  Be as a,
  te as b,
  O as c,
  Fe as d,
  re as e
};
